    This directory contains the information needed to make ST4GEM run as
an external package within IRAF.  It also contains special libraries used 
within ST4GEM.

Libraries in this directory:
        libgflib.a
        libgilib.a
        libstxtools	ST4GEM special application tools (xtools directory)
        libsynphot	ST4GEM synthetic photometry library (synphot directory)
        libtbtables	ST4GEM table I/O subroutines (tbtables directory)

Other necessary files:
	helpdb.mip	host independent help database for STSDAS
	iraf77.inc	F77VOS interface include file
	mkpkg		mkpkg for this directory
	mkpkg.inc	special mkpkg instructions for STSDAS
	mkpkg.sf.*	operating system specific mkpkg instructions
	root.hd		root help directory for ST4GEM
	rootst4gem.hd	root task entry for ST4GEM help tree
	strip.st4gem	list of files to be deleted when run `mkpkg strip'
	zzsetenv.def	ST4GEM environment variables used
	

The files in this directory implement the gflib library, a front end
to the gilib library. The gilib library allows programmers to
manipulate the internals of geis files. This library allows programs to
call the gilib library for geis files, but also performs the equivalent
function for other image types. Not all functions in gilib are
supported, only those currently used by tasks outside the fitsio and
convert packages. Some functions not in gilib have been added to make
modifying existing tasks to support all image types easier. 

Since the functions in gilib operate on a group, the notion of "group" 
has been extended so that each extension of a fits file is considered
a "group" and all other files, including simple fits files are
considered to have a single group. Fits files with extensions and data
in the primary data unit and fits files with table extensions are not
supported by this library.

Functions in file beginning with gf (rather than gf_) are not part of
the interface and may be changed without notice.  Tasks linking with
this library must also link with the gilib library.

Emulation of functions in gilib library
---------------------------------------

gf_addpar	Add a parameter to the group parameter block
gf_delpar	Delete a parameter from the group parameter block
gf_geis		Return true if image is in STF format
gf_gfind	Return YES if a keyword is from the GPB or extension header
gf_gstfval	Get an integer value stored in the stf descriptor
gf_opengr	Open another group in an already open image
gf_pstfval	Change an integer value in the stf descriptor

Functions not in gilib library
------------------------------

gf_gcount	Count the number of groups in an image
gf_map		Run immap transparently on images of all types
gf_unmap	Close image opend with gf_map

gf_ipstr	Wrappers for the imput* functions which check
gf_iputb	to see if the keyword is added to the extension
gf_iputd	or primary header and set a flag to update the 
gf_iputh	primary header accordingly
gf_iputi
gf_iputl
gf_iputr
gf_iputs

gf_iaddb	Wrappers for the imadd* functions 
gf_iaddd
gf_iaddi
gf_iaddl
gf_iaddr
gf_iadds
gf_iastr

Support functions (not part of interface)
-----------------------------------------

gf_fitsname	Construct a fits file name from its parts
gf_groups	Return YES if image has multiple groups or extensions
gf_hasgroup	Return YES if image contains the specified group
gf_hash		Create a hash table of keywords in the primary header
gf_imtype	Determine image type from name stored in image descriptor


Updating existing code
----------------------

This new version of gflib is meant as a replacement for the old geis
dependent library, which was renamed gilib. All code linking with this 
library must also link with gilib. Tasks which are not instrument
specific and loop over all groups of an geis file or extensions of a
fits file are good candidates for conversion. In order to convert
code, change calls to immap to gf_map and replace calls that read
gcount with calls to gf_gcount. 

The following code shows how to loop over all the groups of a geis file
or extensions of a fits file using the procedures in this library:

	# Transparently open an image of any type
	im = gf_map (Memc[input], READ_ONLY, NULL)

	# Get the number of groups in the image
	ngroup = gf_gcount (im)

	do igroup = 1, ngroup {
	    if (igroup > 1) 
		# Open each group after the first
		call gf_opengr (im, igroup, datamin, datamax, NULL)

	    # Do something with the group here
	}


Interface violations
--------------------

Gf_imtype calls the procedure iki_debug to get the character string
that identifies each of the image types supported by iraf. It parses
the output produced by this procedure, which makes for a double
violation: not only does it call a non-interface function, but it
depends on the output produced by this function to be in a certain
format. My only excuse for doing things this way is there is no other
way of getting the information from the imio library.


Calling sequences of interface functions
----------------------------------------

# GF_ADDPAR -- Add a parameter to the group parameter block

procedure gf_addpar (im, pname, dtype, plen, pval, pcomm)

pointer	im			# i: image descriptor
char	pname[ARB]		# i: parameter name
int	dtype			# i: SPP datatype of parameter
int	plen			# i: length (> 1 if array)
char	pval[ARB]		# i: string encoded initial parameter value
char	pcomm[ARB]		# i: string comment to the new parameter

# GF_DELPAR -- Delete a parameter from the group parameter block

procedure gf_delpar (im, pname)

pointer	im		# i: image descriptor
char	pname[ARB]	# i: parameter name

# GF_GCOUNT -- Count the number of groups in an image

int procedure gf_gcount (im)

pointer	im		# i: image descriptor

# GF_GEIS -- Return true if image is in STF format

bool procedure gf_geis (im)

pointer	im		# i: Image descriptor

# GF_GFIND -- Determine if a keyword is from the GPB or extension header

int procedure gf_gfind (im, keyword)

pointer im              # i: Image descriptor
char    keyword[ARB]    # i: Group parameter keyword name

# GF_GSTFVAL -- Get an integer value stored in the stf descriptor

int procedure gf_gstfval (im, keyword)

pointer	im		# i: image descriptor
char	keyword[ARB]	# i: keyword to retrieve

# GF_MAP -- Run immap transparently on images of all types

pointer procedure gf_map (image, acmode, oldim)

char	image[ARB]	# i: image name
int	acmode		# i: access mode
pointer	oldim		# i: old image descriptor

# GF_OPENGR -- Open another group in an already open image
	    
procedure gf_opengr (im, gn, datamin, datamax, imt)

pointer	im		# u: image descriptor
int	gn		# i: group number to skip to
real	datamin		# u: image minimun value
real	datamax		# u: image maximum value
pointer imt		# i: image template descriptor (NEW_COPY only)

# GF_PSTFVAL -- Change an integer value in the stf descriptor

procedure gf_pstfval (im, keyword, value)

pointer	im		# i: image descriptor
char	keyword[ARB]	# i: keyword name
int	value		# i: keyword value

This file describes the files in the synphot library intended as the
external interface. These files are guaranteed to remain as part of
the library through all versions and not to change their calling
sequence. THe interface can be divided into four different parts: high
middle and low interaces to the library, along with some auxiliary
routines that can be used with any level. Several different of the
interface levels exist because different users of the library have
different purposes and for historical reasons. The pipeline
procedures, for example use the low level interface because they have
no need for a general expression evaluator and they were developed
before the expression evaluator was written.

The high level interface to synphot is backwards compatible with the
old version of the synphot library. The routines, compband and
compspec, are subroutine callable versions of the tasks calcband and
calcspec. These procedures should be used when one needs to compute a
single throughput (passband) or spectrum from a synphot
expression. The calling sequences are:

# COMPBAND -- Passband expression evaluator

procedure compband (command, iw, graphtab, comptab, nwave, wave, band)

char	command[ARB]	# i: string containing expression to evaluate
int	iw		# i: position in string where expression starts
char	graphtab[ARB]	# i: graph table name
char	comptab[ARB]	# i: component lookup table name
int	nwave		# i: number of wavelengths
pointer	wave		# u: wavelength array
pointer	band		# o: passband array, calling subroutine must free

# COMPSPEC -- Spectrum expression evaluator

procedure compspec (command, iw, graphtab, comptab, nwave, wave, spec, form)

char	command[ARB]	# i: string containing expression to evaluate
int	iw		# i: position in string where expression starts
char	graphtab[ARB]	# i: graph table name
char	comptab[ARB]	# i: component lookup table name
int	nwave		# i: number of wavelengths
pointer	wave		# u: wavelength array
pointer	spec		# o: spectrum array, calling array must free
char	form[ARB]	# o: form (units) of spectrum

The argument iw will probably always be 1. It is included for
backwards compatibility with the old version of synphot. The
wavelength array must be allocated in the calling procedure. These
tasks have the capability of computing a default wavelength set
internally. This is flagged by setting the first wavelength in the
wavelength array to INDEFR. The form argument is an output and not an
input parameter. Its value will always be the string "photlam" as all
synphot calculations are done in units of photlam internally. It is
included for backwards compatibility with the old version of
synphot. The spectrum can be converted to another form with procedure
phottoany, described below.

The middle layer interface breaks out some of the functionality
encased in the compband and compspec procedures for the sake of
greater efficiency. I think it also has a cleaner interface than the
high level procedures. These procedures, along with the auxiliary
procedures described later,  are the ones called by the synphot
package. They are to be preferred over the high level interface when
one needs to evaluate multiple synphot expressions in a task.

The synphot library increases its efficiency by caching table
descriptors. That is, once tables are opened they remain open for the
length of the task. The cache is created by procedure inisyntab and
destroyed by procedure clssyntab. When using the middle level
interface, all calls to synphot library procedures should be bracketed
by calls to inisyntab and clssyntab. The calling sequences are:

# INISYNTAB -- Initialize persistent variables used by opnsyntab

procedure inisyntab ()

# CLSSYNTAB -- Close cached tables

procedure clssyntab ()

Neither procedure takes any arguments.

The heart of synphot is the expression evaluator.  The expression
evaluator allows the user to pass a string containg a synphot
expression as input and receive a spectrum or bandpass as output. The
expression evaluator is broken into two parts. The first procedure,
syncompile, compiles the expression into pseudocode and the second
procedure, syncalc, evaluates the pseudocode. Breaking the procedures
apart allows the same expression to be evaluated repeatedly more
efficiently than a single procedure would.  There is also a procedure,
calcrange, which uses the pseudocode to compute a wavelength range
which covers the spectrum or throughput.  The calling sequences are:

# SYNCOMPILE -- Compile an synphot expression into psedocode instructions

procedure syncompile (expr, pcode, maxcode)

char	expr[ARB]	# i: Expression to be parsed
int	pcode[ARB]	# o: Array of pseudocode instructions
int	maxcode		# i: Maximum length of pseudocode array

# SYNCALC -- Calculate the result of a synthetic photometry expression

procedure syncalc (pcode, maxcode, getvar, nwave, wave,
		   graphtab, comptab, output, units)

int	pcode[ARB]	# i: pseudocode used by calculator
int	maxcode		# i: maximum length of pseudocode
pointer	getvar		# i: pointer to subroutine to fetch variable values
int     nwave           # i: length of wavelength and output arrays
real    wave[ARB]       # i: wavelengths at which output is computed
char    graphtab[ARB]   # i: graph table name
char    comptab[ARB]    # i: component lookup table name
real	output[ARB]	# o: result of calculation
int	units		# o: power of FLAM (spectrum = 1, throughput = 0)

# CALCRANGE -- Calculate wavelength range appropriate for expression

procedure calcrange (pcode, maxcode, graphtab, comptab, minwave, maxwave)

int	pcode[ARB]	# i: pseudocode used by calculator
int	maxcode		# i: maximum length of pseudocode
char    graphtab[ARB]   # i: graph table name
char    comptab[ARB]    # i: component lookup table name
real	minwave		# o: short end of wavelength range
real	maxwave		# o: long end of wavelength range

The argument getvar is a pointer to a procedure which returns a
variable value given its number. The synphot expression can contain
variables of the form $0 through $9 and the number is passed to this
procedure. If you do not need to support variables, set getvar to NULL
and any expression containing a variable will return a runtime error.
The routine getsynvar is an example of a getvar procedure. It is not
part of the synphot interface.

# GETSYNVAR -- Get the value of a variable for a synphot expression

procedure getsynvar (ivar, value)

int     ivar            # i: variable number
real    value           # o: variable value

The low level interface to synphot was originally written for the
calibration pipeline tasks. There are several variations on the same
theme as each of the original authors of the pipeline tasks wanted a
slightly different interface.  They do not use the synphot expression
evaluator and only compute combind throughputs (passbands). There are
Fortran and SPP versions of these procedures, as some calibration
pipeines are written in Fortran and others in SPP. The SPP versions
end in the letter x. The calling seqeunces are identical except that
the Fortran versions use Fortran character strings and the SPP version
use SPP character strings.

The first two procedures are getphotx and gtphot. The routines
calculate the four photometric quantities that the calxxx tasks write
into the image header. These are, in order, the inverse sensitivity
(PHOTFLAM), the photometric zero point (PHOTZPT), the pivot wavelength
(PHOTPLAM), and the rms bandwidth (PHOTBW). The calling sequences are:

# GETPHOTX -- Get the photometric parameters for an instrument mode

procedure getphotx (mode, graphtab, comptab, path, mxpath, phot)

char	mode[ARB]	# i: instrument mode
char	graphtab[ARB]	# i: graph table name
char	comptab[ARB]	# i: component lookup table name
char	path[ARB]	# o: list of component throughput tables
int	mxpath		# i: maximum length of path string
real	phot[4]		# o: photometric parameters

The next two are getbandx and gtband, procedures that calculate the
grand throughput for an instrument mode and its associated error. The
procedures also determine the wavelength set that the throughput and
error are computed at and output this as well.

# GETBANDX -- Calculate the wavelength and passband for an instrument mode

procedure getbandx (mode, graphtab, comptab, logspace, nwave, 
		    wave, thruput, thruerr)

char	mode[ARB]	# i: instrument mode
char	graphtab[ARB]	# i: graph table name
char	comptab[ARB]	# i: component lookup table name
bool	logspace	# i: use log spacing for wavelengths?
int	nwave		# i: number of wavelengths
real	wave[ARB]	# o: wavelength array
real	thruput[ARB]	# o: grand throughput
real	thruerr[ARB]	# o: throughput error

Procedures evalbandx and evlbnd should be used instead of getbandx and
gtband if you know the wavelengths you want the throughput and
throughput error calculated at. The dufference is that they wavelength
array is an input for evalbandx and an output for getbandx.

# EVALBANDX -- Calculate the passband for all components in the instrument path

procedure evalbandx (mode, nwave, wave, graphtab, comptab, thruput, thruerr)

char	mode[ARB]	# i: instrument mode
int	nwave		# i: length of wavelength and output arrays
real	wave[ARB]	# i: wavelengths at which output is computed
char	graphtab[ARB]	# i: graph table name
char	comptab[ARB]	# i: component lookup table name
real	thruput[ARB]	# o: grand throughput
real	thruerr[ARB]	# o: grand throughput error

The four photometric quantities produced by getphotx can be coumputed
form the output of getbandx or evalbandx by calling phopar. The same
procedure is callable from both Fortran and SPP, as there are no
character strings in the argument list.

# PHOPAR -- Calculate the four photometric parameters for HST

procedure phopar (nwave, wave, thruput, phot)

int	nwave		# i: number of wavelengths
real	wave[ARB]	# i: wavelength array
real	thruput[ARB]	# i: throughput array
real	phot[4]		# o: photometric parameters

In addition to the main interface routines, which calculate the
spectrum or throughput for an expression or observation mode, there
are a number of auxiliary routines which can be called outside the
package. These perform units conversion and compute functions of a
spectrum or throughput. Internally in synphot, all calculations are
done in units of angstroms and photlam. Procedures anytoang and
angtoany convert wavelength units to and from angstroms
respectively. Procedures anytophot and phottoany convert flux to and
from units of photlam, respectively. Their calling sequences are:

# ANYTOANG -- Convert wavelength units to angstroms

int procedure anytoang (units, wave, nwave)

char	units[ARB]	# i: wavelength units
real	wave[ARB]	# u: wavelength array
int	nwave		# i: number of wavelengths

# ANGTOANY -- Convert wavelength units from angstroms

int procedure angtoany (units, wave, nwave)

char	units[ARB]	# i: wavelength units
real	wave[ARB]	# u: wavelength array
int	nwave		# i: number of wavelengths

# ANYTOPHOT -- Convert flux units to photlam (photons cm-2 s-1 A-1)

int procedure anytophot (units, nwave, wave, flux)

char	units[ARB]	# i: input flux units
int	nwave		# i: length of wavelength and flux arrays
real	wave[ARB]	# i: wavelengths, in angstroms
real	flux[ARB]	# u: flux

# PHOTTOANY -- Convert flux units from photlam (photons cm-2 s-1 A-1)

int procedure phottoany (units, nwave, wave, flux)

char	units[ARB]	# i: input flux units
int	nwave		# i: length of wavelength and flux arrays
real	wave[ARB]	# i: wavelengths, in angstroms
real	flux[ARB]	# u: flux

Several procedures are available to compute integrated quantities fof
a passband. These are avglam and pivlam, which compute the average
wavelength of a passband, rmslam and fwhmlam, which compute measures
of the passband width, and flam, which computes the stimulus in units
of flam needed to produce a unit response. These quantities are
defined by the formulas below. In these formulas lam is the
wavelength, dlam it differential, and P(lam) the passband, which is a
function of wavealnegth.

avglam = Int (lam P(lam) dlam) / Int (P(lam) dlam)
pivlam = sqrt( INT(lam * P(lam) * dlam) / INT(P(lam) * dlam / lam) )

rmslam^2 = barlam^2 <[ln{lam/barlam}]^2> ,
	where barlam is the bar wavelength, defined by 
	Schneider, Gunn and Hoessel ( 1983 ApJ 264,337 ) as
        barlam = exp{<ln{lam}>} ,
  	and < > denotes an average over the passband in ln{lam}
 	<X{lam}> = ( Int P{lam} X{lam} dlam/lam ) / ( Int P{lam} dlam/lam ) .
fwhmlam = sqrt (8 * log(2)) * rmslam

funit = hc / [ A * INT(P(lam) * lam * dlam) ]

The calling sequence for these routines are;

# AVGLAM -- Compute the average wavelength of a passband

real procedure avglam (nwave, wave, thruput)

int	nwave		# i: number of wavelengths
real	wave[ARB]	# i: wavelength array
real	thruput[ARB]	# i: throughput array

# PIVLAM -- Compute the pivot wavelength of a passband

real procedure pivlam (nwave, wave, thruput)

int	nwave		# i: number of wavelengths
real	wave[ARB]	# i: wavelength array
real	thruput[ARB]	# i: throughput array

# RMSLAM -- Compute the rms bandwidth of a passband

real procedure rmslam (nwave, wave, thruput)

int	nwave		# i: number of wavelengths
real	wave[ARB]	# i: wavelength array
real	thruput[ARB]	# i: throughput array

# FWHMLAM -- Compute the full width half maximum wavelength

real procedure fwhmlam (nwave, wave, thruput)

int	nwave		# i: number of wavelengths
real	wave[ARB]	# i: wavelength array
real	thruput[ARB]	# i: throughput array

# FUNIT -- Compute the stimulus needed to produce a unit response

real procedure funit (area, nwave, wave, thruput)

real	area		# i: telescope area
int	nwave		# i: number of wavelengths
real	wave[ARB]	# i: wavelength array
real	thruput[ARB]	# i: throughput array

Three other auxiliary procedures return the spectrum of vega, stored
in a table in the synphot library or return a list of throughput
tables used to compute the total throughput for a specified
observation mode. They are named getvega, graffiles, and listpath,
repectively. The distinction between graffiles and listpath is that
graffiles returns the filenames as an array of strings, while listpath
returns the filenames as a single concatenated string. Listpath calls
graffiles internally and can be used to produce a history record for
tasks using the synphot library. The subroutine arguments are:

# GETVEGA -- Read a spectrum of Vega, sampled on the wavelength set

procedure getvega (nwave, wave, spec)

int     nwave           # i: length of wavelength and spectrum arrays
real    wave[ARB]       # i: wavelengths at which spectrum is computed
real	spec[ARB]	# o: spectrum flux

# GRAFFILES -- Return an array of component throughput table names

procedure graffiles (mode, graphtab, comptab, maxname, maxthru, nthru, thruput)

char	mode[ARB]			# i: instrument mode
char	graphtab[ARB]			# i: graph table name
char	comptab[ARB]			# i: component lookup table name
int	maxname				# i: max length of thruput table name
int	maxthru				# i: max number of throughput tables
int	nthru				# o: actual number of throughput tables
char	thruput[maxname,maxthru]	# o: throughput table names

# LISTPATH -- Create list of component throughput tables

procedure listpath (mode, graphtab, comptab, path, mxpath)

char	mode[ARB]	# i: instrument mode
char	graphtab[ARB]	# i: graph table name
char	comptab[ARB]	# i: component lookup table name
char	path[ARB]	# o: list of component throughput tables
int	mxpath		# i: maximum length of path string

These two procedures complete the list of auxiliary procedures in the
synphot library, although it is possible that some of the procedures
in the synphot package might be moved to this library if there were a
more general need for them.

These directories contain tasks for working with tables.  The various
subdirectories and the tasks that they contain are as follows:

copyone		keypar, keytab, parkey, partab, tabkey, tabpar
doc		help files
gtedit		gtedit
keyselect	keyselect
lib		subroutines used by more than one task
tcalc		tcalc
tchcol		tchcol
tchsize		tchsize
tcopy		tcopy, tdelete
tcreate		tcreate
tdiffer		tdiffer
tedit		tedit, tread
texpand		texpand
thedit		thedit, thselect
tinfo		tinfo, tlcol
tintegrate	tintegrate
tjoin		tjoin
tlinear		tlinear 
tmerge		tmerge 
tprint		tdump, tprint
tproduct	tproduct
tproject	tproject
tquery		tquery
tselect		tselect
tsort		tsort
tstat		thistogram, tstat
tunits		tunits
tupar		tupar

This directory contains the source for the Fortran-callable SDAS table I/O
routines.  All procedure names begin with "ut".  The next letter gives some
idea of the kind of object the procedure deals with (t - table in general,
r - row, c - column, p - parameter, h - header parameter).

The doc subdirectory contains further information in the following files:

UTTABLES.DOC	a description of each routine and a simple example program
CALLS.DOC	a list of routines and their calling sequences
USERPAR.DOC	characteristics of "header" parameters (i.e. user parameters)
UTPPTI.DOC	a note about using utppti

GILIB

	The GILIB (Group File Library) was implemented to improve the 
handling of GEIS files with more than one group. Performance has been
measured between opening each group using 'immap' and using 'giopengr'
to be 25 times faster when using the latter (on a VAX 8600 or 8800).

	An example on how an application might read a multigroup file
is as follows:

	im = immap ("my_geis.hhh",READ_ONLY, 0)
	# 
	# Get the number of groups in the image
	#
	ngroups = gi_gstfval (im, "GCOUNT")

	# Now loop through the groups
	#

	do ng = 1, ngroups {

	   # Open next group of the multigroup file
	   #

	   call gi_opengr (im, gn, datamin, datamax, 0)

	   # Filter the data
	   #
	   call myfilter(..)

	}
	
	#Finish
	#
	call imunmap(im)



	The main idea of the gilib is to have at the application level the
STF structure defined in imio/iki/stf interface; the program ask directly
what is the value of a particular stf structure member without using the 
imio/db utilities.

	A summary of the present GILIB is as follows:



===========================================================================
gi_addpar.x/

# GI_ADDPAR -- Add a parameter in FITS format and add it to the FITS format
# IMIO user area; initialize the entry for the parameter in the GPB descriptor
# as well.

procedure gi_addpar (im, pname, dtype, plen, pval, pcomm)

pointer	im			#I image descriptor
char	pname[ARB]		#I parameter name
int	dtype			#I SPP datatype of parameter
int	plen			#I length (> 1 if array)
char	pval[ARB]		#I string encoded initial parameter value
char	pcomm[ARB]		#I string comment to the new parameter

===========================================================================
gi_delpar.x/

# GI_DELPAR -- delete a group parameter from the STF structure. Also delete
#              the entry from the IMIO user area.
#	       WARNING: Deleting a TY_SHORT parameter might cause a 
#		        memory alignment abort. (bus error more likely)

procedure gi_delpar (im, pname)

pointer	im			#I image descriptor
char	pname[ARB]		#I parameter name


===========================================================================
gi_cpdgpb.x/


# GI_CPDGPB -- Procedure to copy the IM_USERAREA from the input image 
#             given its descriptor 'im', to the output area in 'om'.
#	      It copies all the keywords except the gpb ones;
#	      the output image is open mode NEW_IMAGE, so it has a 
#	      default set of keyword for the gpb.


procedure gi_cpdgpb (im, om)

pointer im	# input image descriptor
pointer om	# output image descriptor


===========================================================================
gi_crgpb.x/

# GI_CRGPB  -- Procedure to extract values from table columns
# convert them to binary values into character buffer; this buffer will
# eventually be written to the end of the data portion as a gpb.
# No provision is made to detect undefined values in the character
# string.

procedure gi_crgpb (im, buf, tbcol, group)

pointer im
char	buf[BIGN]	# i: input string buffer
int	tbcol[BIGN]	# i: table column starting positions.
int	group		# i: current group number

===========================================================================
gi_gcomm.x/

define  MAXP	32000
# GI_GCOMM -- Procedure to get comment from table user parameters
# store in the array 'buf', which has keyword and a text after the
# 9 character position.

procedure gi_gcomm (im, npar, buf)

pointer	im		# Image descriptor
int	npar		# Number of parameters in buffer
char    buf[FITS_RECLEN,MAXP]	# Has the table user parameters.


===========================================================================
gi_giind.x/

# GI_GIIND -- Find the index of a group parameter keyword
#
# This procedure returns the index of a keyword in the group parameter block.
# If the keyword is not a group parameter, the procedure returns zero.
#
# B.Simon	24-Apr-90	Original

int procedure gi_giind (im, keyword)

pointer im		# i: Image descriptor
char	keyword[ARB] 	# i: Group parameter keyword name


===========================================================================
gi_ggpv.x/

# GI_GGPV -- Procedure to get a group parameter value on a
# string buffer.

procedure gi_ggpv (im, pn, buff)

pointer im		# image descriptor
int	pn		# group parameter number 
char	buff[SZ_LINE] 	# Buffer with the gpv in string form


===========================================================================
gi_gstfval.x/

# GI_GSTFVAL -- Get an stf descriptor value

int procedure gi_gstfval (im, what)

pointer	im	# image descriptor
char	what[SZ_DATATYPE]

===========================================================================
gi_pstfval.x/

# GI_PSTFVAL -- Change the value of an stf descriptor

procedure gi_pstfval (im, what, value)

pointer	im	# image descriptor
char	what[SZ_DATATYPE]
int	value


===========================================================================
gi_mgtoxdim.x

# GI_MGTOXDIM -- Convert a multigroup image to one group image.  Use sequential
# routines to permit copying images of any dimension.  Perform pixel i/o in 
# the datatype of the image, to avoid unnecessary type conversion.

procedure gi_mgtoxdim (image1, image2, verbose)

char	image1[SZ_FNAME]		# Input image
char	image2[SZ_FNAME]		# Output image
bool	verbose


===========================================================================
gi_pdes.x/

define  SZ_KEYWORD  8
# GI_PDES -- Procedure to setup the stf parameter descriptor PDES
# with parameter name, datatype and parameter number.

procedure gi_pdes (im, pname, dtype, plen, pno)

pointer	im		# Image descriptor
char    pname[SZ_KEYWORD]	# Parameter name
int	dtype		# Parameter value datatype
int	plen		# value len
int	pno		# Parameter number.


===========================================================================
gi_realloc.x/

# GI_REALLOC -- Procedure to reallocate space to keep the necessary
# stf parameter descrptor in memory.

procedure gi_realloc (im)

pointer	im		# Image descriptor


===========================================================================
gi_reset.x/

# GI_RESET -- Procedure to reset some of the STF descriptor values
# to be able to create an multigroup image with a gpb but not
# writing the latter until all the pixels are in first.

procedure gi_reset (im)

pointer im	# Image descriptor


===========================================================================
gi_rgpbi3e.x/

# GI_RGPB_I3E -- A take from stf_rgpb to read gpb values from an image
# residing in a remote UNIX node. Each value is read and converted to vms
# floating point representation or to vms integer.
# Nelson Zarate Aug 1989
# Read the group data block into the first few cards of the user
# area of the IMIO image header.  The GPB is stored as a binary data structure
# in the STF pixfile.  The values of the standard GPB parameters DATAMIN and
# DATAMAX are returned as output arguments.
#

procedure gi_rgpb_i3e (pfd, im, datamin, datamax)

int	pfd			# Pixel file descriptor
pointer	im			# IMIO image descriptor
real	datamin, datamax	# min,max pixel values from GPB


===========================================================================
gi_rheader.x/

# GI_RHEADER -- Read the STF format image header for a single group into the
# IMIO descriptor.  The standard fields are processed into the fields of the
# descriptor.  The GPB binary parameters are encoded as FITS cards and placed
# in the IMIO user area, followed by all extra cards in the FITS format STF
# group header.  Note that no distinction is made between the common FITS
# keywords and the GPB group parameters at the IMIO level and above.

procedure gi_rheader (fd, im)

int	fd		# input file descriptor
pointer	im		# image descriptor


===========================================================================
gi_update.x/

# GI_UPDATE -- Procedure to update the STF descriptor before writing the
# user area to the image header.

procedure gi_update (im)

pointer im


===========================================================================
gi_wgpbi3e.x/

# GI_WGPB_I3E -- A take from stf_wgpb to write the gpb values into
# a pixel file in ieee floating point format for the input
# vms floating point number or to UNIX integer order for the input
# vms integer numbers.
# Nelson Zarate Aug. 1989
# STF_WGPB -- Write the group parameter block data back into the pixel file.
# The GPB is described by a structure member list in the STF descriptor.
# The values of the GPB parameters are encoded as FITS cards in the user
# area of the IMIO descriptor.
#

procedure gi_wgpb_i3e (im, fd, group)

pointer	im			# IMIO image descriptor
pointer fd			# output file descriptor
int	group			# group to be accessed


===========================================================================
gixdimtomg.x

# GI_XDIMTOMG -- Convert an image with an extra dimension for the groups and an 
# attach table with gpb values, into a true sdas/geis multigroup file.

procedure gi_xdimtomg (image1, image2, verbose)

char	image1[SZ_FNAME]		# Input image
char	image2[SZ_FNAME]		# Output image
bool	verbose


===========================================================================
giopen_table.x/

# GIOPN_TABLE -- Procedure to open a table and define the columns
# with the group parameter information from the input geis image
# descriptor. 

procedure giopn_table (tname, im, tp, colptr)

char	tname[SZ_FNAME]		# i: Table name
pointer	im			# i: image descriptor (stf format)
pointer	tp			# o: Table descriptor
int	colptr[ARB]			# o: pointer to each column


===========================================================================
giopengr.x/

# GIOPENGR --  Procedure to skip onto the next group of a geis image
#	       already open. The group parameter block information
#	       is in memory for the previous group and it will be
#	       necessary only to write the gpb to the image (if the
#	       access mode is other than READ_ONLY) pixel file.
#	       If access is NEW_IMAGE we need to skip only after 
#	       the gpb has been written back to the file.

procedure gi_opengr (im, gn, datamin, datamax, imt)

pointer	im		# i: image descriptor
int	gn		# i: group number to skip to
real	datamin		# i,o: image minimun value
real	datamax		# i,o: image maximum value
pointer imt		# i: image template descriptor (NEW_COPY only)


===========================================================================
gird_gpb.x/

# GIRD_GPB -- Procedure to read gpb values from the input table columns.
# The resulting values then replace those in the imuserarea for the 
# current group number


procedure gird_gpb (tp, gn, im)

pointer	tp		# i: table descriptor
int	gn		# i: group number, or table line number
pointer	im		# i: output image descriptor


===========================================================================
gistf_setup.x/

# GISTFDES_SETUP -- Procedure to setup the stf group parameter
# descriptors from the table column information.

procedure gistfdes_setup (tp, stf, im)

pointer	tp			# i: Input table descriptor
pointer	stf			# i: STF descriptor
pointer im			# i: image descriptor

==============================
gi.h/    
	This include file should be a copy of the actual stf.h file
	in imio/iki/stf

This directory contains the "master" version of the standard, two channel
version of PLUCY (V0.65) as well as the stable ACOADD code (V1.4). 

These were updated in July 1995 to correct bugs and it is
strongly recommended that the new versions be obtained and implemented.

The files compile_acoadd and compile_plucy contain templates for 
building these application to run under IRAF. These files should be
edited to give the local locations for the STSDAS V77/VOS library.
Once this is done they may simply be executed to compile and link.

Please let me know any problems or suggestions you may have.

Richard Hook, July 1995 (e-mail: rhook@eso.org)

# These routines are part of the FITSIO library and are designed to run in
# the IRAF/SPP environment.
#------------------------------------------------------------------------------
#   This software was prepared by High Energy Astrophysics Science Archive
#   Research Center (HEASARC) at the NASA Goddard Space Flight Center. Users
#   shall not, without prior written permission of the U.S. Government,
#   establish a claim to statutory copyright.  The Government and others acting
#   on its behalf shall have a royalty-free, non-exclusive, irrevocable,
#   worldwide license for Government purposes to publish, distribute,
#   translate, copy, exhibit, and perform such material.
#------------------------------------------------------------------------------

*****     This is SPECFIT Version 8.0 installed 6/27/95.     *****

SPECFIT was developed by Gerard Kriss with funding provided by NASA to the
Hopkins Ultraviolet Telescope project.  Please provide appropriate
acknowledgment for the use of this code, and please do not distribute to
additional sites without first notifying the author.  A good reference is

``Fitting Models to UV and Optical Spectral Data: Using SPECFIT in IRAF",
G. A. Kriss 1994, in ``Astronomical Data Analysis Software and Systems III",
A.S.P. Conf. Series, Vol. 61, ed. D. R. Crabtree, R. J. Hanisch,
and J. Barnes, (Astronomical Society of the Pacific: San Francisco), p. 437.

SPECFIT and all associated subroutines are provided "as is" with no associated
warranties, express or implied.  The code is not asserted to be free of errors,
and the user assumes all risk.  The author and Johns Hopkins University disclaim
all liability for direct, incidental, or consequential damages resulting from
the use of this code or any portion thereof.

--------------------------------------------------------------------------------
Changes to Version 8.0
	*  Read the file NewinSpecfit8 for a list of all the new features in
	   specfit.  This include an improved minimization routine, improved
	   functionality in the interactive mode, two new specfit tasks, and
	   several new component types - to name a few.

Installation
	* Install all three specfit tasks - specfit, dbcheck, dbcreate.  All 
	  three are defined in the executable file created by compiling 
	  specfit (xx_specfit.e).  A typical task installation looks like

		task specfit dbcheck dbcreate = specfit$xx_specfit.e

	  where the environment variable "specfit" has been previously
	  defined to point to the specfit code directory, e.g.

		set specfit="/home/perseus/gak/specfit8/"

	* Global definitions are contained in "specfit.h".  Make changes to
	  array sizes here if necessary.
	* the "mkpkg" file may need to be tailored to your specific site.
	  See the IRAF manuals for appropriate instructions and examples.
	* For installation of the three "help" files, see instructions 
	  for the IRAF command "mkhelpdb"
	* Before running specfit make sure to look at the parameter file 
	  specfit.par.  Make sure that the variable key_file which 
	  describes the location of the specfit.key file is defined correctly.

Adding additional fitting functions of your own

	This entails modifications to several routines, but is not complex.
	The files involved are

	fspec.x	- add your new procedure here near the bottom of the file
		- declare the procedure in "procedure cspec"
		- add variables as necessary to cspec
		- add a new case statement in cspec

	sfinitcomp.x - add the name of the new component and its number of
		parameters to the initializations here.

	specfit.h - increase the value of "NKEYS" by one

	Optional:  look at sfaddcomp.x and dbcreate.x to see if you would like
		to add prompts for your new components to these files.  Both 
		files contain more information in them as commented text.

	Re-compile with mkpkg.

Questions or problems, please contact

	Dr. Gerard A. Kriss
	Department of Physics and Astronomy
	The Johns Hopkins University
	Baltimore, MD 21218

	email: gak@pha.jhu.edu	(Internet)
	phone: (410)516-7679
	FAX:   (410)516-8260

This directory contains reference files for maintaining the correspondence
between status codes used in the SPP F77VOS include file and the
equivalent F77VOS Fortran include file:

f77status.h	- the SPP version of the status include file
f77status.inc	- the Fortran version of the status include file
f77status.xrf	- the cross-reference file containing both SPP and Fortran names
iraf77.mem	- a memo file describing the preprocessor used to make
		  the .h and .inc files from the .xrf file

NOTE:  the status return codes are only a PART of the information in 
lib$iraf77.h (and stsdaslib$iraf77/iraf77.h -- they should be the same
file) and stsdaslib$iraf77.inc; NEVER, NEVER, NEVER replace lib$iraf77.h
or stsdaslib$iraf77.inc with the corresponding f77status file! 
Edit and include the relevant files instead.

README for reference atomic data files used in NEBULAR. 	27-Aug-2008

The nebular package retrieves atomic data at run-time from 
files in this (nebular$atom_data) directory. The data are 
divided according to ion, and further into two FITS files 
per ion: a table with the temperature-dependent collision 
strengths and a table with all other data, including the 
energy levels, Einstein A-coefficients, and statistical 
weights. The names of these files are stored in the ASCII 
file "at_refer.dat"; the naming convention for the collision 
strength tables is <ion>_coll.fits, and the other tables is 
<ion>_atom.fits, where <ion> refers to the atomic symbol and 
spectrum number. An example would be "ne_v_coll.fits" for 
the collision strengths for Ne V.  

NOTE: it is essential that these atomic data tables both 
exist and be listed in the at_refer.dat file if the nebular 
tasks are to support a given ion.  However, support for new 
ions requires some (minor) changes to the nebular source code. 

FORMAT OF ATOMIC DATA

Each atomic data table is stored as a FITS BINTABLE. Keywords 
in these tables give the following information: 

  ATOM    = '       ' / name of the atom 
  SPECTRUM=           / spectrum designation (integer >= 1)
  N_LEVEL =           / no. levels supported for this ion
  SOURCE1 = '       ' / literature source for data
  NOTE1   = '       ' / comment about literature source
  GSCONFIG= '       ' / ground-state electron configuration

In the collision strength files, there is an additional keyword: 

  FIT_FUNC= '       ' / function used to fit coll. strength vs. T_e

These tables contain a column for the electron temperature, and 
one column each for the collision strength at the tabulated 
temperature. The column names are "Omega(n->m)" where n is the 
number of the upper level, and m the lower level. The column 
units specify the order of the function used to characterize 
the run of collision strength with T_e. 

For the atomic data files, there is one column each for the 
energy levels (in units of 1/Angstroms), the statistical weights, 
and spontaneous radiative transition probabilities/s for each 
level to each available lower level.  Note that values of zero 
in the table cells may mean that the transition is strictly 
forbidden or that the atomic data are not available in the 
literature. 

OTHER DATA

Besides the catalog of supported ions and the associated atomic 
data files (at_refer.dat mentioned above), the file "ntplot.dat" 
lists those diagnostic curves that are plotted by the "ntplot" 
task. This makes the application more table-driven, and allows 
the source code to be more general.  

UPDATES TO ATOMIC DATA

From time to time new/improved atomic data become available. 
When this happens the files in the atomic_data directory are 
updated with the new values, and the files that had been used 
are moved to the "/old" subdirectory. Users who wish to use the 
older files (perhaps for comparison with prior abundance 
calculations) can substitute the old files for the new ones, 
and the "nebular" package will automatically be updated. 

Non-linear least squares curve fitting package.

Contains routines to fit functions non-linear in their parameters, in the least
squares sense, to 1 or 2-dimensional data. 

The package contains separate entry points for setting the function parameter's
initial guesses, fitting, evaluating the curve and rejecting data points.

							Ivo Busko  2/89

colnames.h	- defines column specs for SDAS fit table
curfitdef.h	- definitions used in linear fitting tasks
extnstr.x	- extracts n-th substring from a dictionary string
getfit.x	- read one line from fit table
nlfit1.x	- used by both non-linear fitting tasks (nfit1d, ngaussfit)
nlwtdb.x	- writes non-linear fit results to table
opendb.x	- opens table for both input and output
prepdata.x	- cleans input values from garbage, computes data errors
rdcurves.x	- data input routines (from the gfit1d original)
tqsort.x	- general quick sort 

C--------------------------------------------------------------------------
        subroutine ftukyd(ounit,keywrd,dval,decim,comm,status)

C       update a double precision value header record in E format
C
C       ounit   i  fortran output unit number
C       keywrd  c  keyword name    ( 8 characters, cols.  1- 8)
C       dval    d  keyword value 
C       decim   i  number of decimal places to display in value field
C       comm    c  keyword comment (max. 47 characters, cols. 34-80)
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, Oct 1994

        character*(*) keywrd,comm
        double precision dval
        integer ounit,status,decim,tstat

        if (status .gt. 0)return
        tstat=status

C       try modifying the keyword, if it exists
        call ftmkyd(ounit,keywrd,dval,decim,comm,status)

        if (status .eq. 202)then
C               keyword doesn't exist, so create it
                status=tstat
                call ftpkyd(ounit,keywrd,dval,decim,comm,status)
        end if
        end

      SUBROUTINE MEDFIL(IN,OUT,NX,NY)
C
C A simple median filter using a 3 by 3 box
C
      IMPLICIT NONE

      INTEGER NX,NY
      DOUBLE PRECISION IN(NX,NY),OUT(NX,NY),SUB(9)

      INTEGER I,J,M,N,NN

      DO J=2,NY-1
         DO I=2,NX-1
            NN=1
            DO N=-1,1
               DO M=-1,1
                  SUB(NN)=IN(I+M,J+N)
                  NN=NN+1
               ENDDO
            ENDDO
 
            CALL SORT(SUB,9)

            OUT(I,J)=SUB(5)
         ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE SORT(RA,N)
      INTEGER N,I,J,L,IR
      DOUBLE PRECISION RA(N),RRA
      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          RRA=RA(L)
        ELSE
          RRA=RA(IR)
          RA(IR)=RA(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            RA(1)=RRA
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20      IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(RA(J).LT.RA(J+1))J=J+1
          ENDIF
          IF(RRA.LT.RA(J))THEN
            RA(I)=RA(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        RA(I)=RRA
      GO TO 10
      END

        SUBROUTINE PUTBND (VERB, NOWAVE, MODSTR, NWAVE, WAVE, 
     :		           GRFTBL, CMPTBL, FLTTAB, STATUS)
*  Worthless comment to see what happens
*
*  Keyphrase:
*  ----------
*  Calculate the instrument passband for all components in a graph path 
*
*  Description:
*  ------------
*  This subroutine first determines the list of optical component mnemonics
*  from the mode string and the graph table by calling PATHF.  Then it gets
*  the corresponding file names from the component table by calling CMPFIL.
*  The wavelengths at which the throughput is desired are pointed to by WAVE,
*  i.e. MEMR(WAVE) through MEMR(WAVE + NWAVE-1).
*  This subroutine then computes the instrument passband and error on this
*  wavelength set by calling THUSET.  Finally, it writes the wavelength set,
*  throughput, and error to the instrument passband table, FLTTAB.
*
*  FORTRAN Name: PUTBND.FOR
*
*  Keywords of Accessed Files and Tables:
*  --------------------------------------
*  NAME              I/O       Description/comment
*  GRFTBL             I        HST instrument graph table
*  CMPTBL             I        HST component name table
*  FLTTAB             O        Output table with instrument passband
*
*  Subroutines Called:
*  -------------------
*  CDBS:
*       ERRMSG, PATHF, CMPFIL, WAVSET, THUSET, FUNIT, PIVLAM,
*       PHOZPT, RMSLAM
*  SDAS:
*       UCLGST, UCLGSB, UTTINN, UTCDEF, UTTCRE, UTCPTR,
*       UTHADR, UTHADT, UTTCLO, UDMGET, UDMFRE
*  OTHERS: NONE
*
*  History:
*  --------
*  Version     Date          Author        Description
*     1      08-16-89        B.Simon       new synphot library interface
*
*-----------------------------------------------------------------------------
*
*==: IRAF.H equivalents
*
C IRAF77 -- Fortran-77 include file for the F77/VOS interface
C Modified: D.L.Ball, 6-OCT-87
C             Remove tabs, change to uppercase
C           D.L.Ball, 15-DEC-1987
C             Changed '777O' to 511 for GRSETA
C             Comment out TYTEXT from datatypes; not used
C           C.D.Biemesderfer, 26-JAN-1988
C             Remove MEMC
C             Add US* status return parameters
C------------------------------------------------------------------------------
C Get IRAF MEM common into main program.
C                              
      LOGICAL          MEMB(1)
      INTEGER          MEMI(1)
      REAL             MEMR(1)
      DOUBLE PRECISION MEMD(1)
      COMPLEX          MEMX(1)
      EQUIVALENCE (MEMB, MEMI, MEMR, MEMD, MEMX)
      COMMON /MEM/ MEMD
C------------------------------------------------------------------------------
C Include F77/VOS parameter equivalents for stuff in hlib$iraf.h.
C
C                                       File access modes, etc.:
C                                       ------------------------
C                                       Read only
      INTEGER    RDONLY
      PARAMETER (RDONLY = 1)
C                                       Read/Write
      INTEGER    RDWRIT
      PARAMETER (RDWRIT = 2)
C                                       New file
      INTEGER    NEWFIL
      PARAMETER (NEWFIL = 5)
C                                       New copy image
      INTEGER    NEWCPY
      PARAMETER (NEWCPY = 7)
C                                       Single-precision real
      INTEGER    TYREAL
      PARAMETER (TYREAL = 6)
C                                       Double-precision real
      INTEGER    TYDOUB
      PARAMETER (TYDOUB = 7)
C------------------------------------------------------------------------------
C Definitions for parameters relevant to table I/O.
C
C                                       Maximum number of header parameters
      INTEGER    TBMXPR
      PARAMETER (TBMXPR = 6)
C                                       Number of rows written to
      INTEGER    TBNROW
      PARAMETER (TBNROW = 21)
C                                       Number of columns defined
      INTEGER    TBNCOL
      PARAMETER (TBNCOL = 22)
*
*== Miscellaneous parameters:
*
*                               -- success indicator
        INTEGER         OK,
*                               -- error indicator
     :                  NOTOK
*
        PARAMETER ( OK = 0 )
*
        PARAMETER ( NOTOK = 1 )
*
C-------------------------------------- End of IRAF77.INC
*
*== String array dimensions:
*
*                               --maximum number of components
        INTEGER MAXCMP,
*                               --maximum number of keywords
     :          MAXKEY,
*                               --maximum component per mode
     :          MAXLST
*
        PARAMETER ( MAXCMP = 2000 )
*
        PARAMETER ( MAXKEY = 100 )
*
        PARAMETER ( MAXLST = 100 )
*
*== input:
*                               --verbose message flag
        LOGICAL         VERB,
*                               --no wavelength array flag
     :                  NOWAVE
*                               --string with mode keywords or mode filename
        CHARACTER*(*)   MODSTR,
*                               --name of output passband table
     :                  FLTTAB
*                               --number of wavelengths
        INTEGER         NWAVE

*
*== input/output:
*                               --pointer to (real) array of wavelengths
        INTEGER         WAVE
*                               --name of instrument graph table
        CHARACTER*(*)   GRFTBL,
*                               --name of component list lookup table
     :                  CMPTBL

*
*== output:
*                               --sdas return status
        INTEGER         STATUS
*
*== local:              
*                               --array contains file names of thruput 
        CHARACTER*64    THUTBL(MAXLST)
*                               --component mnemonics of graph links
        CHARACTER*20    LIST(MAXLST)
*                               --instrument passband table pointer

        INTEGER         TPFLT,
*                               --column indicators
     :                  CIFLT(3),
*                               --total number of components present
     :                  NLIST,
*                               --number of components with throughput tables
     :                  NTHU,
*                               --old value of status
     :                  OSTAT
*                               --passband values at wavelength

        INTEGER         FILT,
*                               --passband errors at wavelength
     :                  FLTERR

*                               --photometric parameters
        REAL            PHOT(5)

*                               --column names of instrument passband table
        CHARACTER*20    FLTCOL(3),
*                               --units of output instrument passband table
     :                  UNITS(3),
*                               --formats of passband table columns
     :                  FORMAT(3)

*                               --data type of passband table columns
        INTEGER         DTTYPE(3)
*
        DATA    FLTCOL  /'WAVELENGTH', 'THROUGHPUT', 'ERROR' /
*
        DATA    UNITS   /'ANGSTROMS', ' ', ' ' /
*
        DATA    FORMAT  /'F12.3', 'F12.7', 'F12.7' /
*
        DATA    DTTYPE  /TYREAL, TYREAL, TYREAL /
*
*==: functions:
*       
*                               --calculate the unit response
        REAL            FUNIT,
*                               --calculate the pivot wavelength
     :                  PIVLAM,
*                               --calculate the equivalent RMS wavelength
     :                  RMSLAM,
*                               --get a synthetic photometry constant
     :                  SYNVAL
*
*---------------------------------------------------------------------------

*       Get component keywords corresponding to observation mode

        CALL PATHF (VERB, MODSTR, MAXLST, GRFTBL, NLIST, LIST)

*       Get the desired optical mnemonic names from CMPTBL

        CALL CMPFIL (VERB, NLIST, LIST, CMPTBL, NTHU, THUTBL)

*       Create the wavelength set at which the passband functions will
*       be evaluated if it was not supplied by the user

        IF (NOWAVE) THEN
            CALL WAVSET (NTHU, THUTBL, NWAVE, WAVE)
	ENDIF

*       Allocate dynamic memory for throughput arrays

        CALL UDMGET (NWAVE, TYREAL, FILT, STATUS)
        CALL UDMGET (NWAVE, TYREAL, FLTERR, STATUS)
        CALL ERRMSG (STATUS, ' ', 'Unable to allocate virtual memory')

*       Compute the combined throughput

        CALL THUSET (NTHU, THUTBL, NWAVE, WAVE, FILT, FLTERR)

*       Evaluate passband functions of components on wavelength set

        PHOT(1) = FUNIT (NWAVE, MEMR(WAVE), MEMR(FILT), 'flam')
        PHOT(2) = SYNVAL ('stmag')
        PHOT(3) = PIVLAM (NWAVE, MEMR(WAVE), MEMR(FILT))
        PHOT(4) = RMSLAM (NWAVE, MEMR(WAVE), MEMR(FILT))
        PHOT(5) = SYNVAL ('hstarea')

        CALL UTTINN (FLTTAB, TPFLT, STATUS)
        IF (STATUS .NE. OK) GOTO 900

        CALL UTPPTI (TPFLT, TBMXPR, 10, STATUS)
        IF (STATUS .NE. OK) GOTO 900

        CALL UTCDEF (TPFLT, FLTCOL, UNITS, FORMAT, DTTYPE, 3,
     :               CIFLT, STATUS)
        IF (STATUS .NE. OK) GOTO 900

        CALL UTTCRE (TPFLT, STATUS)
        IF (STATUS .NE. OK) GOTO 900

*       Put computed values in table header.

        CALL UTHADR (TPFLT, 'photflam', PHOT(1), STATUS)
        CALL UTHADR (TPFLT, 'photzpt', PHOT(2), STATUS)
        CALL UTHADR (TPFLT, 'photplam', PHOT(3), STATUS)
        CALL UTHADR (TPFLT, 'photbw', PHOT(4), STATUS)
        CALL UTHADR (TPFLT, 'aperarea', PHOT(5), STATUS)
        IF (STATUS .NE. OK) GOTO 900

        CALL UTHADT (TPFLT, 'obsmode', MODSTR, STATUS)
        CALL UTHADT (TPFLT, 'grftable', GRFTBL, STATUS)
        CALL UTHADT (TPFLT, 'cmptable', CMPTBL, STATUS)
        IF (STATUS .NE. OK) GOTO 900

        CALL UTCPTR (TPFLT, CIFLT(1), 1, NWAVE, MEMR(WAVE), STATUS)
        CALL UTCPTR (TPFLT, CIFLT(2), 1, NWAVE, MEMR(FILT), STATUS)
        CALL UTCPTR (TPFLT, CIFLT(3), 1, NWAVE, MEMR(FLTERR), STATUS)
        IF (STATUS .NE. OK) GOTO 900

        CALL DTLMSG (VERB, FLTTAB, 'Instrument passband is in table @')
        CALL UTTCLO (TPFLT, STATUS)

 900    IF (STATUS .EQ. OK) THEN
	    OSTAT = OK
        ELSE
	    OSTAT = NOTOK
        ENDIF

*       Free dynamic memory 

        CALL UDMFRE (FILT, TYREAL, STATUS)
        CALL UDMFRE (FLTERR, TYREAL, STATUS)
        CALL ERRMSG (STATUS, ' ', 'Unable to free virtual memory')

        STATUS = OSTAT

        RETURN
        END

      real function unitrp (nwave, wave, band, units)
      integer nwave
      real wave(*)
      real band(*)
      integer*2 units(*)
      integer utype
      logical Memb(1)
      integer*2 Memc(1)
      integer*2 Mems(1)
      integer Memi(1)
      integer*4 Meml(1)
      real Memr(1)
      double precision Memd(1)
      complex Memx(1)
      equivalence (Memb, Memc, Mems, Memi, Meml, Memr, Memd, Memx)
      common /Mem/ Memd
      integer sp
      integer form
      integer vflux
      real sum
      real resp
      integer wordmh
      real sumfit
      real asumr
      real cntrae
      integer sw0001
      integer*2 baduns(19)
      integer*2 formlt(64)
      logical xerflg
      common /xercom/ xerflg
      integer*2 st0001(8)
      save
      integer iyy
      data (baduns(iyy),iyy= 1, 8) / 85,110,107,110,111,119,110, 32/
      data (baduns(iyy),iyy= 9,16) /102,108,117,120, 32,117,110,105/
      data (baduns(iyy),iyy=17,19) /116,115, 0/
      data (formlt(iyy),iyy= 1, 8) /112,104,111,116,108, 97,109, 44/
      data (formlt(iyy),iyy= 9,16) / 99,111,117,110,116,115, 44,102/
      data (formlt(iyy),iyy=17,24) /108, 97,109, 44,102,110,117, 44/
      data (formlt(iyy),iyy=25,32) /112,104,111,116,110,117, 44,106/
      data (formlt(iyy),iyy=33,40) /121, 44,109,106,121, 44, 97, 98/
      data (formlt(iyy),iyy=41,48) /109, 97,103, 44,115,116,109, 97/
      data (formlt(iyy),iyy=49,56) /103, 44,118,101,103, 97,109, 97/
      data (formlt(iyy),iyy=57,64) /103, 44,111, 98,109, 97,103, 0/
      data st0001 /112,104,111,116,108, 97,109, 0/
      unitrp = 0
         call smark (sp)
         call salloc (form, 63 , 2)
         resp = 0.0
         call xstrcy(units, memc(form), 63 )
         call strfix (memc(form))
         utype = wordmh (memc(form), formlt)
         sw0001=(utype)
         goto 110
120      continue
            sum = sumfit (nwave, wave, 0, band)
            if (.not.(sum .gt. 0.0)) goto 130
               resp = 1.0 / sum
130         continue
         goto 111
140      continue
            sum = asumr (band, nwave)
            if (.not.(sum .gt. 0.0)) goto 150
               resp = 1.0 / sum
150         continue
         goto 111
160      continue
            sum = sumfit (nwave, wave, 1, band)
            sum = sum / (6.62620e-27 * 2.997925e18 )
            if (.not.(sum .gt. 0.0)) goto 170
               resp = 1.0 / sum
170         continue
         goto 111
180      continue
            sum = sumfit (nwave, wave, -1, band)
            sum = sum / 6.62620e-27
            if (.not.(sum .gt. 0.0)) goto 190
               resp = 1.0 / sum
190         continue
         goto 111
200      continue
            sum = sumfit (nwave, wave, -2, band)
            sum = sum * 2.997925e18
            if (.not.(sum .gt. 0.0)) goto 210
               resp = 1.0 / sum
210         continue
         goto 111
220      continue
            sum = sumfit (nwave, wave, -1, band)
            sum = sum * 1.0e-23 / 6.62620e-27
            if (.not.(sum .gt. 0.0)) goto 230
               resp = 1.0 / sum
230         continue
         goto 111
240      continue
            sum = sumfit (nwave, wave, -1, band)
            sum = sum * 1.0e-26 / 6.62620e-27
            if (.not.(sum .gt. 0.0)) goto 250
               resp = 1.0 / sum
250         continue
         goto 111
260      continue
            sum = sumfit (nwave, wave, -1, band)
            sum = sum / 6.62620e-27
            if (.not.(sum .gt. 0.0)) goto 270
               resp = 2.5 * alog10 (sum) + (-48.60)
270         continue
         goto 111
280      continue
            sum = sumfit (nwave, wave, 1, band)
            sum = sum / (6.62620e-27 * 2.997925e18 )
            if (.not.(sum .gt. 0.0)) goto 290
               resp = 2.5 * alog10 (sum) + (-21.10)
290         continue
         goto 111
300      continue
            call salloc (vflux, nwave, 6)
            call getvea (nwave, wave, memr(vflux))
            if (xerflg) goto 100
            sum = cntrae (nwave, wave, band, memr(vflux), st0001)
            if (.not.(sum .gt. 0.0)) goto 310
               resp = 2.5 * alog10 (sum)
310         continue
         goto 111
320      continue
            sum = asumr (band, nwave)
            if (.not.(sum .gt. 0.0)) goto 330
               resp = 2.5 * alog10 (sum)
330         continue
         goto 111
340      continue
            call synphr (baduns, units)
            if (xerflg) goto 100
            goto 111
110      continue
            if (sw0001.lt.1.or.sw0001.gt.11) goto 340
            goto (120,140,160,180,200,220,240,260,280,300,320),sw0001
111      continue
         call sfree (sp)
         unitrp = (resp)
         goto 100
100      return
      end
c     synphr  synphoterr
c     getvea  getvega
c     formlt  formlist
c     cntrae  cntrate
c     unitrp  unitresp
c     wordmh  word_match
c     sumfit  sumfilt
c     baduns  badunits

        SUBROUTINE RDWAVE (

*  inputs:

     :                     VERB,
     :                     WAVTBL,

*  outputs:

     :                     NWAVE,
     :                     WAVE
     :                    )
*
*  Keyphrase:
*  ----------
*  Read the requested wavelength set from the wavelength table
*
*  Description:
*  ------------
*  This subroutine opens the wavelength table, WAVTBL, and reads the
*  requested wavelength set into a dynamically allocated array. Null
*  values are removed from the array, which is returned to the calling
*  routine.
*
*  FORTRAN Name: RDWAVE.FOR
*
*  Keywords of Accessed Files and Tables:
*  --------------------------------------
*  Name              I/O       Description/comment
*  'WAVTABLE'         I        SDAS table contains requested wavelength set
*
*  Subroutines Called:
*  -------------------
*  CDBS:
*       ERRMSG, DTLMSG 
*  SDAS:
*       UTTOPN, UTPGTI, UTCFND, UTCGTR, UDMGET, UTTCLO
*  Others: None
*
*  History:
*  --------
*  Version     Date          Author        Description
*     1      04-02-87        K.-T. Yung    code
*     2      06-02-88        B.Simon       revised for modularity
*
*-----------------------------------------------------------------------------
*
*==: IRAF.H equivalents
*
C IRAF77 -- Fortran-77 include file for the F77/VOS interface
C Modified: D.L.Ball, 6-OCT-87
C             Remove tabs, change to uppercase
C           D.L.Ball, 15-DEC-1987
C             Changed '777O' to 511 for GRSETA
C             Comment out TYTEXT from datatypes; not used
C           C.D.Biemesderfer, 26-JAN-1988
C             Remove MEMC
C             Add US* status return parameters
C------------------------------------------------------------------------------
C Get IRAF MEM common into main program.
C
      LOGICAL          MEMB(1)
      INTEGER          MEMI(1)
      REAL             MEMR(1)
      DOUBLE PRECISION MEMD(1)
      COMPLEX          MEMX(1)
      EQUIVALENCE (MEMB, MEMI, MEMR, MEMD, MEMX)
      COMMON /MEM/ MEMD
C------------------------------------------------------------------------------
C Include F77/VOS parameter equivalents for stuff in hlib$iraf.h.
C
C                                       End-of-file code
      INTEGER    EOF
      PARAMETER (EOF = -2)
C                                       IRAF definition for NO
      INTEGER    NO
      PARAMETER (NO = 0)
C                                       IRAF definition for YES
      INTEGER    YES
      PARAMETER (YES = 1)
C                                       File access modes, etc.:
C                                       ------------------------
C                                       Read only
      INTEGER    RDONLY
      PARAMETER (RDONLY = 1)
C                                       Read/Write
      INTEGER    RDWRIT
      PARAMETER (RDWRIT = 2)
C                                       Write only
      INTEGER    WRONLY
      PARAMETER (WRONLY = 3)
C                                       Append
      INTEGER    APPEND
      PARAMETER (APPEND = 4)
C                                       New file
      INTEGER    NEWFIL
      PARAMETER (NEWFIL = 5)
C                                       Temporary file
      INTEGER    TMPFIL
      PARAMETER (TMPFIL = 6)
C                                       New copy image
      INTEGER    NEWCPY
      PARAMETER (NEWCPY = 7)
C                                       New image
      INTEGER    NEWIMG
      PARAMETER (NEWIMG = 5)
C                                       Data types:
C                                       -----------
C                                       Boolean
      INTEGER    TYBOOL
      PARAMETER (TYBOOL = 1)
C                                       Short integer
      INTEGER    TYSHOR
      PARAMETER (TYSHOR = 3)
C                                       Integer
      INTEGER    TYINT
      PARAMETER (TYINT = 4)
C                                       Long integer
      INTEGER    TYLONG
      PARAMETER (TYLONG = 5)
C                                       Single-precision real
      INTEGER    TYREAL
      PARAMETER (TYREAL = 6)
C                                       Double-precision real
      INTEGER    TYDOUB
      PARAMETER (TYDOUB = 7)
C                                       Complex
      INTEGER    TYCPLX
      PARAMETER (TYCPLX = 8)
C                                       Unsigned short integer
      INTEGER    TYUSHT
      PARAMETER (TYUSHT = 11)
C                                       Unsigned byte
      INTEGER    TYUBYT
      PARAMETER (TYUBYT = 12)
C
C TYTEXT is a special code for the IRAF77 interface; it is not in the VOS.
C
C The following is NOT the value to use when defining a character-type column
C for a table; use -N, where N is the maximum number of characters in an
C element of that column.
C
C NOT PRESENTLY USED IN THE INTERFACE; commented out 12/15/87, DB
C
C                                       Text string
C      INTEGER    TYTEXT
C      PARAMETER (TYTEXT = 13)
C------------------------------------------------------------------------------
C Definitions for parameters relevant to table I/O.
C
C                                       These may be set by UTPPTI and/or
C                                         read by UTPGTI:
C                                       ---------------------------------
C                                       Length of row (unit: size of real)
      INTEGER    TBRLEN
      PARAMETER (TBRLEN = 1)
C                                       Increase row length
      INTEGER    TBIRLN
      PARAMETER (TBIRLN = 2)
C                                       Number of rows to allocate
      INTEGER    TBALLR
      PARAMETER (TBALLR = 3)
C                                       Increase alloc num of rows
      INTEGER    TBIALR
      PARAMETER (TBIALR = 4)
C                                       Which type of table (row or column) ?
      INTEGER    TBWTYP
      PARAMETER (TBWTYP = 5)
C                                       Maximum number of user parameters
      INTEGER    TBMXPR
      PARAMETER (TBMXPR = 6)
C                                       Maximum number of columns
      INTEGER    TBMXCL
      PARAMETER (TBMXCL = 7)
C                                       Type: row-ordered table
      INTEGER    TBTYPR
      PARAMETER (TBTYPR = 11)
C                                       Type: column-ordered table
      INTEGER    TBTYPC
      PARAMETER (TBTYPC = 12)
C                                       These may be read by UTPGTI but
C                                         may not be set:
C                                       -------------------------------
C                                       Number of rows written to
      INTEGER    TBNROW
      PARAMETER (TBNROW = 21)
C                                       Number of columns defined
      INTEGER    TBNCOL
      PARAMETER (TBNCOL = 22)
C                                       Amount of row used (unit: size of real)
      INTEGER    TBRUSD
      PARAMETER (TBRUSD = 23)
C                                       Number of user parameters
      INTEGER    TBNPAR
      PARAMETER (TBNPAR = 24)
C-------------------------------------- End of IRAF77.INC
*
*== String array dimensions:
*
*                               --maximum number of components
        INTEGER MAXCMP,
*                               --maximum number of keywords
     :          MAXKEY,
*                               --maximum component per mode
     :          MAXLST
*
        PARAMETER ( MAXCMP = 2000 )
*
        PARAMETER ( MAXKEY = 100 )
*
        PARAMETER ( MAXLST = 100 )
*
*== Miscellaneous parameters:
*
*                               -- success indicator
        INTEGER         OK,
*                               -- error indicator
     :                  NOTOK
*
        PARAMETER ( OK = 0 )
*
        PARAMETER ( NOTOK = 1 )
*
*== input: 
*                               --detail message switch
        LOGICAL         VERB
*                               --table contains requested wavelength set
        CHARACTER*64    WAVTBL
*
*== output: 
*                               --number of wavelengths in table
        INTEGER         NWAVE 
*                               --pointer to wavelength set
        INTEGER         WAVE
*
*== local:              
*                               --wavelength table pointer
        INTEGER         TPWAV, 
*                               --column indicator
     :                  CIWAV, 
*                               --number of non-null wavelengths
     :                  MWAVE,
*                               --SDAS return status
     :                  STATUS
*                               --array of flags (true if undefined)
        INTEGER         NULFLG
*
*---------------------------------------------------------------------------

*       Get number of rows in wavelength set table

        CALL UTTOPN( WAVTBL, RDONLY, TPWAV, STATUS )
        CALL ERRMSG( STATUS, WAVTBL, 'Unable to open table @' )
        CALL DTLMSG( VERB, WAVTBL, 'Wavelength table @ opened' )

        CALL UTPGTI( TPWAV, TBNROW, NWAVE, STATUS )
        CALL ERRMSG( STATUS, WAVTBL,
     :               'Unable to get number of rows in @' )

*       Allocate the dynamic memory to hold the wavelength table column

        CALL UDMGET ( NWAVE, TYBOOL, NULFLG, STATUS )
        CALL UDMGET ( NWAVE, TYREAL, WAVE, STATUS )
        CALL ERRMSG ( STATUS, ' ', 'Unable to allocate dynamic memory' )

*       Get the requested wavelengths from WAVTBL, place them in array WAVE(I)

        CALL UTCFND( TPWAV, 'WAVELENGTH', 1, CIWAV , STATUS )
        CALL ERRMSG( STATUS, WAVTBL,
     :               'Column WAVELENGTH not found in @' )

        CALL UTCGTR( TPWAV, CIWAV, 1, NWAVE, MEMR(WAVE), MEMB(NULFLG),
     :               STATUS )
        CALL ERRMSG( STATUS, WAVTBL,
     :               'Unable to get requested wavelengths from @' )

*       Move all null elements to the end of the array

        CALL DNULLR( MEMB(NULFLG), NWAVE, MWAVE, MEMR(WAVE) )
        IF ( MWAVE .EQ. 0) THEN
            CALL ERRMSG( NOTOK, WAVTBL,
     :                  'Wavelength values are all undefined in @' )
        ELSE
            NWAVE = MWAVE
        END IF

        CALL UTTCLO( TPWAV, STATUS )
        CALL ERRMSG( STATUS, WAVTBL, 'Unable to close table @' )

        RETURN
        END
 
                                                               
                                                               
                                                               
                                                               
                                                               
                                                               
                                                              

 

C----------------------------------------------------------------------
        subroutine ftuscc(input,np,scaled,scale,zero,output)

C       unscale the array of complex numbers, prior to writing to the FITS file

C       input  r  array of complex numbers (pairs of real/imaginay numbers)
C       np     i  total number of values to scale (no. of pairs times 2)
C       scaled l  is the data scaled?
C       scale  d  scale factor
C       zero   d  offset
C       output r  output array

        integer np,i,j
        logical scaled
        real input(np),output(np)
        double precision scale,zero

        j=1
        if (scaled)then
            do 10 i=1,np/2
                output(j)=(input(j)-zero)/scale
                j=j+1
C               the imaginary part of the number is not offset!!
                output(j)=input(j)/scale
                j=j+1
10          continue
        else
            do 20 i=1,np
                output(i)=input(i)
20          continue
        end if
        end

C----------------------------------------------------------------------
        subroutine fti4i1(input,n,scale,zero,tofits,
     &          chktyp,chkval,setval,flgray,anynul,output,status)

C       copy input i*4 values to output i*1 values, doing optional
C       scaling and checking for null values

C       input   i input array of values
C       n       i  number of values 
C       scale   d  scaling factor to be applied
C       zero    d  scaling zero point to be applied
C       tofits  l  true if converting from internal format to FITS
C       chktyp  i  type of null value checking to be done if TOFITS=.false.
C                       =0  no checking for null values
C                       =1  set null values = SETVAL
C                       =2  set corresponding FLGRAY value = .true.
C       chkval  i value in the input array that is used to indicated nulls
C       setval  c*1 value to set output array to if value is undefined
C       flgray  l   array of logicals indicating if corresponding value is null
C       anynul  l   set to true if any nulls were set in the output array
C       output  c*1 returned array of values
C       status  i  output error status (0 = ok)

        integer input(*),chkval
        character*1 output(*),setval
        integer n,i,chktyp,status
        double precision scale,zero,dval
        logical tofits,flgray(*),anynul,noscal

        if (status .gt. 0)return

        if (scale .eq. 1. .and. zero .eq. 0)then
                noscal=.true.
        else
                noscal=.false.
        end if
        
        if (tofits) then
C               we don't have to worry about null values when writing to FITS
                if (noscal)then
                    do 10 i=1,n
C                       trap any values that overflow the I*1 range
                        if (input(i).le. 255 .and. input(i).ge. 0)then      
                                output(i)=char(input(i))
                        else if (input(i) .gt. 255)then
                                status=-11
                                output(i)=char(255)
                        else
                                status=-11
                                output(i)=char(0)
                        end if
10                  continue
                else
                        do 20 i=1,n
                            dval=(input(i)-zero)/scale
C                           trap any values that overflow the I*1 range
                            if (dval.lt. 255.49 .and. dval.gt. -.49)then      
                                output(i)=char(nint(dval))
                            else if (dval .ge. 255.49)then
                                status=-11
                                output(i)=char(255)
                            else
                                status=-11
                                output(i)=char(0)
                            end if
20                      continue
                end if
        else
C               converting from FITS to internal format; may have to check nulls
                if (chktyp .eq. 0)then
C                   don't have to check for nulls
                    if (noscal)then
                      do 30 i=1,n
C                       trap any values that overflow the I*1 range
                        if (input(i).le. 255 .and. input(i).ge. 0)then      
                                output(i)=char(input(i))
                        else if (input(i) .gt. 255)then
                                status=-11
                                output(i)=char(255)
                        else
                                status=-11
                                output(i)=char(0)
                        end if
30                    continue
                    else
                        do 40 i=1,n
                            dval=input(i)*scale+zero
C                           trap any values that overflow the I*1 range
                            if (dval.lt. 255.49 .and. dval.gt. -.49)then      
                                    output(i)=char(int(dval))
                            else if (dval .ge. 255.49)then
                                    status=-11
                                    output(i)=char(255)
                            else
                                    status=-11
                                    output(i)=char(0)
                            end if
40                      continue
                    end if
                else 
C                   must test for null values
                    if (noscal)then
                         do 50 i=1,n
                             if (input(i) .eq. chkval)then
                                            anynul=.true.
                                            if (chktyp .eq. 1)then
                                                output(i)=setval
                                            else
                                                flgray(i)=.true.
                                            end if
                              else
C                               trap any values that overflow the I*1 range
                                if (input(i).le. 255 .and. 
     &                              input(i).ge. 0)then     
                                    output(i)=char(input(i))
                                else if (input(i) .gt. 255)then
                                    status=-11
                                    output(i)=char(255)
                                else
                                    status=-11
                                    output(i)=char(0)
                                end if
                             end if
50                       continue
                    else
                      do 60 i=1,n
                        if (input(i) .eq. chkval)then
                                    anynul=.true.
                                    if (chktyp .eq. 1)then
                                        output(i)=setval
                                    else
                                        flgray(i)=.true.
                                    end if
                         else
                            dval=input(i)*scale+zero
C                           trap any values that overflow the I*1 range
                            if (dval.lt. 255.49 .and. dval.gt. -.49)then
                                    output(i)=char(int(dval))
                            else if (dval .ge. 255.49)then
                                    status=-11
                                    output(i)=char(255)
                            else
                                    status=-11
                                    output(i)=char(0)
                            end if
                         end if
60                     continue
                    end if
                end if
        end if
        end

C--------------------------------------------------------------------------
        subroutine ftmkyl(ounit,keywrd,logval,comm,status)

C       modify a logical value header record 
C
C       ounit   i  fortran output unit number
C       keywrd  c  keyword name    ( 8 characters, cols.  1- 8)
C       logval  l  keyword value 
C       comm    c  keyword comment (47 characters, cols. 34-80)
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        character*(*) keywrd,comm
        integer ounit,status
        logical logval
        character value*20,cmnt*48

C       find the old keyword
        call ftgkey(ounit,keywrd,value,cmnt,status)
        
C       check for special symbol indicating that comment should not be changed
        if (comm .ne. '&')then
              cmnt=comm
        end if

C       convert logical to character string
        call ftl2c(logval,value,status)

C       modify the keyword record
        call ftmkey(ounit,keywrd,value,cmnt,status)
        end

      real function cntrae (nwave, wave, band, spec, units)
      integer nwave
      real wave(*)
      real band(*)
      real spec(*)
      integer*2 units(*)
      integer utype
      integer done
      logical Memb(1)
      integer*2 Memc(1)
      integer*2 Mems(1)
      integer Memi(1)
      integer*4 Meml(1)
      real Memr(1)
      double precision Memd(1)
      complex Memx(1)
      equivalence (Memb, Memc, Mems, Memi, Meml, Memr, Memd, Memx)
      common /Mem/ Memd
      integer sp
      integer prod
      integer form
      real rate
      integer ismagt
      integer wordmh
      integer anytot
      integer photty
      real sumfit
      real asumr
      integer sw0001
      integer*2 baduns(19)
      integer*2 formlt(64)
      logical xerflg
      common /xercom/ xerflg
      integer*2 st0001(4)
      integer*2 st0002(5)
      integer*2 st0003(5)
      integer*2 st0004(7)
      save
      integer iyy
      data (baduns(iyy),iyy= 1, 8) / 85,110,107,110,111,119,110, 32/
      data (baduns(iyy),iyy= 9,16) /102,108,117,120, 32,117,110,105/
      data (baduns(iyy),iyy=17,19) /116,115, 0/
      data (formlt(iyy),iyy= 1, 8) /112,104,111,116,108, 97,109, 44/
      data (formlt(iyy),iyy= 9,16) / 99,111,117,110,116,115, 44,102/
      data (formlt(iyy),iyy=17,24) /108, 97,109, 44,102,110,117, 44/
      data (formlt(iyy),iyy=25,32) /112,104,111,116,110,117, 44,106/
      data (formlt(iyy),iyy=33,40) /121, 44,109,106,121, 44, 97, 98/
      data (formlt(iyy),iyy=41,48) /109, 97,103, 44,115,116,109, 97/
      data (formlt(iyy),iyy=49,56) /103, 44,118,101,103, 97,109, 97/
      data (formlt(iyy),iyy=57,64) /103, 44,111, 98,109, 97,103, 0/
      data st0001 /102,110,117, 0/
      data st0002 /102,108, 97,109, 0/
      data st0003 /102,108, 97,109, 0/
      data st0004 / 99,111,117,110,116,115, 0/
      cntrae = 0
         call smark (sp)
         call salloc (prod, nwave, 6)
         call salloc (form, 63 , 2)
         if (.not.(ismagt (units) .eq. 0)) goto 110
            call amulr (band, spec, memr(prod), nwave)
            goto 111
110      continue
            call amovr (spec, memr(prod), nwave)
            done = anytot (units, nwave, wave, memr(prod))
            if (xerflg) goto 100
            call amulr (band, memr(prod), memr(prod), nwave)
111      continue
         call xstrcy(units, memc(form), 63 )
         call strfix (memc(form))
         utype = wordmh (memc(form), formlt)
         sw0001=(utype)
         goto 120
130      continue
            rate = sumfit (nwave, wave, 0, memr(prod))
         goto 121
140      continue
            rate = asumr (memr(prod), nwave)
         goto 121
150      continue
            rate = sumfit (nwave, wave, 1, memr(prod))
            rate = rate / (6.62620e-27 * 2.997925e18 )
         goto 121
160      continue
            rate = sumfit (nwave, wave, -1, memr(prod))
            rate = rate / 6.62620e-27
         goto 121
170      continue
            rate = sumfit (nwave, wave, -2, memr(prod))
            rate = rate * 2.997925e18
         goto 121
180      continue
            rate = sumfit (nwave, wave, -1, memr(prod))
            rate = rate * 1.0e-23 / 6.62620e-27
         goto 121
190      continue
            rate = sumfit (nwave, wave, -1, memr(prod))
            rate = rate * 1.0e-26 / 6.62620e-27
         goto 121
200      continue
            done = photty (st0001, nwave, wave, memr(prod))
            if (xerflg) goto 100
            rate = sumfit (nwave, wave, -1, memr(prod))
            rate = rate / 6.62620e-27
         goto 121
210      continue
            done = photty (st0002, nwave, wave, memr(prod))
            if (xerflg) goto 100
            rate = sumfit (nwave, wave, 1, memr(prod))
            rate = rate / (6.62620e-27 * 2.997925e18 )
         goto 121
220      continue
            done = photty (st0003, nwave, wave, memr(prod))
            if (xerflg) goto 100
            rate = sumfit (nwave, wave, 1, memr(prod))
            rate = rate / (6.62620e-27 * 2.997925e18 )
         goto 121
230      continue
            done = photty (st0004, nwave, wave, memr(prod))
            if (xerflg) goto 100
            rate = asumr (memr(prod), nwave)
         goto 121
240      continue
            call synphr (baduns, units)
            if (xerflg) goto 100
            goto 121
120      continue
            if (sw0001.lt.1.or.sw0001.gt.11) goto 240
            goto (130,140,150,160,170,180,190,200,210,220,230),sw0001
121      continue
         call sfree (sp)
         cntrae = (rate)
         goto 100
100      return
      end
c     synphr  synphoterr
c     anytot  anytophot
c     photty  phottoany
c     formlt  formlist
c     cntrae  cntrate
c     wordmh  word_match
c     ismagt  is_magunit
c     sumfit  sumfilt
c     baduns  badunits

C     Copyright restrictions apply - see st4gem$copyright.stsdas 
C 
      SUBROUTINE PLUCY   !I
CM    PROGRAM MPLUCY      !M
C++
C
C PLUCY.F Version 0.7
C
C Lucy point-sources+smooth extended objects restoration.
C Experimental version for many PSFs, acceleration and a floating prior.
C
C Implementation Details:
C
C This version uses the F77/VOS interface to IRAF parameters and
C data structures.
C
C Apart from the F77/VOS standard libraries the only other external
C dependencies are:
C
C fftetc.f - a set of FFT support routines including several
C            FFT codes.
C
C x_plucy.x - the one line of SPP needed for linking purposes.
C
C timtem.x - routines needed for image list handling from F77/VOS
C
C Author:
C
C Richard Hook, ST-ECF, e-mail: rhook@eso.org (Internet)
C (Based on ideas and code by Leon Lucy)
C
C History:
C
C First attempts, Jan 1993
C Added renormalisation and non-negativity checking - July 1993
C Started multi PSF version - Aug 93
C Floating prior added - Aug 93
C Acceleration added - Aug 93
C Acceleration for stationary prior and other additions - Sep/Oct 93
C Tests of automatically corrected PSF - Oct 93
C Bugfix for version 0.5D - Mar 94
C Working on PSF determination enhancements - Aug 94
C Version 0.6D, including regularization of PSF - Aug 94
C  This version also modifies and simplifies the normalisations
C Version 0.65 - bugfix for DIMS array - July 95
C
C Version 0.7 - removed options for varying PSF, removed problems
C               with character strings extending over more than one
C               line and a few other minor changes.
C
C Note:
C
C This version may also be compiled and linked to run under MIDAS
C as well as IRAF. Essentially all that is required is for the
C lines ending with !I to be commented out and the comment
C characters removed from lines starting CM. The result should
C then be linked with the additional library 'midint.f' which
C emulates (partially) the F77/VOS routines using MIDAS.
C
C--
      IMPLICIT NONE
                   
C Iraf global storage
      DOUBLE PRECISION MEMD(1) !I
      COMMON /MEM/MEMD         !I
                                 
C MIDAS global storage
CM    INTEGER MEMD(1)          !M
CM    COMMON /VMR/MEMD         !M
                                 
C Parameters
      INTEGER MAXSTR
      PARAMETER (MAXSTR=100000)
      INTEGER MAXPSF
      PARAMETER (MAXPSF=100)
      INTEGER USEOF
      PARAMETER (USEOF=-2)

C Local variables
      INTEGER DATTYP,NDIMS,NPSF
      INTEGER DATPNT,PSFPNT(MAXPSF)
      INTEGER ISTAT,NX,NY,N,NITER,DIMS(7)
      INTEGER PSFFFT(MAXPSF),WORK,REST,PS,PSM(MAXPSF)
      INTEGER W,CH,NNEG,CF,PHS,RP,CFP,PSFP,FPFFT,PHP
      INTEGER DPHP,DPHS
      INTEGER IDD,IDP(MAXPSF),IDDC,IDPS
      DOUBLE PRECISION T,PT,SCRATCH(40960),CS,SMB,TST
      DOUBLE PRECISION RMSRES,RESMAX,TT,TEM,MAGZERO
      DOUBLE PRECISION GW,HH,SS,STARS(5,MAXSTR),QQ
      INTEGER IRMAX,JRMAX,NSTARS
      INTEGER I,PSFLD,IMSTAT
      DOUBLE PRECISION ST,XL,VMIN,LV
      CHARACTER*80 DATA,PSFS,PSF(MAXPSF),FILE,OUTTAB
      CHARACTER*80 DECON,BACK
      CHARACTER*80 CHARS
      INTEGER NBX,NBY
      LOGICAL VERBOSE
      LOGICAL SUBSAM
      LOGICAL FPRIOR
      LOGICAL ACCEL 
C++
   
C Start of code
               
CM    CALL STSPRO('MPLUCY') !M
                              
C First get the boolean control logicals
      CALL UCLGSB('verbose',VERBOSE,ISTAT)
      CALL UCLGSB('accel',ACCEL,ISTAT)

      FPRIOR=.TRUE.

C Initialise the acceleration factor to one
      XL=1.0D0

C Initialise the maximised quantity (obj func.) to something v. small
      LV=-1.0E20

C Announce the version
      IF(VERBOSE) CALL UMSPUT('+ PLUCY Version 0.7 (March 98)', !I
     :            1,0,ISTAT)                                      !I
CM    IF(VERBOSE) CALL UMSPUT('+ MPLUCY Version 0.7 (March 98)', !M
CM   :            1,0,ISTAT)                                      !M
                            
C Get the magnitude zero point
      CALL UCLGSD('magzero',MAGZERO,ISTAT)
                                    
C Get the name of the input data image
      CALL UCLGST('data',DATA,ISTAT)
      CALL UIMOPN(DATA,1,IDD,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT('! Unable to open data image',
     :                    1,0,ISTAT)
         GO TO 99
      ELSE
         IF(VERBOSE) CALL UMSPUT('-Opening data file: '//DATA,
     :                   1,0,ISTAT)
      ENDIF
         
C Get the names of the PSF images and count them
C if the PSF is varying this is the input, initial PSF
C which need not be the same as the default
      CALL UCLGST('psfs',PSFS,ISTAT)
      CALL TIMOTP(PSFS,PSFLD,ISTAT)

      NPSF=1
      IMSTAT=0
      DO I=1,MAXPSF+1
         CALL TIMXTP(PSFLD,PSF(NPSF),IMSTAT)
         IF(IMSTAT.EQ.USEOF) GO TO 78
         CALL UIMOPN(PSF(NPSF),1,IDP(NPSF),ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT('! Unable to open PSF image',
     :                    1,0,ISTAT)
            GO TO 99
         ELSE
             IF(VERBOSE) 
     :          CALL UMSPUT('-Opening PSF file: '//PSF(NPSF),
     :                   1,0,ISTAT)
         ENDIF
         NPSF=NPSF+1
      ENDDO

 78   CONTINUE
      NPSF=NPSF-1

      CALL TIMCTP(PSFLD,ISTAT)

C Check for floating prior and multiple PSFs - this is not currently
C supported
      IF(NPSF.GT.1 .AND. (FPRIOR.OR.ACCEL)) THEN
         CALL UMSPUT('! Sorry, multiple PSFs cannot be used'//
     :               ' with a floating prior or acceleration.',
     :               1,0,ISTAT)
         GO TO 99
      ENDIF

C Get the fractional contribution of the entropy term
      CALL UCLGSD('fracent',CS,ISTAT)

C Do some checks on PSF size etc
C Get the shapes and sizes of the images
      CALL UIMGID(IDD,DATTYP,NDIMS,DIMS,ISTAT)
                                                    
      IF(NDIMS.EQ.1) THEN
         DIMS(2)=1
      ENDIF
           
      NX=DIMS(1)
      NY=DIMS(2)
                
C Check that the dimensions are EVEN, if not abort
      IF(MOD(NX,2).NE.0 .OR.
     :   (MOD(NY,2).NE.0 .AND. NY.NE.1)) THEN
         CALL UMSPUT('! Image dimensions must be even',
     :               1,0,ISTAT)
         GO TO 99
      ENDIF

C Same for the PSFs
      DO N=1,NPSF
         CALL UIMGID(IDP(N),DATTYP,NDIMS,DIMS,ISTAT)
                                                      
         IF(NDIMS.EQ.1) THEN
            DIMS(2)=1
         ENDIF
              
C Check they are OK
         IF(NX.NE.DIMS(1) .OR.
     :        NY.NE.DIMS(2)) THEN
            CALL UMSPUT('! Data/PSF size/shape error',1,0,ISTAT)
            WRITE(CHARS,'(''Data array size: '',2I5,'//
     :           ''', PSF['',I4,''] array size: '',2I5)')
     :           NX,NY,N,DIMS(1),DIMS(2)
            CALL UMSPUT(CHARS,1,0,ISTAT)
            GO TO 99
         ENDIF
      ENDDO          

C If we have a floating prior get the smoothing kernel sigma
C and create an image for it. Then take the FFT and remove the
C original image
      IF(FPRIOR) THEN
         CALL UCLGSD('skernel',GW,ISTAT)

         CALL UDMGET(NX*NY,7,PSFP,ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT(
     :           '! Unable to allocate memory for PSFP array',
     :                    1,0,ISTAT)
            GO TO 99
         ENDIF

         CALL UDMGET(NX*NY*2,7,FPFFT,ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT(
     :           '! Unable to allocate memory for FPFFT array',
     :                    1,0,ISTAT)
            GO TO 99
         ENDIF

C Put a central, circular, normalised Gaussian into the image
         CALL FGAUSS(MEMD(PSFP),NX,NY,GW)

         CALL DFILL(MEMD(PSFP),NX,NY,MEMD(FPFFT))

         CALL DFOURT(MEMD(FPFFT),DIMS,2,-1,0,SCRATCH)

         CALL UDMFRE(PSFP,7,ISTAT)

C We also get space for the other images we will need
         CALL UDMGET(NX*NY,7,RP,ISTAT)
         IF(ISTAT.NE.0) THEN
           CALL UMSPUT(
     :           '! Unable to allocate memory for RP array',
     :                    1,0,ISTAT)
           GO TO 99
         ENDIF

         CALL UDMGET(NX*NY,7,CFP,ISTAT)
         IF(ISTAT.NE.0) THEN
           CALL UMSPUT(
     :           '! Unable to allocate memory for CFP array',
     :                    1,0,ISTAT)
           GO TO 99
         ENDIF

         CALL UDMGET(NX*NY,7,PHP,ISTAT)
         IF(ISTAT.NE.0) THEN
           CALL UMSPUT(
     :           '! Unable to allocate memory for PHP array',
     :                    1,0,ISTAT)
           GO TO 99
         ENDIF
      ENDIF

C Even more arrays for the accelerated case
      IF(ACCEL) THEN

C This one is only needed for the floating prior case
         IF(FPRIOR) THEN
            CALL UDMGET(NX*NY,7,DPHP,ISTAT)
            IF(ISTAT.NE.0) THEN
               CALL UMSPUT(
     :         '! Unable to allocate memory for DPHP array',
     :                       1,0,ISTAT)
               GO TO 99
            ENDIF
         ENDIF

         CALL UDMGET(NX*NY,7,DPHS,ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT(
     :           '! Unable to allocate memory for DPHS array',
     :                    1,0,ISTAT)
            GO TO 99
         ENDIF
      ENDIF

C Get a scratch array
      CALL UDMGET(NX*NY,7,W,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :      '! Unable to allocate memory for working array',
     :            1,0,ISTAT)
         GO TO 99
      ENDIF
      CALL FILCON(MEMD(W),NX,NY,0.0D0)

C Get the name of the stars list
      CALL UCLGST('starlist',FILE,ISTAT)

      IF(FILE.NE.' ') THEN
         CALL GETSTR(FILE,STARS,NX,NY,NPSF,MEMD(W),
     :               MAXSTR,MAGZERO,
     :               NSTARS,ISTAT)
         IF(ISTAT.NE.0) GO TO 99

C Report the file name of the number of stars
         IF(VERBOSE) THEN
            WRITE(CHARS,'(''-Read star list file: '','//
     :                    'A20,'' ('',I5,'' stars).'')')
     :      FILE,NSTARS
            CALL UMSPUT(CHARS,1,0,ISTAT)
         ENDIF

C Also get the name for the output text file
         CALL UCLGST('outtab',OUTTAB,ISTAT)

         IF(OUTTAB.NE.' ') THEN
            OPEN(8,FILE=OUTTAB,STATUS='NEW',IOSTAT=ISTAT)
            IF(ISTAT.NE.0) THEN
               CALL UMSPUT(
     :      '! Unable to open output text list file',
     :                     1,0,ISTAT)
               GO TO 99
            ENDIF
         ENDIF
      ELSE
         NSTARS=0
         NPSF=1
      ENDIF

C Allocate space for the data
      CALL UDMGET(NX*NY,7,DATPNT,ISTAT)
      IF(ISTAT.NE.0) THEN
        CALL UMSPUT(
     :        '! Unable to allocate memory for data array',
     :                 1,0,ISTAT)
        GO TO 99
      ENDIF
             
C Read the data into the memory
      CALL UIGS2D(IDD,1,NX,1,NY,MEMD(DATPNT),ISTAT)
      IF(ISTAT.NE.0) THEN
        CALL UMSPUT(
     :        '! Unable to read in data input image',
     :                 1,0,ISTAT)
        GO TO 99
      ENDIF
             
C Check that the data is non-negative
      CALL ZAPNEG(MEMD(DATPNT),NX,NY,NNEG,VMIN,0.0D0)
      IF(NNEG.GT.0) THEN
          WRITE(CHARS,
     :    '(''! Warning, data image'','//
     :    ''' contains'',I7,'' negative values, these'','//
     :    ''' have been zeroed.'')') NNEG
         CALL UMSPUT(CHARS,1,0,ISTAT)
         WRITE(CHARS,'(''--Minimum value: '',d20.10)') VMIN
         CALL UMSPUT(CHARS,1,0,ISTAT)
      ENDIF
             
C Allocate space for the PSFs
      DO N=1,NPSF
         CALL UDMGET(NX*NY,7,PSFPNT(N),ISTAT)
         IF(ISTAT.NE.0) THEN
           CALL UMSPUT(
     :     '! Unable to allocate memory for PSF array',
     :              1,0,ISTAT)
           GO TO 99
         ENDIF
             
C Read the PSF into the memory
         CALL UIGS2D(IDP(N),1,NX,1,NY,MEMD(PSFPNT(N)),ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT(
     :      '! Unable to read in PSF input image',
     :               1,0,ISTAT)
            GO TO 99
         ENDIF
             
C Get working space arrays for the FFT
         CALL UDMGET(NX*NY*2,7,PSFFFT(N),ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT(
     :      '! Unable to allocate memory for PSF FFT array',
     :               1,0,ISTAT)
            GO TO 99
         ENDIF
      ENDDO
           
C Create the output data arrays
      CALL UCLGST('decon',DECON,ISTAT)
      CALL UIMCRE(DECON,7,2,DIMS,IDDC,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :     '! Unable to open output deconvolved image',
     :                 1,0,ISTAT)
         GO TO 99
      ENDIF
           
      CALL UCLGST('back',BACK,ISTAT)

      IF(BACK.NE.' ') THEN
         CALL UIMCRE(BACK,7,2,DIMS,IDPS,ISTAT)

         IF(ISTAT.NE.0) THEN
            CALL UMSPUT(
     :     '! Unable to open output background image',
     :                 1,0,ISTAT)
            GO TO 99
         ENDIF
      ENDIF
           
89    CONTINUE
              
C Get the sub-sampling values in X and Y and check that
C the X and Y dimensions are multiples of them.
      CALL UCLGSI('xsubsam',NBX,ISTAT)
      CALL UCLGSI('ysubsam',NBY,ISTAT)
                                      
      IF(MOD(NX,NBX).NE.0 .OR.
     :   MOD(NY,NBY).NE.0) THEN
         CALL UMSPUT('! Warning, arrays are not multiples'//
     :               ' of the sub-sampling',1,0,ISTAT)
      ENDIF
           
      IF(NBX.NE.1 .OR. NBY.NE.1) THEN
         SUBSAM=.TRUE.
      ELSE
         SUBSAM=.FALSE.
      ENDIF
           
C Check the sub-stepping is actually what is found in the data
      IF(SUBSAM) THEN
         CALL CHKSUB(MEMD(DATPNT),NX,NY,NBX,NBY,ISTAT)
         IF(ISTAT.NE.0) THEN
            CALL UMSPUT(
     :    '! Sampling of data wrong - check x/ysubsam',
     :      1,0,ISTAT)
            GO TO 99
         ENDIF
      ENDIF

C Add up the total in the data image
      CALL TOTAL(MEMD(DATPNT),NX,NY,T)

C Normalise the image - this is necessary as the algorithm 
C assumes it has been done
      CALL MULC(MEMD(DATPNT),NX,NY,1.0D0/T,MEMD(DATPNT))

C Prepare the arrays for the FFT routine
C and do the FFTs of the PSF and rotated PSF
C
C At this point we also check that the PSFs are normalised to
C a total of 1 - if they aren't we warn the user but continue
                
C First check for negative values, if there are any set them
C to zero
      DO N=1,NPSF
         CALL ZAPNEG(MEMD(PSFPNT(N)),NX,NY,NNEG,VMIN,0.0D0)
         IF(NNEG.GT.0) THEN
            WRITE(CHARS,
     :       '(''! Warning, PSF '','//
     :       ''' contained '',I7,'' negative values, these'','//
     :       ''' have been set to zero.'')') NNEG
             CALL UMSPUT(CHARS,1,0,ISTAT)
         ENDIF
              
         CALL TOTAL(MEMD(PSFPNT(N)),NX,NY,PT)
         IF(DABS(PT-1.0D0).GT.1.0E-5) THEN
            WRITE(CHARS,
     :       '(''! Warning, PSF '',I4,'//
     :    ''' totals '',F15.7,'' - renormalising.'')') N,PT
            CALL UMSPUT(CHARS,1,0,ISTAT)
            CALL MULC(MEMD(PSFPNT(N)),NX,NY,1.0D0/PT,
     :                MEMD(PSFPNT(N)))
         ENDIF
              
         CALL DFILL(MEMD(PSFPNT(N)),NX,NY,MEMD(PSFFFT(N)))
         CALL DFOURT(MEMD(PSFFFT(N)),DIMS,2,-1,0,SCRATCH)
                                                         
C At this point we have finished with the PSF so it can be closed
C and the memory freed - this is NOT the case with modifyable
C PSFs where we will need to change them later
         CALL UIMCLO(IDP(N),ISTAT)
         CALL UDMFRE(PSFPNT(N),7,ISTAT)
      ENDDO
           
C Create other arrays needed, workspace etc
      CALL UDMGET(NX*NY*2,7,WORK,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :      '! Unable to allocate memory for workspace array',
     :               1,0,ISTAT)
         GO TO 99
      ENDIF
             
C REST is the total restored array - stars+continuum
      CALL UDMGET(NX*NY,7,REST,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :      '! Unable to allocate memory for restored array',
     :               1,0,ISTAT)
         GO TO 99
      ENDIF
             
C PS is the continuum part
      CALL UDMGET(NX*NY,7,PS,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :      '! Unable to allocate memory for continuum array',
     :               1,0,ISTAT)
         GO TO 99
      ENDIF

C PSM is the point sources array(s) (only if there are any)
      IF(NSTARS.GT.0) THEN
         DO N=1,NPSF
            CALL UDMGET(NX*NY,7,PSM(N),ISTAT)
            IF(ISTAT.NE.0) THEN
               CALL UMSPUT(
     :         '! Unable to allocate memory for PSM array',
     :                  1,0,ISTAT)
               GO TO 99
            ENDIF
         ENDDO
      ENDIF

C CH is the 'entropy' array
      CALL UDMGET(NX*NY,7,CH,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :      '! Unable to allocate memory for CH array',
     :               1,0,ISTAT)
         GO TO 99
      ENDIF

C PHS 
      CALL UDMGET(NX*NY,7,PHS,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT(
     :      '! Unable to allocate memory for PHS array',
     :              1,0,ISTAT)
        GO TO 99
      ENDIF
              
C Get space for and initialise the correction factor array
      CALL UDMGET(NX*NY,7,CF,ISTAT)
      IF(ISTAT.NE.0) THEN
         CALL UMSPUT('! Unable to create corr. fac. image',
     :                    1,0,ISTAT)
         GO TO 99
      ENDIF
            
C Prepare the first estimate - just a flat image with 
C the fluxes of the point sources deduced from the third column
C of the input list, using the magzero parameter to scale them.
C The remaining flux goes into the background.
C 
C If there are no specified star positions
C we can just fill the array with a constant
      IF(NSTARS.GT.0) THEN

C First work out the total of the star intensities
         ST=0.0D0
         DO I=1,NSTARS
            IF(STARS(4,I).NE.0) 
     :      ST=ST+STARS(3,I)
         ENDDO

C Write out the initial background value and check that it is
C positive
         IF(VERBOSE) THEN
          WRITE(CHARS,
     :   '(''-Setting background in first estimate to: '','//
     :                 'F12.3)') (T-ST)/DFLOAT(NX*NY)
          CALL UMSPUT(CHARS,1,0,ISTAT)
         ENDIF

C Check that the background would be positive - if not set it
C to zero and get it renormalised later
         IF((T-ST)/DFLOAT(NX*NY).LT.0.0D0) THEN
            CALL UMSPUT(
     :     '! Error - negative initial background, setting to zero',
     :                  1,0,ISTAT)
            CALL FILCON(MEMD(PS),NX,NY,0.0D0)
         ELSE
            CALL FILCON(MEMD(PS),NX,NY,(1.0D0-ST/T)/DFLOAT(NX*NY))
         ENDIF

         DO N=1,NPSF
            CALL FILCON(MEMD(PSM(N)),NX,NY,0.0D0)

            CALL MKINIM(MEMD(PSM(N)),
     :               N,NX,NY,STARS,NSTARS,
     :               1.0D0/T)
         ENDDO
      ELSE
         CALL FILCON(MEMD(PS),NX,NY,1.0D0/DFLOAT(NX*NY))
      ENDIF
           
C Now we can start the iterative procedure
      CALL UCLGSI('niter',NITER,ISTAT)
                                      
      DO N=1,NITER
                  
         IF(VERBOSE) THEN
          CALL UMSPUT(' ',1,0,ISTAT)
            WRITE(CHARS,'(''# Starting iteration '',I5,'//
     :            '''/'',I5,''-----------'')') N,NITER
          CALL UMSPUT(CHARS,1,0,ISTAT)
         ENDIF

C Check for non-negativity
         CALL ZAPNEG(MEMD(PS),NX,NY,NNEG,VMIN,0.0D0)
         IF(NNEG.GT.0) THEN
            WRITE(CHARS,'(''! Background image '','//
     :         '''contains '',I7,'' negative values'')') NNEG
            CALL UMSPUT(CHARS,1,0,ISTAT)
            WRITE(CHARS,'(''--Minimum value: '',D20.10)') VMIN
            CALL UMSPUT(CHARS,1,0,ISTAT)
         ENDIF

         IF(NSTARS.GT.0) THEN
          DO I=1,NPSF
            CALL ZAPNEG(MEMD(PSM(I)),NX,NY,NNEG,VMIN,0.0D0)
            IF(NNEG.GT.0) THEN
               WRITE(CHARS,'(''! Point Source image '',I3,'//
     :         ''' contains '',I7,'' negative values'')') I,NNEG
               CALL UMSPUT(CHARS,1,0,ISTAT)
               WRITE(CHARS,'(''--Minimum value: '',D20.10)') VMIN
               CALL UMSPUT(CHARS,1,0,ISTAT)
            ENDIF
          ENDDO
         ENDIF
                                                 
C Check that everything is correctly normalised
         CALL TOTAL(MEMD(PS),NX,NY,TT)

         IF(NSTARS.GT.0) THEN
            ST=0.0D0
            DO I=1,NPSF
               CALL TOTAL(MEMD(PSM(I)),NX,NY,TEM)
               ST=ST+TEM
               TT=TT+TEM
            ENDDO

            WRITE(CHARS,'(''--Flux distribution, Stars: '','//
     :    'F6.2,''% Background: '',F6.2,''%.'')') 100.0D0*ST,
     :    100.0D0*(1.0D0-ST)
            CALL UMSPUT(CHARS,1,0,ISTAT)
         ENDIF

         IF(DABS(TT-1.0D0).GT.1.0D-10) THEN
            WRITE(CHARS,'('//
     :     '''! Warning, sum of predicted image is '',D20.10,'//
     :     '''(not renormalised).'')') TT
            CALL UMSPUT(CHARS,1,0,ISTAT)
         ENDIF

C First add the continuum and point source arrays (if the latter
C exists). Only the first (centered) point source array.
         IF(NSTARS.GT.0) THEN
            CALL ADDIM(MEMD(PS),MEMD(PSM(1)),NX,NY,MEMD(REST))

C Convolve the current estimate with the PSF to give PHS     
            CALL DCONV(MEMD(REST),NX,NY,MEMD(WORK),
     :                 MEMD(PSFFFT(1)),MEMD(PHS),1)

C Now convolve the rest of the PSFs and add those in too
            IF(NPSF.GT.1) THEN
               DO I=2,NPSF
                  CALL DCONV(MEMD(PSM(I)),NX,NY,MEMD(WORK),
     :                 MEMD(PSFFFT(I)),MEMD(W),1)
                  CALL ADDIM(MEMD(W),MEMD(PHS),
     :                 NX,NY,MEMD(PHS))
               ENDDO
            ENDIF
         ELSE
           CALL DCONV(MEMD(PS),NX,NY,MEMD(WORK),
     :                 MEMD(PSFFFT(1)),MEMD(PHS),1)
         ENDIF
              
C If we have a floating prior we now convolve with the smoothing
C kernel to get the default solution
C
C NB, this is the version 0.5D bugfix - the ,1 at the
C end was missing in earlier versions.
         IF(FPRIOR) THEN
            CALL DCONV(MEMD(PS),NX,NY,MEMD(WORK),
     :                 MEMD(FPFFT),MEMD(PHP),1)
         ENDIF

C Calculate and display the residual information to assist closeness
C of fit assessment
         IF(VERBOSE) THEN
             CALL RESINF(MEMD(PHS),MEMD(DATPNT),
     :                    NX,NY,RMSRES,RESMAX,IRMAX,JRMAX)
               
          WRITE(CHARS,'(''--RMS residual: '',D10.4,'//
     :                 ''' Max residual of '',D10.4,'//
     :                 ''' at ('',I4,'','',I4,'')'')')
     :             RMSRES*T,RESMAX*T,IRMAX,JRMAX
          CALL UMSPUT(CHARS,1,0,ISTAT)
         ENDIF
              
C Calculate the sum of the continuum component
         CALL TOTAL(MEMD(PS),NX,NY,SMB)

C If we are sub-sampling we must do so here.
         CALL TOTAL(MEMD(PHS),NX,NY,SMB)

         IF(SUBSAM) CALL REBIN(MEMD(PHS),NX,NY,NBX,NBY)

         CALL TOTAL(MEMD(PHS),NX,NY,SMB)

C Divide the data by this convolution
         CALL DIVIDE(MEMD(DATPNT),MEMD(PHS),NX,NY,MEMD(W))

C If there is a floating prior we need to calculate the RP
C array
         IF(FPRIOR) THEN
            CALL DIVIDE(MEMD(PS),MEMD(PHP),NX,NY,MEMD(RP))
              
C Calculate the entropy and likelihood and fill the array CH
C This is a bit different if there is a floating prior so we
C use a different routine
            CALL FNTROP(MEMD(PS),MEMD(PHS),MEMD(DATPNT),MEMD(PHP),
     :               NX,NY,MEMD(CH),SS,HH)
         ELSE
            CALL ENTROP(MEMD(PS),MEMD(PHS),MEMD(DATPNT),SMB,
     :               NX,NY,MEMD(CH),SS,HH)
         ENDIF

C Calculate the objective function
         QQ=HH+CS*SS

C Some diagnostics
         IF(VERBOSE) THEN
          WRITE(CHARS,'(''--Log.Lik: '','//
     :         'E15.6,'' Ent: '',E15.6,'//
     :         ''' Obj.Func: '',E20.12)')
     :    HH,SS,QQ
          CALL UMSPUT(CHARS,1,0,ISTAT)
         ENDIF

         IF(QQ.LT.LV) THEN
            WRITE(CHARS,
     :  '(''! Warning, objective function fell by '',D15.7)')
     :      LV-QQ
            CALL UMSPUT(CHARS,1,0,ISTAT)

            IF(.NOT.ACCEL) THEN
               CALL UMSPUT('! Turning on acceleration.',
     :            1,0,ISTAT)

C To avoid catastrophic instabilities we now need to turn on 
C acceleration. First we need to allocate the space we will need
               ACCEL=.TRUE.

C This one is only needed for the floating prior case
               IF(FPRIOR) THEN
                  CALL UDMGET(NX*NY,7,DPHP,ISTAT)
                  IF(ISTAT.NE.0) THEN
                     CALL UMSPUT(
     :         '! Unable to allocate memory for DPHP array',
     :                       1,0,ISTAT)
                     GO TO 99
                  ENDIF
               ENDIF

               CALL UDMGET(NX*NY,7,DPHS,ISTAT)
               IF(ISTAT.NE.0) THEN
                  CALL UMSPUT(
     :           '! Unable to allocate memory for DPHS array',
     :                    1,0,ISTAT)
                  GO TO 99
               ENDIF
            ENDIF
         ELSE
            IF(VERBOSE.AND.N.GT.1) THEN
               WRITE(CHARS,
     :  '(''--Objective function increased by '',D15.7)')
     :         QQ-LV
               CALL UMSPUT(CHARS,1,0,ISTAT)
            ENDIF
         ENDIF
         LV=QQ

C Convolve again, this time by the rotated PSF to get the correction
C factor array
         CALL DCONV(MEMD(W),NX,NY,MEMD(WORK),
     :          MEMD(PSFFFT(1)),MEMD(CF),-1)
                                              
C If we have a floating prior we need to calculate another
C correction factor array (this is also a correlation)
         IF(FPRIOR) THEN
            CALL DCONV(MEMD(RP),NX,NY,MEMD(WORK),
     :          MEMD(FPFFT),MEMD(CFP),-1)
         ENDIF

C If we have acceleration enabled we should now calculate a couple
C more arrays, even more convolutions unfortunately...
         IF(ACCEL) THEN
               
C First calculate DPSS (into MEMD(W)):
C (different code for floating or stationary prior)
             IF(FPRIOR) THEN
                CALL FIDPSS(MEMD(PS),MEMD(PSM(1)),
     :               MEMD(CF),MEMD(CFP),
     :            MEMD(CH),NX,NY,CS,SS,NSTARS,MEMD(W))
             ELSE
                CALL CIDPSS(MEMD(PS),MEMD(PSM(1)),
     :          MEMD(CF),MEMD(CH),NX,NY,CS,SMB,SS,NSTARS,
     :          MEMD(W))
             ENDIF

C Convolve to give DPHS
             CALL DCONV(MEMD(W),NX,NY,MEMD(WORK),
     :           MEMD(PSFFFT(1)),MEMD(DPHS),1)

C Maybe we should rebin here?
             IF(SUBSAM) CALL REBIN(MEMD(DPHS),NX,NY,NBX,NBY)

C Calculate DPS (into MEMD(W) again):
C If there are no stars this can be ignored as W
C already has the correct contents
             IF(NSTARS.GT.0) 
     :           CALL FILDPS(MEMD(W),MEMD(PSM(1)),MEMD(CF),
     :           NX,NY,CS,SS,MEMD(W))

C Convolve this to give DPHP (floating prior only):
             IF(FPRIOR) THEN
                CALL DCONV(MEMD(W),NX,NY,MEMD(WORK),
     :               MEMD(FPFFT),MEMD(DPHP),1)
               
C Calculate the acceleration factor
                CALL FACCL(MEMD(DATPNT),MEMD(PS),MEMD(W),
     :           MEMD(PHS),MEMD(DPHS),MEMD(PHP),MEMD(DPHP),
     :           NX,NY,CS,XL,VERBOSE)
             ELSE
                CALL ACCL(MEMD(DATPNT),MEMD(PS),MEMD(W),
     :           MEMD(PHS),MEMD(DPHS),
     :           NX,NY,CS,XL,VERBOSE)
             ENDIF

             IF(VERBOSE) THEN
              WRITE(CHARS,
     ;       '(''--Using acceleration factor of: '',F10.4)') XL
              CALL UMSPUT(CHARS,1,0,ISTAT)
             ENDIF
         ENDIF

C Apply the correction, first to the continuous image
         IF(FPRIOR) THEN
            CALL FORCON(MEMD(PS),MEMD(CF),MEMD(CFP),MEMD(PSM(1)),
     :                  MEMD(CH),NX,NY,XL,CS,SS,TST)
         ELSE
            CALL CORCON(MEMD(PS),MEMD(CF),
     :                  MEMD(CH),NX,NY,XL,CS,SS,SMB,TST)
         ENDIF

         IF(VERBOSE) THEN
            WRITE(CHARS,
     :       '(''--Convergence parameter: '',D20.8)') TST
            CALL UMSPUT(CHARS,1,0,ISTAT)
         ENDIF

C and to the point source image (if there is one)
         IF(NSTARS.GT.0) THEN  
            CALL CORSTR(MEMD(PSM(1)),MEMD(CF),1,NX,NY,
     :             XL,T,STARS,NSTARS,SS,CS,MAGZERO,VERBOSE)

C now if there are more PSFs we need to do this again
            IF(NPSF.GT.1) THEN
              DO I=2,NPSF
               CALL DCONV(MEMD(W),NX,NY,MEMD(WORK),
     :             MEMD(PSFFFT(I)),MEMD(CF),-1)
               CALL CORSTR(MEMD(PSM(I)),MEMD(CF),I,NX,NY,
     :            XL,T,STARS,NSTARS,SS,CS,MAGZERO,VERBOSE)
              ENDDO
            ENDIF
         ENDIF
      ENDDO
           
C Add up the components of the result (if there are 
C any point sources)
      IF(NSTARS.GT.0) THEN
         CALL ADDIM(MEMD(PS),MEMD(PSM(1)),NX,NY,MEMD(REST))

         IF(NPSF.GT.1) THEN
            DO N=2,NPSF
               CALL ADDIM(MEMD(REST),MEMD(PSM(N)),NX,NY,MEMD(REST))
            ENDDO
         ENDIF

C Multiply up by the total in the input array (un-normalise)
         CALL MULC(MEMD(REST),NX,NY,T,MEMD(REST))
      ELSE
         CALL MULC(MEMD(PS),NX,NY,T,MEMD(REST))
      ENDIF

C Write out the results: 
C First the deconvolved image
      IF(VERBOSE)
     :  CALL UMSPUT('-Writing output deconvolved image: '//DECON
     :              ,1,0,ISTAT)
                               
      CALL UIPS2D(IDDC,1,NX,1,NY,MEMD(REST),ISTAT)
      CALL UIMCLO(IDDC,ISTAT)
                              
C Then the background image if requested
      IF(BACK.NE.' ') THEN
         IF(VERBOSE)
     :     CALL UMSPUT(
     :       '-Writing output smooth background image: '//BACK
     :                 ,1,0,ISTAT)
                               
         CALL MULC(MEMD(PS),NX,NY,T,MEMD(PS))
         CALL UIPS2D(IDPS,1,NX,1,NY,MEMD(PS),ISTAT)
         CALL UIMCLO(IDPS,ISTAT)
      ENDIF

C And now the text list
      IF(OUTTAB.NE.' '.AND.NSTARS.GT.0) THEN

C First we write in some information which may be of interest - mainly
C to record how the file was produced
         WRITE(8,'(''# Created by PLUCY V0.70'')')
         WRITE(8,'(''#'')')
         WRITE(8,'(''# Input data image: '',A30)') DATA
         WRITE(8,'(''# Input PSF image(s): '',A50)') PSFS
         WRITE(8,'(''# Fractional entropy strength: '',F10.4)') CS
         WRITE(8,'(''# Number of interations: '',I6)') NITER
         WRITE(8,'(''# Output deconvolved image: '',A50)') DECON
         WRITE(8,'(''# Input star list: '',A50)') FILE
         WRITE(8,'(''# Floating prior was used.'')')
         WRITE(8,'(''# Sigma of smoothing kernel: '',F10.3)') GW

         IF(ACCEL) THEN
            WRITE(8,'(''# Acceleration was used.'')')
         ELSE
            WRITE(8,'(''# Acceleration was not used.'')')
         ENDIF

         WRITE(8,'(''# Magnitude zero point: '',F10.3)') MAGZERO

         WRITE(8,
     :   '(''# Number  X        Y       InputFlux'','//
     :   '''   MeasuredFlux MeasuredMag'')')

         CALL WRITAB(STARS,NSTARS,MAGZERO,NPSF)
         IF(VERBOSE)
     :     CALL UMSPUT(
     :       '-Writing output photometry list: '//OUTTAB
     :                 ,1,0,ISTAT)
      ENDIF

99    CONTINUE
               
C Close the text file
      CLOSE(8)

C Close all the images
      CALL UIMCLO(IDD,ISTAT)
           
C Free all the dynamic arrays
      CALL UDMFRE(DATPNT,7,ISTAT)

      DO I=1,NPSF
         CALL UDMFRE(PSFFFT(I),7,ISTAT)
      ENDDO

      CALL UDMFRE(PHS,7,ISTAT)
      CALL UDMFRE(PS,7,ISTAT)

      IF(NSTARS.GT.0) THEN
         DO I=1,NPSF
            CALL UDMFRE(PSM(I),7,ISTAT)
         ENDDO
      ENDIF

      CALL UDMFRE(CF,7,ISTAT)
      CALL UDMFRE(WORK,7,ISTAT)
      CALL UDMFRE(REST,7,ISTAT)
      CALL UDMFRE(W,7,ISTAT)

C Another one if acceleration is on
      CALL UDMFRE(DPHS,7,ISTAT)
      
C Extra ones if there is a floating prior
      IF(FPRIOR) THEN
        CALL UDMFRE(PHP,7,ISTAT)
        CALL UDMFRE(FPFFT,7,ISTAT)
        CALL UDMFRE(RP,7,ISTAT)
        CALL UDMFRE(CFP,7,ISTAT)

C Even more if there is acceleration also
        IF(ACCEL) THEN
           CALL UDMFRE(DPHP,7,ISTAT)
        ENDIF
      ENDIF
                                      
C Close down MIDAS
CM    CALL STSEPI    !M
                       
      END
         
      SUBROUTINE MULC(IN1,NX,NY,F,OUT)
C
C Just multiply one array by a constant
C
      IMPLICIT NONE
                   
      INTEGER NX,NY,I,J
      DOUBLE PRECISION IN1(NX,NY),OUT(NX,NY),F
                                              
      DO J=1,NY
         DO I=1,NX
            OUT(I,J)=IN1(I,J)*F
         ENDDO
      ENDDO
           
      RETURN
      END
         
      SUBROUTINE DIVIDE(IN1,IN2,NX,NY,OUT)
C
C Just divide one array by another of the same size
C If the denominator is zero the result is set to zero also.
C
      IMPLICIT NONE
                   
      INTEGER NX,NY,I,J
      DOUBLE PRECISION IN1(NX,NY),IN2(NX,NY),OUT(NX,NY)
      INTEGER NZERO,ISTAT
      CHARACTER*80 CHARS

      NZERO=0
                                                       
      DO J=1,NY
         DO I=1,NX
            IF(IN2(I,J).EQ.0.0D0) THEN
               OUT(I,J)=0.0D0
               NZERO=NZERO+1
            ELSE
               OUT(I,J)=IN1(I,J)/IN2(I,J)
            ENDIF
         ENDDO
      ENDDO
           
      IF(NZERO.GT.0) THEN
         WRITE(CHARS,
     : '(''! '',i10,'' attempts to divide by zero.'')') NZERO
         CALL UMSPUT(CHARS,1,0,ISTAT)
      ENDIF

      RETURN
      END
         
      SUBROUTINE TOTAL(DATA,NX,NY,TOT)
C
C Add up all elements in an image
C
      IMPLICIT NONE
                   
      INTEGER NX,NY,I,J
      DOUBLE PRECISION DATA(NX,NY),TOT
                                      
      TOT=0.0D0
      DO J=1,NY
         DO I=1,NX
             TOT=TOT+DATA(I,J)
         ENDDO
      ENDDO
           
      RETURN
      END
         
      SUBROUTINE MKINIM(IMAGE,NPSF,NX,NY,STARS,NSTARS,T)
C
C Make a suitable starting image from the list of Stars
C provided. The values are those given in the 3rd column
C of the STARS list multiplied by the value of T.
C
C It is assumed that the background is empty on entry.
C

      IMPLICIT NONE

      INTEGER NX,NY,NSTARS
      DOUBLE PRECISION IMAGE(NX,NY),T,STARS(5,NSTARS)
      INTEGER I,NPSF,ISTAT
      CHARACTER*80 CHARS

      DO I=1,NSTARS
         IF(STARS(3,I).NE.0.0D0) THEN
           IF(NINT(STARS(4,I)).EQ.NPSF) THEN
              IF(IMAGE(NINT(STARS(1,I)),NINT(STARS(2,I)))
     :           .NE.0.0D0) THEN
                 WRITE(CHARS,
     : '(''! Pixel ('',I4,'','',I4,'') already has a star in it.'')')
     :          NINT(STARS(1,I)),NINT(STARS(2,I))
                CALL UMSPUT(CHARS,1,0,ISTAT)
                STARS(4,I)=0.0D0
              ELSE 
                 IMAGE(NINT(STARS(1,I)),NINT(STARS(2,I)))=
     :          T*STARS(3,I)
              ENDIF
           ENDIF
         ENDIF
      ENDDO

      RETURN
      END

      SUBROUTINE CORCON(PS,CF,CH,NX,NY,XL,CS,SS,SMB,TST)
C
C Apply the correction to the continuous background image
C including an entropy term. Constant prior version.
C
C This routine also calculates values for a normalisation
C and convergence test.
C
      IMPLICIT NONE

      INTEGER NX,NY
      DOUBLE PRECISION PS(NX,NY),CF(NX,NY)
      DOUBLE PRECISION CH(NX,NY),CS,SS,SMB,XL
      DOUBLE PRECISION DH,DS,DT,TST,VH,VS,XMAX
      INTEGER I,J

      DH=0.0D0
      DS=0.0D0
      XMAX=1.0D30
      DT=0.0D0

      DO J=1,NY
         DO I=1,NX
            VH=PS(I,J)*(CF(I,J)-1.0D0)
            VS=CS*(-PS(I,J)*SS/SMB-CH(I,J))
            DH=DH+VH*VH
            DS=DS+VS*VS
            DT=DT+(VH+VS)**2
            PS(I,J)=PS(I,J)+XL*(VH+VS)
         ENDDO
      ENDDO

      TST=DSQRT(DT)/(DSQRT(DH)+DSQRT(DS))

      RETURN
      END

      SUBROUTINE FORCON(PS,CF,CFP,PSM,
     :           CH,NX,NY,XL,CS,SS,TST)
C
C Apply the correction to the continuous background image
C including an entropy term. Floating prior version.
C
C This routine also calculates values for a normalisation
C and convergence test.
C
C Modified for the new, simpler normalisation scheme and also
C removed the SMB argument - Richard Hook, Dec 14th 1994
C
      IMPLICIT NONE

      INTEGER NX,NY
      DOUBLE PRECISION PS(NX,NY),CF(NX,NY),CFP(NX,NY)
      DOUBLE PRECISION CH(NX,NY),PSM(NX,NY),CS,SS,XL
      DOUBLE PRECISION DH,DS,DT,TST,VH,VS,SSS
      INTEGER I,J

      DH=0.0D0
      DS=0.0D0
      DT=0.0D0

      SSS=0.0D0

      DO J=1,NY
         DO I=1,NX
            VH=PS(I,J)*(CF(I,J)-1.0D0)
            VS=CS*PS(I,J)*(CFP(I,J)-1.0D0)+
     :         CS*(-PS(I,J)*SS-CH(I,J))

            SSS=SSS+VS+VH
            DH=DH+VH*VH
            DS=DS+VS*VS
            DT=DT+(VH+VS)**2
            PS(I,J)=PS(I,J)+XL*(VH+VS)
         ENDDO
      ENDDO

      TST=DSQRT(DT)/(DSQRT(DH)+DSQRT(DS))

      RETURN
      END

      SUBROUTINE CORSTR(PSM,CF,NPSF,NX,NY,XL,T,STARS,NSTARS,
     :                  SS,CS,MAGZERO,VERBOSE)
C
C Apply the correction to the point sources - they have no
C entropy term and are just multiplied by the correction
C factor
C
C Modified to include normalisation changes, Dec 94
C
      IMPLICIT NONE

      INTEGER NX,NY,NSTARS,ISTAT,NPSF
      DOUBLE PRECISION PSM(NX,NY),CF(NX,NY),SS,CS
      DOUBLE PRECISION STARS(5,NSTARS),T,XL,MAGZERO
      CHARACTER*80 CHARS
      LOGICAL VERBOSE
     
      INTEGER I,J,IX,IY

      DO J=1,NY
         DO I=1,NX
            PSM(I,J)=PSM(I,J)*(1.0D0+XL*(CF(I,J)-1.0D0-CS*SS))
         ENDDO
      ENDDO

      DO I=1,NSTARS
        IF(STARS(3,I).NE.0.0D0 .AND.
     :     NINT(STARS(4,I)).EQ.NPSF) THEN
         IX=NINT(STARS(1,I))
         IY=NINT(STARS(2,I))
         STARS(5,I)=PSM(IX,IY)*T

         IF(I.LT.5.AND.VERBOSE.AND.STARS(5,I).GT.0.0D0) THEN
          IF(NPSF.GT.1) THEN
           WRITE(CHARS,'(''--Flux in *'',I4,'' is: '','//
     :         'G14.6,'' Mag: '',F9.3,'' (PSF: '',I4,'')'')') 
     :         I,PSM(IX,IY)*T,
     :         MAGZERO-2.5*DLOG10(PSM(IX,IY)*T),NPSF
           ELSE
           WRITE(CHARS,'(''--Flux in *'',I4,'' is: '','//
     :         'G14.6,'' Mag: '',F9.3)') I,PSM(IX,IY)*T,
     :         MAGZERO-2.5*DLOG10(PSM(IX,IY)*T)
           ENDIF
           CALL UMSPUT(CHARS,1,0,ISTAT)
          ENDIF
         ENDIF
         IF(I.EQ.6.AND.VERBOSE) 
     :        CALL UMSPUT('    Etc,Etc...',1,0,ISTAT)
      ENDDO

      RETURN
      END

      SUBROUTINE WRITAB(STARS,NSTARS,MAGZERO,NPSF)
C
C Write out the final results as an ASCII table
C It is assumed that this file has already been opened
C on FORTRAN unit 8.
C
      IMPLICIT NONE

      INTEGER NSTARS
      DOUBLE PRECISION STARS(5,NSTARS),MAGZERO

      INTEGER I,IX,IY,K,NPSF

      DO I=1,NSTARS
         IX=NINT(STARS(1,I))
         IY=NINT(STARS(2,I))

         IF(STARS(3,I).NE.0.0D0 .AND. STARS(5,I).GT.0.0D0) THEN
          IF(NPSF.GT.1) THEN
           WRITE(8,'(I6,1X,F7.2,1X,F7.2,1X,'//
     :         'F12.2,1X,F12.2,1X,F7.3,1X,I5)')
     :         I,(STARS(K,I),K=1,3),STARS(5,I),
     :         MAGZERO-2.5*DLOG10(STARS(5,I)),
     :         NINT(STARS(4,I))
          ELSE
           WRITE(8,'(I6,1X,F7.2,1X,F7.2,1X,'//
     :         'F12.2,1X,F12.2,1X,F7.3)')
     :         I,(STARS(K,I),K=1,3),STARS(5,I),
     :         MAGZERO-2.5*DLOG10(STARS(5,I))
          ENDIF
         ELSE
          IF(NPSF.GT.1) THEN
           WRITE(8,'(I6,1X,F7.2,1X,F7.2,1X,'//
     :         'F12.2,1X,F12.2,1X,F7.3,1X,I5)')
     :         I,(STARS(K,I),K=1,3),0.0D0,
     :         -100.0,NINT(STARS(4,I))
          ELSE
           WRITE(8,'(I6,1X,F7.2,1X,F7.2,1X,'//
     :         'F12.2,1X,F12.2,1X,F7.3)')
     :         I,(STARS(K,I),K=1,3),0.0D0,-100.0
          ENDIF
         ENDIF

      ENDDO

      END

      SUBROUTINE MULIM(A,B,NX,NY,OUT)
C
C Multiply an image by another
C
      IMPLICIT NONE

      INTEGER NX,NY,I,J
      DOUBLE PRECISION A(NX,NY),B(NX,NY),OUT(NX,NY)

      DO J=1,NY
         DO I=1,NX
            OUT(I,J)=A(I,J)*B(I,J)
         ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE ADDIM(A,B,NX,NY,OUT)
C
C Add an image to another
C
      IMPLICIT NONE

      INTEGER NX,NY,I,J
      DOUBLE PRECISION A(NX,NY),B(NX,NY),OUT(NX,NY)

      DO J=1,NY
         DO I=1,NX
            OUT(I,J)=A(I,J)+B(I,J)
         ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE ENTROP(PS,PHS,PHT,SMB,NX,NY,CH,SS,HH)
C
C Calculate the entropy and likelihood
C as well as filling the array CH. This
C version is for the stationary prior.
C
      IMPLICIT NONE

      INTEGER NX,NY
      DOUBLE PRECISION PS(NX,NY),PHS(NX,NY),PHT(NX,NY)
      DOUBLE PRECISION SMB,CH(NX,NY),SS,HH

      INTEGER I,J

      SS=0.0D0
      HH=0.0D0

      DO J=1,NY
         DO I=1,NX
            CH(I,J)=0.0D0
            IF(PS(I,J).GT.0.0D0)
     :        CH(I,J)=PS(I,J)/SMB*DLOG(PS(I,J)/SMB)
            SS=SS-CH(I,J)
            IF(PHS(I,J).GT.0.0D0) HH=HH+PHT(I,J)*
     :                              DLOG(PHS(I,J))
         ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE FNTROP(PS,PHS,PHT,PHP,NX,NY,CH,SS,HH)
C
C Calculate the entropy and likelihood
C as well as filling the array CH
C
C This version uses a floating prior
C
C NB - modified in version 0.6 for a simpler normalisation
C        Richard Hook, August 1994
C
C Note also that I use CH and Leon uses SF:
C
C CH(i,j) = PS(i,j)*SF(i,j)
C
      IMPLICIT NONE

      INTEGER NX,NY
      DOUBLE PRECISION PS(NX,NY),PHS(NX,NY),PHT(NX,NY)
      DOUBLE PRECISION CH(NX,NY),PHP(NX,NY),SS,HH

      INTEGER I,J

      SS=0.0D0
      HH=0.0D0

      DO J=1,NY
         DO I=1,NX
            CH(I,J)=0.0D0
            IF(PS(I,J).GT.0.0D0 .AND. PHP(I,J).GT.0.0D0)
     :        CH(I,J)=PS(I,J)*DLOG(PS(I,J)/PHP(I,J))
            SS=SS-CH(I,J)
            IF(PHS(I,J).GT.0.0D0) HH=HH+PHT(I,J)*
     :                              DLOG(PHS(I,J))
         ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE PNTROP(RHO,RHOP,NX,NY,TF,TT)
C
C Calculate the entropy for the PSF in the case
C of a regularized, modifyable PSF
C
      IMPLICIT NONE

      INTEGER NX,NY
      DOUBLE PRECISION RHO(NX,NY),RHOP(NX,NY)
      DOUBLE PRECISION TF(NX,NY),TT

      INTEGER I,J

      TT=0.0D0

      DO J=1,NY
         DO I=1,NX
            TF(I,J)=0.0D0
            IF(RHO(I,J).GT.0.0D0 .AND. RHOP(I,J).GT.0.0D0)
     :        TF(I,J)=DLOG(RHO(I,J)/RHOP(I,J))
            TT=TT-RHO(I,J)*TF(I,J)
         ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE RESINF(IM1,IM2,NX,NY,RMSRES,RESMAX,
     :                   IRMAX,JRMAX)
C
C Calculate the RMS residual between two images and the
C largest residual.
C
      IMPLICIT NONE
                   
      INTEGER NX,NY,IRMAX,JRMAX
      DOUBLE PRECISION RMSRES,RESMAX,IM1(NX,NY),IM2(NX,NY)
                                                          
      INTEGER I,J
      DOUBLE PRECISION RES,T
                            
      T=0.0D0
      RESMAX=0.0D0
                  
      DO J=1,NY
         DO I=1,NX
            RES=IM1(I,J)-IM2(I,J)
            T=T+RES*RES
            IF(DABS(RES).GT.DABS(RESMAX)) THEN
               RESMAX=RES
               IRMAX=I
               JRMAX=J
            ENDIF
         ENDDO
      ENDDO
           
      RMSRES=DSQRT(T/DBLE(NX*NY))
                                 
      RETURN
      END
         
      SUBROUTINE REBIN(IN,NX,NY,NBX,NBY)
C
C Re-bin an array by replacing groups of pixels by their
C average. This is needed in the sub-sampling case.
C Flux is conserved and the operation is done 'in place'
C
      IMPLICIT NONE
                   
      INTEGER NX,NY,NBX,NBY
      DOUBLE PRECISION IN(NX,NY)
                                
      INTEGER I,J,K,L
      DOUBLE PRECISION T,DN
                           
      DN=DBLE(NBX*NBY)
                      
      DO J=1,NY,NBY
         DO I=1,NX,NBX
            T=0D0
            DO L=1,NBY
               DO K=1,NBX
                  T=T+IN(I+K-1,J+L-1)
               ENDDO
            ENDDO
            DO L=1,NBY
               DO K=1,NBX
                  IN(I+K-1,J+L-1)=T/DN
               ENDDO
            ENDDO
         ENDDO
      ENDDO
           
      RETURN
      END
         
      SUBROUTINE ZAPNEG(DATA,NX,NY,NNEG,VMIN,VZAP)
C
C Find negative points in an array and set them to VZAP
C Also return the number of negative points and the smallest
C value.
C
      IMPLICIT NONE
                   
      INTEGER NX,NY,NNEG
      DOUBLE PRECISION DATA(NX,NY),VMIN,VZAP
      INTEGER I,J
                 
      NNEG=0
      VMIN=1.0D20
            
      DO J=1,NY
         DO I=1,NX
            IF(DATA(I,J).LT.0.0D0) THEN
               NNEG=NNEG+1
               IF(DATA(I,J).LT.VMIN) VMIN=DATA(I,J)
               DATA(I,J)=VZAP
            ENDIF
         ENDDO
      ENDDO
           
      RETURN
      END

      SUBROUTINE GETSTR(FILE,STARS,NX,NY,NPSF,
     :                  W,MAXSTR,MAGZERO,NSTARS,ISTAT)
C
C Read in a list of free format star positions (in pixels)
C
C Each line has four entries:
C  - the X position
C  - the Y position
C  - some sort of relative brightness expressed as a magnitude
C    relative to MAGZERO
C  - the number of the matching PSF (only if NPSF>1)
C
C Comments may be put in a line after a ! or #, blank lines
C are ignored.
C
      IMPLICIT NONE

      INTEGER MAXSTR,NSTARS,ISTAT,NX,NY,I,NPSF
      DOUBLE PRECISION STARS(5,MAXSTR),MAGZERO
      DOUBLE PRECISION W(NX,NY)
      CHARACTER*80 FILE,CHARS,LINE

      INTEGER N,IOS,NN

      ISTAT=0
      NSTARS=0

C First open the file
      OPEN(12,FILE=FILE,STATUS='OLD',IOSTAT=IOS)
      IF(IOS.NE.0) THEN
         CALL UMSPUT('! Unable to open star positions list file',
     :               1,0,ISTAT)
         ISTAT=1
         RETURN
      ENDIF

      N=0

C Read in the values until there are no more
      DO NN=1,MAXSTR+1000
         IF(N.EQ.MAXSTR+1) THEN
            CALL UMSPUT('! Too many stars!',1,0,ISTAT)
            ISTAT=1
            GO TO 99 
         ENDIF

C Read a line from the file
         READ(12,'(A80)',END=99) LINE 

C Remove comments
         DO I=1,80
            IF(LINE(I:I).EQ.'#' .OR.
     :         LINE(I:I).EQ.'!') THEN
               LINE(I:80)=' '
            ENDIF
         ENDDO

         IF(LINE.NE.' ') THEN
            N=N+1

C If there is only one PSF we don't try to get the PSF
C number, we just default it to 1
            IF(NPSF.GT.1) THEN
             READ(LINE,*,IOSTAT=IOS) (STARS(I,N),I=1,4)
            ELSE
             READ(LINE,*,IOSTAT=IOS) (STARS(I,N),I=1,3)
      write(chars,'('' Stars: '',i5,3f12.2)') n,(STARS(I,N),I=1,3)

      call umsput(chars,1,0,istat)
             STARS(4,N)=1.0D0
            ENDIF
 
            IF(IOS.NE.0) THEN
               CALL UMSPUT('! Error reading StarList file',
     :                     1,0,ISTAT)
               GO TO 99
            ENDIF

C Convert from magnitudes to fluxes
            STARS(3,N)=10.0**(-0.4*(STARS(3,N)-MAGZERO))

C Check for a star already there
            IF(W(NINT(STARS(1,N)),NINT(STARS(2,N))).NE.
     :         0.0D0) THEN
        write(chars,'('' W val: '',f12.4)') 
     :     W(NINT(STARS(1,N)),NINT(STARS(2,N)))
        call umsput(chars,1,0,istat)
               STARS(3,N)=0.0D0
               STARS(4,N)=0.0D0
               WRITE(CHARS,'(''! Warning duplicate star at '','//
     :          '''X: '',I4,'' Y: '',I4)') NINT(STARS(1,N)),
     :          NINT(STARS(2,N))
               CALL UMSPUT(CHARS,1,0,ISTAT)
            ENDIF

C Check for out of bounds stars
            IF(NINT(STARS(1,N)).LT.1 .OR.
     :         NINT(STARS(1,N)).GT.NX .OR.
     :         NINT(STARS(2,N)).LT.1 .OR.
     :         NINT(STARS(2,N)).GT.NY) THEN
               STARS(3,N)=0.0D0
               STARS(4,N)=0.0D0
               WRITE(CHARS,'(''! Warning, star '',I5,'//
     :           ''' is outside image, ignored.'')') N
               CALL UMSPUT(CHARS,1,0,ISTAT)
            ELSE
               W(NINT(STARS(1,N)),NINT(STARS(2,N)))=1.0D0
            ENDIF

            IF(NINT(STARS(4,N)).LT.0 .OR.
     :         NINT(STARS(4,N)).GT.NPSF) THEN
               STARS(3,N)=0.0D0
               STARS(4,N)=0.0D0
               WRITE(CHARS,'(''! Warning, star '',I5,'//
     :           ''' has invalid PSF number, ignored.'')') N
               CALL UMSPUT(CHARS,1,0,ISTAT)
            ENDIF

         ENDIF

         NSTARS=N
      ENDDO

99    CONTINUE
      CLOSE(12)

      RETURN
      END

      SUBROUTINE FGAUSS(IMAGE,NX,NY,GW)
C
C Fill the centre of an empty image with a 2d circular
C gaussian of sigma=GW. We go out as far as 5 sigma.
C
      IMPLICIT NONE

      INTEGER NX,NY
      DOUBLE PRECISION IMAGE(NX,NY),GW

C Local Variables etc
      DOUBLE PRECISION R2,S5S,T,DY,DX
      INTEGER I,J

      S5S=25.0D0*GW*GW
      T=0.0D0

      DO J=1,NY
         DY=DBLE(J-NY/2)
         DO I=1,NX
            DX=DBLE(I-NX/2)
            R2=DX*DX+DY*DY
            IF(R2.LT.S5S) THEN
               IMAGE(I,J)=EXP(-R2/(2.0D0*GW*GW))
               T=T+IMAGE(I,J)
            ELSE
               IMAGE(I,J)=0.0D0
            ENDIF
         ENDDO
      ENDDO

      DO J=1,NY
         DO I=1,NX
            IMAGE(I,J)=IMAGE(I,J)/T
         ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE FACCL(PHT,PS,DPS,PHS,DPHS,PHP,DPHP,
     :                NX,NY,CS,XL,VERBOSE)
C
C Calculate an optimum acceleration factor for point+smooth
C background restorations. This version has a floating prior.
C
C Based on a routine by Leon Lucy.
C
C Modified to use the simpler normalisation scheme, Dec 1994
C
C Removed the MODPSF flag, Mar 1998
C
      IMPLICIT NONE

      INTEGER NX,NY

      DOUBLE PRECISION PS(NX,NY),DPS(NX,NY)
      DOUBLE PRECISION PHS(NX,NY),DPHS(NX,NY)
      DOUBLE PRECISION PHP(NX,NY),DPHP(NX,NY)
      DOUBLE PRECISION PHT(NX,NY)
      DOUBLE PRECISION CS,XL,XLM1,XLM2,XLM3,SS,HH
      DOUBLE PRECISION XLP,XLU,DQ1,DQ2,QQ,XLM,PSD,PHSD
      DOUBLE PRECISION SS1,SS2,BB,PHPD,ET,TS,YL
      LOGICAL VERBOSE
      INTEGER ISTAT,I,J,NIT
      CHARACTER*80 CHARS

C First calculate the maximum possible acceleration within the 
C positivity restraint
      CALL MAXF(PS,DPS,NX,NY,XLM1)

C and now the same thing in the image plane
      CALL MAXF(PHS,DPHS,NX,NY,XLM2)

C and also for the floating prior
      CALL MAXF(PHP,DPHP,NX,NY,XLM3)

      XL=1.0D0

C We now need a 'safe' value for the acceleration - less than 
C the max permitted but still positive...
      XLM=DMIN1(XLM1,XLM2,XLM3)

      IF(VERBOSE) THEN
       WRITE(CHARS,
     : '(''--Max. acc. possible without introducing neg. values: '','//
     :      'F12.4)') XLM
       CALL UMSPUT(CHARS,1,0,ISTAT)
      ENDIF

      IF(XLM.GT.1.0D0) THEN
         XLU=1.0D0+0.9D0*(XLM-1.0D0)
      ELSE
         XLU=0.9*XLM
      ENDIF

      NIT=0

C Return here when iterating
45    CONTINUE

      NIT=NIT+1
      XLP=XL

C Derive the first and second derivatives w.r.t. the
C acceleration factor
      SS=0.0D0
      SS1=0.0D0
      SS2=0.0D0
      HH=0.0D0

      DO J=1,NY
         DO I=1,NX
           PSD=PS(I,J)+XL*DPS(I,J)
           PHSD=PHS(I,J)+XL*DPHS(I,J)
           PHPD=PHP(I,J)+XL*DPHP(I,J)

           IF(PHPD.GT.0.0D0 .AND. PSD.GT.0.0D0
     :         .AND. PHSD.GT.0.0D0) THEN
            YL=DLOG(PSD/PHPD)
            ET=DPHP(I,J)/PHPD
            TS=DPS(I,J)/PSD

            SS=SS-PSD*YL
            HH=HH+PHT(I,J)*DLOG(PHSD)

            SS2=SS2-PSD*(ET-TS)**2
            SS1=SS1-(YL+1.0D0)*DPS(I,J)+PSD*ET
           ENDIF
         ENDDO
      ENDDO

      DQ1=CS*SS1
      DQ2=CS*SS2

      DO J=1,NY
         DO I=1,NX
            IF(PHS(I,J)+XL*DPHS(I,J).NE.0.0D0) THEN
            BB=DPHS(I,J)/(PHS(I,J)+XL*DPHS(I,J))
            DQ1=DQ1+PHT(I,J)*BB
            DQ2=DQ2-PHT(I,J)*BB**2
            ENDIF
         ENDDO
      ENDDO

      XL=XL-DQ1/DQ2
      XL=DMIN1(XLU,XL)

      QQ=HH+CS*SS

C Write out some diagnostics
      IF(VERBOSE) THEN
       WRITE(CHARS,'(''---Iter: '',I3,'//
     :  ''' Accel: '',G15.5,'' Objective function: '',D20.12)')
     :         NIT,XL,QQ
       CALL UMSPUT(CHARS,1,0,ISTAT)
      ENDIF

C Check for acceleration going negative - if so reset to the 'safe'
C value
      IF(XL.LT.0.0D0) THEN
         CALL UMSPUT('! Warning, acceleration calculated is negative',
     :               1,0,ISTAT)
         XL=XLU
         IF(XL.GT.10.0D0) XL=1.0D0
      ELSE
          IF(DABS(XL-XLP).GT.0.01D0) GO TO 45
      ENDIF

      RETURN
      END

      SUBROUTINE MAXF(PS,DPS,NX,NY,XMAX)
C
C Calculate the maximum acceleration factor obtainable within
C the non-negativity constraint.
C
      INTEGER NX,NY
      DOUBLE PRECISION PS(NX,NY),DPS(NX,NY),XMAX,RT

      INTEGER I,J

      XMAX=1.0D30

      DO J=1,NY
         DO I=1,NX
            IF(DPS(I,J).EQ.0.0D0) GO TO 30
            RT=-PS(I,J)/DPS(I,J)
            IF(RT.LE.0.0D0) GO TO 30
            IF(RT.LT.XMAX) XMAX=RT

30          CONTINUE
         ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE CIDPSS(PS,PSM,CF,CH,NX,NY,CS,
     :                  SMB,SS,NSTARS,DPSS)
C
C Fill up the DPSS array.
C
C This is for the stationary prior case and is only needed
C if calculating the acceleration factors.
C
      IMPLICIT NONE

      INTEGER NX,NY,I,NSTARS,J
      DOUBLE PRECISION PS(NX,NY),DPSS(NX,NY),SMB,SS,VH,VS
      DOUBLE PRECISION CF(NX,NY),CH(NX,NY)
      DOUBLE PRECISION PSM(NX,NY),CS

C We handle the case of no stars separately
      IF(NSTARS.GT.0) THEN
       DO J=1,NY
          DO I=1,NX
             VH=PS(I,J)*(CF(I,J)-1.0D0)
             VS=CS*(-PS(I,J)*SS-CH(I,J))
     :         +PSM(I,J)*(CF(I,J)-1.0D0)
             DPSS(I,J)=VH+VS
          ENDDO
       ENDDO
      ELSE
       DO J=1,NY
          DO I=1,NX
             VH=PS(I,J)*(CF(I,J)-1.0D0)
             VS=CS*(-PS(I,J)*SS-CH(I,J))
             DPSS(I,J)=VH+VS
          ENDDO
       ENDDO
      ENDIF

      END

      SUBROUTINE FIDPSS(PS,PSM,CF,CFP,CH,NX,NY,CS,
     :                  SS,NSTARS,DPSS)
C
C Fill up the DPSS array.
C
C This is for the floating prior case and is only needed
C if calculating the acceleration factors.
C
C Belatedly modified for the new normalisation, Dec 94
C
      IMPLICIT NONE

      INTEGER NX,NY,I,J,NSTARS
      DOUBLE PRECISION PS(NX,NY),DPSS(NX,NY),SS,VH,VS,VM
      DOUBLE PRECISION CF(NX,NY),CH(NX,NY),CFP(NX,NY)
      DOUBLE PRECISION PSM(NX,NY),CS

C We handle the case of no stars separately
      IF(NSTARS.GT.0) THEN
       DO J=1,NY
          DO I=1,NX
             VH=PS(I,J)*(CF(I,J)-1.0D0)
             VS=CS*PS(I,J)*(CFP(I,J)-1.0D0)+
     :          CS*(-PS(I,J)*SS-CH(I,J))
             VM=PSM(I,J)*(CF(I,J)-1.0D0-CS*SS)
             DPSS(I,J)=VH+VS+VM
          ENDDO
       ENDDO
      ELSE
       DO J=1,NY
          DO I=1,NX
             VH=PS(I,J)*(CF(I,J)-1.0D0)
             VS=CS*PS(I,J)*(CFP(I,J)-1.0D0)+
     :          CS*(-PS(I,J)*SS-CH(I,J))
             DPSS(I,J)=VH+VS
          ENDDO
       ENDDO
      ENDIF

      END
  
      SUBROUTINE FILDPS(DPSS,PSM,CF,NX,NY,CS,SS,DPS)
C
C Fill up the DPS array from the DPSS one.
C
C This is only needed
C if calculating the acceleration factors.
C
C Also changed for the new normalisation, Jan 95
C
      IMPLICIT NONE

      INTEGER NX,NY,I,J
      DOUBLE PRECISION DPS(NX,NY),PSM(NX,NY)
      DOUBLE PRECISION CF(NX,NY),DPSS(NX,NY),CS,SS

      DO J=1,NY
         DO I=1,NX
            DPS(I,J)=DPSS(I,J)-PSM(I,J)*(CF(I,J)-1.0D0-CS*SS)
         ENDDO
      ENDDO

      END


      SUBROUTINE ACCL(PHT,PS,DPS,PHS,DPHS,NX,NY,CS,XL,
     :                VERBOSE)
C
C Calculate an optimum acceleration factor for point+smooth
C background restorations.
C
C Based on a routine by Leon Lucy.
C
      IMPLICIT NONE

      INTEGER NX,NY

      DOUBLE PRECISION PS(NX,NY),DPS(NX,NY)
      DOUBLE PRECISION PHS(NX,NY),DPHS(NX,NY)
      DOUBLE PRECISION PHT(NX,NY)
      DOUBLE PRECISION CS,XL,XLM1,XLM2,SS,HH,SGP,DSG
      DOUBLE PRECISION XLP,XLU,DQ1,DQ2,QQ,XLM,PSD,PHSD
      DOUBLE PRECISION SS1,SS2,BB

      INTEGER ISTAT,I,J,NIT
      CHARACTER*80 CHARS
      LOGICAL VERBOSE

C First calculate the maximum possible acceleration within the
C positivity restraint
      CALL MAXF(PS,DPS,NX,NY,XLM1)

C and now the same thing in the image plane
      CALL MAXF(PHS,DPHS,NX,NY,XLM2)

      XL=1.0D0

C We now need a 'safe' value for the acceleration - less than
C the max permitted but still positive...
      XLM=DMIN1(XLM1,XLM2)

      IF(VERBOSE) THEN
       WRITE(CHARS,
     :     '(''--Maximum acceleration within non-neg: '','//
     :     'F12.4)') XLM
       CALL UMSPUT(CHARS,1,0,ISTAT)
      ENDIF

      IF(XLM.GT.1.0D0) THEN
         XLU=1.0D0+0.9D0*(XLM-1.0D0)
      ELSE
         XLU=0.9*XLM
      ENDIF

C Here we do another check - if this value is really very big
C it is likely that we are very close to convergence and using it
C directly will be more harm than good. So we rather arbitrarily
C default to 1.0
      IF(XLU.GT.100.0D0) XLU=1.0D0

      NIT=0

C Return here when iterating
45    CONTINUE

      NIT=NIT+1
      XLP=XL

C Derive the first and second derivatives w.r.t. the
C acceleration factor
      SS=0.0D0
      HH=0.0D0
      SGP=0.0D0
      DSG=0.0D0

      DO J=1,NY
         DO I=1,NX
            SGP=SGP+PS(I,J)+XL*DPS(I,J)
            DSG=DSG+DPS(I,J)
         ENDDO
      ENDDO

      DO J=1,NY
         DO I=1,NX
            PSD=PS(I,J)+XL*DPS(I,J)
            PHSD=PHS(I,J)+XL*DPHS(I,J)

            IF(PSD.GT.0.0D0 .AND. SGP.NE.0.0D0) 
     :            SS=SS-PSD/SGP*DLOG(PSD/SGP)
            IF(PHSD.GT.0.0D0) HH=HH+PHT(I,J)*DLOG(PHSD)
         ENDDO
      ENDDO

      SS1=-SS*DSG/SGP

      DO J=1,NY
         DO I=1,NX
            PSD=PS(I,J)+XL*DPS(I,J)
            IF(PSD.GT.0.0D0 .AND. SGP.NE.0.0D0) 
     :         SS1=SS1-DPS(I,J)*DLOG(PSD/SGP)/SGP
         ENDDO
      ENDDO
             
      SS2=-2.0D0*DSG/SGP*SS1+DSG**2/SGP**2

      DO J=1,NY
         DO I=1,NX
            PSD=PS(I,J)+XL*DPS(I,J)
            IF(PSD.NE.0.0D0) SS2=SS2-(DPS(I,J)/SGP)**2/
     :         ((PS(I,J)+XL*DPS(I,J))/SGP)
         ENDDO
      ENDDO

      DQ1=CS*SS1
      DQ2=CS*SS2

      DO J=1,NY
         DO I=1,NX
            BB=DPHS(I,J)/(PHS(I,J)+XL*DPHS(I,J))
            DQ1=DQ1+PHT(I,J)*BB
            DQ2=DQ2-PHT(I,J)*BB**2
         ENDDO
      ENDDO

      XL=XL-DQ1/DQ2
      XL=DMIN1(XLU,XL)

      QQ=HH+CS*SS

C Write out some diagnostics
      IF(VERBOSE) THEN
       WRITE(CHARS,'(''---Iter: '',I3,'//
     :     ''' Accel: '',G15.5,'' Objective function: '','//
     :     'D20.12)')
     :         NIT,XL,QQ
       CALL UMSPUT(CHARS,1,0,ISTAT)
      ENDIF

C Check for acceleration going negative - if so reset to the 'safe'
C value
      IF(XL.LT.0.0D0) THEN
         CALL UMSPUT('! Warning, acceleration calculated is negative',
     :               1,0,ISTAT)
         XL=XLU
      ELSE 
         IF(DABS(XL-XLP).GT.0.01D0) GO TO 45
      ENDIF

      RETURN
      END

      SUBROUTINE COPYIM(IN,NX,NY,OUT)
C
C Copy an image to another of the same size
C
      IMPLICIT NONE

      INTEGER NX,NY
      DOUBLE PRECISION IN(NX,NY),OUT(NX,NY)

      INTEGER I,J

      DO J=1,NY
         DO I=1,NX
            OUT(I,J)=IN(I,J)
         ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE INCPSF(RHO,CG,TF,DRHO,CT,TT,NX,NY)
C
C Increment for the PSF when it is being regularized
C From Leon Lucy Code, August 1994
C
      IMPLICIT NONE

      INTEGER NX,NY
      DOUBLE PRECISION RHO(NX,NY),CG(NX,NY),TF(NX,NY)
      DOUBLE PRECISION DRHO(NX,NY)
      DOUBLE PRECISION CT,TT

      DOUBLE PRECISION DRHH,DRHT,DRT,XLM,XL
      CHARACTER*80 CHARS
      INTEGER I,J,ISTAT

      DO J=1,NY
         DO I=1,NX
            DRHH=RHO(I,J)*(CG(I,J)-1.0D0)
            DRT=-TF(I,J)-1.0D0
            DRHT=CT*RHO(I,J)*(DRT-TT+1.0D0)
            DRHO(I,J)=DRHH+DRHT
         ENDDO
      ENDDO

C Find the maximum possible acceleration in the usual way
      CALL MAXF(RHO,DRHO,NX,NY,XLM)

C Display the maximum value
      WRITE(CHARS,'(''-Max. PSF acc.: '',G10.3)') XLM
      CALL UMSPUT(CHARS,1,0,ISTAT)

C Work out a sensible and safe value
      XL=DMIN1(0.9D0*XLM,1.0D0)

      WRITE(CHARS,'(''-Using PSF acc.: '',G10.3)') XL
      CALL UMSPUT(CHARS,1,0,ISTAT)

C and apply it
      DO J=1,NY
         DO I=1,NX
            RHO(I,J)=RHO(I,J)+XL*DRHO(I,J)
         ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE SMOOTH(IN,OUT,NX,NY,SIG)
C
C Simple smoothing using direct convolution and a box size
C of 7 by 7 - ie only usable for small SIG
C
      IMPLICIT NONE

      INTEGER NX,NY,I,J
      DOUBLE PRECISION IN(NX,NY),OUT(NX,NY),SIG,BOX(7,7)
      DOUBLE PRECISION X,Y,T

C First fill the box
      T=0.0D0
      DO J=1,7
         Y=DBLE(J-3)
         DO I=1,7
            X=DBLE(I-3)
            BOX(I,J)=EXP(-(X*X+Y*Y)/(2.0D0*SIG*SIG))
            T=T+BOX(I,J)
         ENDDO
      ENDDO

C Normalise
      DO J=1,7
         DO I=1,7
            BOX(I,J)=BOX(I,J)/T
         ENDDO
      ENDDO

C Convolve
      CALL DIRCON(IN,NX,NY,BOX,7,7,OUT,1)

      RETURN
      END

      SUBROUTINE CHKSUB(DATA,NX,NY,NBX,NBY,ISTAT)
C
C Check the the data sub-sampling is correct - we just look
C at the first few pixels
C
      IMPLICIT NONE

      INTEGER NX,NY,NBX,NBY,I,J,ISTAT
      DOUBLE PRECISION DATA(NX,NY),V

      ISTAT=0

      V=DATA(1,1)
      DO J=1,NBY
         DO I=1,NBX
            IF(DATA(I,J).NE.V) THEN
               ISTAT=1
               RETURN
            ENDIF
         ENDDO
      ENDDO
    
      RETURN 
      END

C*AMOEBA ... downhill simplex fitting program
C+
	SUBROUTINE AMOEBA(P,Y,MP,NP,NDIM,FTOL,FUNK,ITER)
*
* adjust parameters to minimize value of a function
*
* input:
*	P	R4(MP,NP)	simplex vertices
*	Y	R4(NDIM+1)	function value at each vertex
*	MP	I4		max number of vertices
*	NP	I4		max number of parameters
*	NDIM	I4		actual number of parameters
*	FTOL	R4		relative tolerance for convergence
*	ITER	I4		maximum iterations
* output:
*	P	R4(MP,NP)	final vertices of simplex
*	Y	R4(NDIM+1)	FUNK values at each vertex
*	ITER	I4		number of iterations
C--
*
* May 1989 Keith Horne @ STScI - adapted from Numerical Recipes
* May 1989 KDH @ STScI - modified convergence test ala Kip Kuntz.
* Jun 1989 KDH @ STScI - convergence messages to terminal.
*
	PARAMETER (NMAX=100)
	DIMENSION P(MP,NP),Y(MP),PR(NMAX),PRR(NMAX),PBAR(NMAX)
	LOGICAL CONTRACT
	EXTERNAL FUNK
C
	ALPHA=1.0
	BETA=0.5
	GAMMA=2.0
	ITMAX = ITER
	MPTS=NDIM+1
	ITER=0
1	ILO=1
	IF(Y(1).GT.Y(2))THEN
		IHI=1
		INHI=2
	ELSE
		IHI=2
		INHI=1
	ENDIF
	DO I=1,MPTS
		IF(Y(I).LT.Y(ILO)) ILO=I
		IF(Y(I).GT.Y(IHI))THEN
			INHI=IHI
			IHI=I
		ELSE IF(Y(I).GT.Y(INHI))THEN
			IF(I.NE.IHI) INHI=I
		ENDIF
	ENDDO

	RTOL=2.*ABS(Y(IHI)-Y(ILO))/(ABS(Y(IHI))+ABS(Y(ILO)))

* converge if chi^2 range is small last operation is contraction

      IF( RTOL.LT.FTOL ) then
      IF( CONTRACT ) THEN
	WRITE(*,*) 'Amoeba converged. Function range', RTOL, ' <', FTOL
	GOTO 1000
      END IF

* converge if precision limit reached in all parameters

	TMAX = 0
	PRECISE = 1E-7
      DO I=1,NDIM
	TEST = ABS( P(I,IHI) ) + ABS( P(I,ILO) )
      IF( TEST.GE. PRECISE ) THEN
	TEST = ABS( P(I,IHI) - P(I,ILO) )
     #		/ ( ABS( P(I,IHI) ) + ABS( P(I,ILO) ) )
      END IF	
	TMAX = MAX( TMAX, TEST )
      END DO
      IF( TMAX .LT. PRECISE ) THEN
	WRITE(*,*) 'Amoeba converged. Parameter range', TMAX, ' <', PRECISE
	GOTO 1000
      END IF
      END IF

* converge if maximum iterations exceeded

      IF(ITER.EQ.ITMAX) THEN
      IF( ITMAX.GT.1 ) THEN
	WRITE(*,*) 'Amoeba iteration count exceeded.', ITER
      END IF
	GOTO 1000
      END IF
	CONTRACT = .FALSE.
	ITER=ITER+1
	DO J=1,NDIM
		PBAR(J)=0.
	ENDDO
	DO I=1,MPTS
		IF(I.NE.IHI)THEN
			DO J=1,NDIM
				PBAR(J)=PBAR(J)+P(I,J)
			ENDDO
		ENDIF
	ENDDO
	DO J=1,NDIM
		PBAR(J)=PBAR(J)/NDIM
		PR(J)=(1.+ALPHA)*PBAR(J)-ALPHA*P(IHI,J)
	ENDDO
	YPR=FUNK(PR)
	IF(YPR.LE.Y(ILO))THEN
		DO J=1,NDIM
			PRR(J)=GAMMA*PR(J)+(1.-GAMMA)*PBAR(J)
		ENDDO
		YPRR=FUNK(PRR)
		IF(YPRR.LT.Y(ILO))THEN
			DO J=1,NDIM
				P(IHI,J)=PRR(J)
			ENDDO
			Y(IHI)=YPRR
		ELSE
			DO J=1,NDIM
				P(IHI,J)=PR(J)
			ENDDO
			Y(IHI)=YPR
		ENDIF
	ELSE IF(YPR.GE.Y(INHI))THEN
		IF(YPR.LT.Y(IHI))THEN
			DO J=1,NDIM
				P(IHI,J)=PR(J)
			ENDDO
			Y(IHI)=YPR
		ENDIF
		DO J=1,NDIM
			PRR(J)=BETA*P(IHI,J)+(1.-BETA)*PBAR(J)
		ENDDO
		YPRR=FUNK(PRR)
		IF(YPRR.LT.Y(IHI))THEN
			DO J=1,NDIM
				P(IHI,J)=PRR(J)
			ENDDO
			Y(IHI)=YPRR
		ELSE
			contract = .true.
			DO I=1,MPTS
				IF(I.NE.ILO)THEN
					DO J=1,NDIM
						PR(J)=0.5*(P(I,J)+P(ILO,J))
						P(I,J)=PR(J)
					ENDDO
					Y(I)=FUNK(PR)
				ENDIF
			ENDDO
		ENDIF
	ELSE
		DO J=1,NDIM
			P(IHI,J)=PR(J)
		ENDDO
		Y(IHI)=YPR
	ENDIF
	GO TO 1

* normal return

 1000	RETURN
	END

C----------------------------------------------------------------------
        subroutine ftgdes(iunit,colnum,rownum,nelem,offset,status)

C       read the descriptor values from a binary table.  This is only
C       used for column which have TFORMn = 'P', i.e., for variable
C       length arrays.

C       iunit   i  fortran unit number
C       colnum  i  number of the column to read
C       rownum  i  number of the row to read
C       nelem   i  output number of elements
C       offset  i  output byte offset of the first element
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, Nov 1991

        integer iunit,colnum,rownum,nelem,offset,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,bstart,iray(2)

        if (status .gt. 0)return
        if (rownum .lt. 1)then
C               error: illegal row number
                status=307
                return
        end if

        ibuff=bufnum(iunit)

C       check that this is really a 'P' type column
        if (tdtype(colnum+tstart(ibuff)) .ge. 0)then
                status=317
                return
        end if

C       move to the specified column and row:
        bstart=dtstrt(ibuff)+(rownum-1)*rowlen(ibuff)
     &         +tbcol(colnum+tstart(ibuff))
        call ftmbyt(iunit,bstart,.true.,status)

C       now read the number of elements and the offset to the table:
        call ftgi4b(iunit,2,0,iray,status)
        nelem=iray(1)
        offset=iray(2)
        end

C--------------------------------------------------------------------------
        subroutine ftirow(iunit,frow,nrows,status)

C       insert NROWS blank rows immediated after row FROW

C       iunit   i  Fortran I/O unit number
C       frow    i  row number after which the new rows will be inserted.
C                  Specify  0 to add rows to the beginning of the table.
C       nrows   i  number of rows to add to the table (must be greater than 0)
C       status  i  returned error status (0=ok)

        integer iunit,frow,nrows,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,naxis1,naxis2,size,freesp,nblock
        character comm*8

        if (status .gt. 0)return

C       define the number of the buffer used for this file
        ibuff=bufnum(iunit)

C       test that the CHDU is an ASCII table or BINTABLE
        if (hdutyp(ibuff) .ne. 1 .and. hdutyp(ibuff) .ne. 2)then
                status=235
                call ftpmsg('Can only add rows to TABLE or BINTABLE '//
     &          'extension (FTIROW)')
                return
        end if

        if (nrows .lt. 0)then
                 status=306
                 call ftpmsg('Cannot insert negative number of ' //
     &           'rows in the table (FTIROW)')
                 return
        else if (nrows .eq. 0)then
                 return
        end if

C       get current size of the table
        call ftgkyj(iunit,'NAXIS1',naxis1,comm,status)
        call ftgkyj(iunit,'NAXIS2',naxis2,comm,status)

        if (frow .gt. naxis2)then
                status=307
                call ftpmsg('Insert position is greater than the '//
     &            'number of rows in the table (FTIROW)') 
                return
        else if (frow .lt. 0)then
                status=307
                call ftpmsg('Insert starting row number is less than 0'
     &          //' (FTIROW)')
                return
        end if
        
C       Calculate how many more FITS blocks (2880 bytes) need to be added
        size=theap(ibuff)+scount(ibuff)
        freesp=((size+2879)/2880)*2880 - size
        size=naxis1*nrows-freesp
        nblock=(size+2879)/2880

C       insert the needed number of new FITS blocks
        if (nblock .gt. 0)call ftiblk(iunit,nblock,1,status)

C       shift the heap down, and update pointers to start of heap
        size=naxis1*nrows
        call fthpdn(iunit,size,status)

C       shift the rows down
        call ftrwdn(iunit,frow,naxis2,nrows,status)

C       update the NAXIS2 keyword
        naxis2=naxis2+nrows
        call ftmkyj(iunit,'NAXIS2',naxis2,'&',status)
        end

C----------------------------------------------------------------------
        subroutine fti1r8(input,n,scale,zero,tofits,
     &          chktyp,chkval,setval,flgray,anynul,output,status)

C       copy input i*1 values to output r*8 values, doing optional
C       scaling and checking for null values

C       input   c*1 input array of values
C       n       i  number of values 
C       scale   d  scaling factor to be applied
C       zero    d  scaling zero point to be applied
C       tofits  l  true if converting from internal format to FITS
C       chktyp  i  type of null value checking to be done if TOFITS=.false.
C                       =0  no checking for null values
C                       =1  set null values = SETVAL
C                       =2  set corresponding FLGRAY value = .true.
C       chkval  c*1 value in the input array that is used to indicated nulls
C       setval  d   value to set output array to if value is undefined
C       flgray  l   array of logicals indicating if corresponding value is null
C       anynul  l   set to true if any nulls were set in the output array
C       output  d   returned array of values

        character*1 input(*),chkval
        double precision output(*),setval
        integer n,i,chktyp,status,itemp
        double precision scale,zero
        logical tofits,flgray(*),anynul,noscal

        if (status .gt. 0)return

        if (scale .eq. 1. .and. zero .eq. 0)then
                noscal=.true.
        else
                noscal=.false.
        end if
        
        if (tofits) then
C               we don't have to worry about null values when writing to FITS
                if (noscal)then
                        do 10 i=1,n
                                itemp=ichar(input(i))
                                if (itemp .lt. 0)itemp=itemp+256
                                output(i)=itemp
10                      continue
                else
                        do 20 i=1,n
                                itemp=ichar(input(i))
                                if (itemp .lt. 0)itemp=itemp+256
                                output(i)=(itemp-zero)/scale
20                      continue
                end if
        else
C               converting from FITS to internal format; may have to check nulls
                if (chktyp .eq. 0)then
C                       don't have to check for nulls
                        if (noscal)then
                                do 30 i=1,n
                                        itemp=ichar(input(i))
                                        if (itemp .lt. 0)itemp=itemp+256
                                        output(i)=itemp
30                              continue
                        else
                                do 40 i=1,n
                                  itemp=ichar(input(i))
                                  if (itemp .lt. 0)itemp=itemp+256
                                  output(i)=itemp*scale+zero
40                              continue
                        end if
                else 
C                       must test for null values
                        if (noscal)then
                                do 50 i=1,n
                                        if (input(i) .eq. chkval)then
                                            anynul=.true.
                                            if (chktyp .eq. 1)then
                                                output(i)=setval
                                            else
                                                flgray(i)=.true.
                                            end if
                                        else
                                            itemp=ichar(input(i))
                                        if (itemp .lt. 0)itemp=itemp+256
                                            output(i)=itemp
                                        end if
50                              continue
                        else
                                do 60 i=1,n
                                        if (input(i) .eq. chkval)then
                                            anynul=.true.
                                            if (chktyp .eq. 1)then
                                                output(i)=setval
                                            else
                                                flgray(i)=.true.
                                            end if
                                        else
                                  itemp=ichar(input(i))
                                  if (itemp .lt. 0)itemp=itemp+256
                                  output(i)=itemp*scale+zero
                                        end if
60                              continue
                        end if
                end if
        end if
        end

C--------------------------------------------------------------------------
        subroutine ftgkyd(iunit,keywrd,dval,comm,status)

C       read a double precision value and comment string from a header record 
C
C       iunit   i  fortran input unit number
C       keywrd  c  keyword name   
C       OUTPUT PARAMETERS:
C       dval    i  output keyword value 
C       comm    c  output keyword comment
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        character*(*) keywrd,comm
        integer iunit,status
        character value*35
        double precision dval

C       find the keyword and return value and comment as character strings
        call ftgkey(iunit,keywrd,value,comm,status)

C       convert character string to double precision
C       datatype conversion will be performed if necessary and if possible
        call ftc2d(value,dval,status)
        end

C--------------------------------------------------------------------------
        subroutine ftukyl(ounit,keywrd,logval,comm,status)

C       update a logical value header record 
C
C       ounit   i  fortran output unit number
C       keywrd  c  keyword name    ( 8 characters, cols.  1- 8)
C       logval  l  keyword value 
C       comm    c  keyword comment (47 characters, cols. 34-80)
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, Oct 1994

        character*(*) keywrd,comm
        integer ounit,status,tstat
        logical logval

        if (status .gt. 0)return
        tstat=status

C       try modifying the keyword, if it exists
        call ftmkyl(ounit,keywrd,logval,comm,status)

        if (status .eq. 202)then
C               keyword doesn't exist, so create it
                status=tstat
                call ftpkyl(ounit,keywrd,logval,comm,status)
        end if
        end

C----------------------------------------------------------------------
        subroutine ftc2dd(cval,val,status)

C       convert a character string to double prec.
C       (assumes that the input string is left justified)
C       cval    c  input character string to be converted 
C       val     d  output value 
C       status  i  output error status (0 = OK)

        character*(*) cval
        double precision val
        integer status,nleng
        character iform*8,sval*16

        if (status .gt. 0)return

C       find length of the input double character string
        nleng=index(cval,' ')-1
        if (nleng .eq. -1)nleng=len(cval)

C       construct the format statement to read the character string
        if (nleng .le. 9)then
                write(iform,1000)nleng
1000            format('(F',I1,'.0)')
        else
                write(iform,1001)nleng
1001            format('(F',I2,'.0)')
        end if

        read(cval,iform,err=900)val
        return

900     status=409
        sval=cval
        call ftpmsg('Error in FTC2DD evaluating this string '//
     &       'as a double: '//sval)
        end

C--------------------------------------------------------------------------
        subroutine ftpkyg(ounit,keywrd,dval,decim,comm,status)

C       write a double precision value to a header record in F format
C
C       ounit   i  fortran output unit number
C       keywrd  c  keyword name    ( 8 characters, cols.  1- 8)
C       dval    d  keyword value 
C       decim   i  number of decimal places to display in value field
C       comm    c  keyword comment (47 characters, cols. 34-80)
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        character*(*) keywrd,comm
        double precision dval
        integer ounit,status,decim
        character value*20

C       convert double precision to F format character string
        call ftd2f(dval,decim,value,status)

C       write the keyword record
        call ftpkey(ounit,keywrd,value,comm,status)
        end

*  FFTPACK code obtained by Chris Biemesderfer from Argonne National Lab
*  math library over Arpanet (via netlib@argonne).  Written at NCAR by
*  Paul Swarztrauber in Apr 85.
*  Caveat receptor.  (Jack) dongarra@anl-mcs, (Eric Grosse) research!ehg
*  Compliments of netlib   Fri Jun 12 13:42:13 CDT 1987
*
*  Array size declarations changed from (1) to (*) for dummy arguments
*  by Phil Hodge on 15-Feb-1993.
*
*  Subroutines cffti1, cfftf1, and cfftb1 had an ifac argument, which was
*  the last 15 elements of the wsave array, except that it was integer
*  intead of real.  When these subroutines were called, the actual
*  argument was real, and the type mismatch resulted in error messages
*  from the compiler.  In these three subroutines, the dummy argument has
*  been renamed to xxifac, and local arrays rfac and jfac have been added.
*  These two arrays are of length 15 and are equivalenced to each other.
*  The contents of xxifac are now copied from (to) rfac in cffti1 (cfftf1
*  and cfftb1), and "ifac" is now replaced by "jfac" in expressions in the
*  body of these subroutines.  The array size 15 was chosen based on the
*  statement in the next paragraph regarding the size of the WSAVE array.
*  Phil Hodge, 12-Oct-2005.
*
*  The forward and backward Fourier transform routines are CFFTF and CFFTB
*  respectively.  Before using either of these, an array WSAVE of trig
*  coefficients must first be computed by calling CFFTI.  This array needs
*  to be recomputed only if the number of points to be transformed is changed.
*  The length of this array is 15 + 4*N.
*
*  Usage is as follows:
*
*  	call cffti (n, wsave)
*  	call cfftf (n, c, wsave)
*  	call cfftb (n, c, wsave)
*
*  	integer n		! length of array c
*  	real	wsave(15+4*n)	! work array of trig coefficients
*  	complex c(n)		! array to be transformed in-place
*
*  The length N is input to all routines.  The work array WSAVE is output
*  from CFFTI and input to CFFTF & CFFTB.  The complex array C is both
*  input and output for CFFTF & CFFTB.
*
*  This file contains the following subroutines, of which the first three
*  are the high-level routines:
*
*	cffti
*	cfftf
*	cfftb
*	cffti1
*	cfftf1
*	cfftb1
*	passf
*	passf2
*	passf3
*	passf4
*	passf5
*	passb
*	passb2
*	passb3
*	passb4
*	passb5


      subroutine cffti (n,wsave)
      dimension       wsave(*)
      if (n .eq. 1) return
      iw1 = n+n+1
      iw2 = iw1+n+n
      call cffti1 (n,wsave(iw1),wsave(iw2))
      return
      end

      subroutine cfftf (n,c,wsave)
      dimension       c(*)       ,wsave(*)
      if (n .eq. 1) return
      iw1 = n+n+1
      iw2 = iw1+n+n
      call cfftf1 (n,c,wsave,wsave(iw1),wsave(iw2))
      return
      end

      subroutine cfftb (n,c,wsave)
      dimension       c(*)       ,wsave(*)
      if (n .eq. 1) return
      iw1 = n+n+1
      iw2 = iw1+n+n
      call cfftb1 (n,c,wsave,wsave(iw1),wsave(iw2))
      return
      end

      subroutine cffti1 (n,wa,xxifac)
      dimension       wa(*)      ,xxifac(*)    ,ntryh(4)
      dimension rfac(15), jfac(15)
      equivalence (rfac(1), jfac(1))
      data ntryh(1),ntryh(2),ntryh(3),ntryh(4)/3,4,2,5/
      nl = n
      nf = 0
      j = 0
  101 j = j+1
      if (j-4) 102,102,103
  102 ntry = ntryh(j)
      go to 104
  103 ntry = ntry+2
  104 nq = nl/ntry
      nr = nl-ntry*nq
      if (nr) 101,105,101
  105 nf = nf+1
      jfac(nf+2) = ntry
      nl = nq
      if (ntry .ne. 2) go to 107
      if (nf .eq. 1) go to 107
      do 106 i=2,nf
         ib = nf-i+2
         jfac(ib+2) = jfac(ib+1)
  106 continue
      jfac(3) = 2
  107 if (nl .ne. 1) go to 104
      jfac(1) = n
      jfac(2) = nf
      tpi = 6.28318530717959
      argh = tpi/float(n)
      i = 2
      l1 = 1
      do 110 k1=1,nf
         ip = jfac(k1+2)
         ld = 0
         l2 = l1*ip
         ido = n/l2
         idot = ido+ido+2
         ipm = ip-1
         do 109 j=1,ipm
            i1 = i
            wa(i-1) = 1.
            wa(i) = 0.
            ld = ld+l1
            fi = 0.
            argld = float(ld)*argh
            do 108 ii=4,idot,2
               i = i+2
               fi = fi+1.
               arg = fi*argld
               wa(i-1) = cos(arg)
               wa(i) = sin(arg)
  108       continue
            if (ip .le. 5) go to 109
            wa(i1-1) = wa(i-1)
            wa(i1) = wa(i)
  109    continue
         l1 = l2
  110 continue
      do 901 i = 1, 15
         xxifac(i) = rfac(i)
  901 continue
      return
      end

      subroutine cfftf1 (n,c,ch,wa,xxifac)
      dimension       ch(*)      ,c(*)       ,wa(*)      ,xxifac(*)
      dimension rfac(15), jfac(15)
      equivalence (rfac(1), jfac(1))
      do 901 i = 1, 15
         rfac(i) = xxifac(i)
  901 continue
      nf = jfac(2)
      na = 0
      l1 = 1
      iw = 1
      do 116 k1=1,nf
         ip = jfac(k1+2)
         l2 = ip*l1
         ido = n/l2
         idot = ido+ido
         idl1 = idot*l1
         if (ip .ne. 4) go to 103
         ix2 = iw+idot
         ix3 = ix2+idot
         if (na .ne. 0) go to 101
         call passf4 (idot,l1,c,ch,wa(iw),wa(ix2),wa(ix3))
         go to 102
  101    call passf4 (idot,l1,ch,c,wa(iw),wa(ix2),wa(ix3))
  102    na = 1-na
         go to 115
  103    if (ip .ne. 2) go to 106
         if (na .ne. 0) go to 104
         call passf2 (idot,l1,c,ch,wa(iw))
         go to 105
  104    call passf2 (idot,l1,ch,c,wa(iw))
  105    na = 1-na
         go to 115
  106    if (ip .ne. 3) go to 109
         ix2 = iw+idot
         if (na .ne. 0) go to 107
         call passf3 (idot,l1,c,ch,wa(iw),wa(ix2))
         go to 108
  107    call passf3 (idot,l1,ch,c,wa(iw),wa(ix2))
  108    na = 1-na
         go to 115
  109    if (ip .ne. 5) go to 112
         ix2 = iw+idot
         ix3 = ix2+idot
         ix4 = ix3+idot
         if (na .ne. 0) go to 110
         call passf5 (idot,l1,c,ch,wa(iw),wa(ix2),wa(ix3),wa(ix4))
         go to 111
  110    call passf5 (idot,l1,ch,c,wa(iw),wa(ix2),wa(ix3),wa(ix4))
  111    na = 1-na
         go to 115
  112    if (na .ne. 0) go to 113
         call passf (nac,idot,ip,l1,idl1,c,c,c,ch,ch,wa(iw))
         go to 114
  113    call passf (nac,idot,ip,l1,idl1,ch,ch,ch,c,c,wa(iw))
  114    if (nac .ne. 0) na = 1-na
  115    l1 = l2
         iw = iw+(ip-1)*idot
  116 continue
      if (na .eq. 0) return
      n2 = n+n
      do 117 i=1,n2
         c(i) = ch(i)
  117 continue
      return
      end

      subroutine cfftb1 (n,c,ch,wa,xxifac)
      dimension       ch(*)      ,c(*)       ,wa(*)      ,xxifac(*)
      dimension rfac(15), jfac(15)
      equivalence (rfac(1), jfac(1))
      do 901 i = 1, 15
         rfac(i) = xxifac(i)
  901 continue
      nf = jfac(2)
      na = 0
      l1 = 1
      iw = 1
      do 116 k1=1,nf
         ip = jfac(k1+2)
         l2 = ip*l1
         ido = n/l2
         idot = ido+ido
         idl1 = idot*l1
         if (ip .ne. 4) go to 103
         ix2 = iw+idot
         ix3 = ix2+idot
         if (na .ne. 0) go to 101
         call passb4 (idot,l1,c,ch,wa(iw),wa(ix2),wa(ix3))
         go to 102
  101    call passb4 (idot,l1,ch,c,wa(iw),wa(ix2),wa(ix3))
  102    na = 1-na
         go to 115
  103    if (ip .ne. 2) go to 106
         if (na .ne. 0) go to 104
         call passb2 (idot,l1,c,ch,wa(iw))
         go to 105
  104    call passb2 (idot,l1,ch,c,wa(iw))
  105    na = 1-na
         go to 115
  106    if (ip .ne. 3) go to 109
         ix2 = iw+idot
         if (na .ne. 0) go to 107
         call passb3 (idot,l1,c,ch,wa(iw),wa(ix2))
         go to 108
  107    call passb3 (idot,l1,ch,c,wa(iw),wa(ix2))
  108    na = 1-na
         go to 115
  109    if (ip .ne. 5) go to 112
         ix2 = iw+idot
         ix3 = ix2+idot
         ix4 = ix3+idot
         if (na .ne. 0) go to 110
         call passb5 (idot,l1,c,ch,wa(iw),wa(ix2),wa(ix3),wa(ix4))
         go to 111
  110    call passb5 (idot,l1,ch,c,wa(iw),wa(ix2),wa(ix3),wa(ix4))
  111    na = 1-na
         go to 115
  112    if (na .ne. 0) go to 113
         call passb (nac,idot,ip,l1,idl1,c,c,c,ch,ch,wa(iw))
         go to 114
  113    call passb (nac,idot,ip,l1,idl1,ch,ch,ch,c,c,wa(iw))
  114    if (nac .ne. 0) na = 1-na
  115    l1 = l2
         iw = iw+(ip-1)*idot
  116 continue
      if (na .eq. 0) return
      n2 = n+n
      do 117 i=1,n2
         c(i) = ch(i)
  117 continue
      return
      end

      subroutine passf (nac,ido,ip,l1,idl1,cc,c1,c2,ch,ch2,wa)
      dimension       ch(ido,l1,ip)          ,cc(ido,ip,l1)          ,
     1                c1(ido,l1,ip)          ,wa(*)      ,c2(idl1,ip),
     2                ch2(idl1,ip)
      idot = ido/2
      nt = ip*idl1
      ipp2 = ip+2
      ipph = (ip+1)/2
      idp = ip*ido
c
      if (ido .lt. l1) go to 106
      do 103 j=2,ipph
         jc = ipp2-j
         do 102 k=1,l1
            do 101 i=1,ido
               ch(i,k,j) = cc(i,j,k)+cc(i,jc,k)
               ch(i,k,jc) = cc(i,j,k)-cc(i,jc,k)
  101       continue
  102    continue
  103 continue
      do 105 k=1,l1
         do 104 i=1,ido
            ch(i,k,1) = cc(i,1,k)
  104    continue
  105 continue
      go to 112
  106 do 109 j=2,ipph
         jc = ipp2-j
         do 108 i=1,ido
            do 107 k=1,l1
               ch(i,k,j) = cc(i,j,k)+cc(i,jc,k)
               ch(i,k,jc) = cc(i,j,k)-cc(i,jc,k)
  107       continue
  108    continue
  109 continue
      do 111 i=1,ido
         do 110 k=1,l1
            ch(i,k,1) = cc(i,1,k)
  110    continue
  111 continue
  112 idl = 2-ido
      inc = 0
      do 116 l=2,ipph
         lc = ipp2-l
         idl = idl+ido
         do 113 ik=1,idl1
            c2(ik,l) = ch2(ik,1)+wa(idl-1)*ch2(ik,2)
            c2(ik,lc) = -wa(idl)*ch2(ik,ip)
  113    continue
         idlj = idl
         inc = inc+ido
         do 115 j=3,ipph
            jc = ipp2-j
            idlj = idlj+inc
            if (idlj .gt. idp) idlj = idlj-idp
            war = wa(idlj-1)
            wai = wa(idlj)
            do 114 ik=1,idl1
               c2(ik,l) = c2(ik,l)+war*ch2(ik,j)
               c2(ik,lc) = c2(ik,lc)-wai*ch2(ik,jc)
  114       continue
  115    continue
  116 continue
      do 118 j=2,ipph
         do 117 ik=1,idl1
            ch2(ik,1) = ch2(ik,1)+ch2(ik,j)
  117    continue
  118 continue
      do 120 j=2,ipph
         jc = ipp2-j
         do 119 ik=2,idl1,2
            ch2(ik-1,j) = c2(ik-1,j)-c2(ik,jc)
            ch2(ik-1,jc) = c2(ik-1,j)+c2(ik,jc)
            ch2(ik,j) = c2(ik,j)+c2(ik-1,jc)
            ch2(ik,jc) = c2(ik,j)-c2(ik-1,jc)
  119    continue
  120 continue
      nac = 1
      if (ido .eq. 2) return
      nac = 0
      do 121 ik=1,idl1
         c2(ik,1) = ch2(ik,1)
  121 continue
      do 123 j=2,ip
         do 122 k=1,l1
            c1(1,k,j) = ch(1,k,j)
            c1(2,k,j) = ch(2,k,j)
  122    continue
  123 continue
      if (idot .gt. l1) go to 127
      idij = 0
      do 126 j=2,ip
         idij = idij+2
         do 125 i=4,ido,2
            idij = idij+2
            do 124 k=1,l1
               c1(i-1,k,j) = wa(idij-1)*ch(i-1,k,j)+wa(idij)*ch(i,k,j)
               c1(i,k,j) = wa(idij-1)*ch(i,k,j)-wa(idij)*ch(i-1,k,j)
  124       continue
  125    continue
  126 continue
      return
  127 idj = 2-ido
      do 130 j=2,ip
         idj = idj+ido
         do 129 k=1,l1
            idij = idj
            do 128 i=4,ido,2
               idij = idij+2
               c1(i-1,k,j) = wa(idij-1)*ch(i-1,k,j)+wa(idij)*ch(i,k,j)
               c1(i,k,j) = wa(idij-1)*ch(i,k,j)-wa(idij)*ch(i-1,k,j)
  128       continue
  129    continue
  130 continue
      return
      end

      subroutine passf2 (ido,l1,cc,ch,wa1)
      dimension       cc(ido,2,l1)           ,ch(ido,l1,2)           ,
     1                wa1(*)
      if (ido .gt. 2) go to 102
      do 101 k=1,l1
         ch(1,k,1) = cc(1,1,k)+cc(1,2,k)
         ch(1,k,2) = cc(1,1,k)-cc(1,2,k)
         ch(2,k,1) = cc(2,1,k)+cc(2,2,k)
         ch(2,k,2) = cc(2,1,k)-cc(2,2,k)
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            ch(i-1,k,1) = cc(i-1,1,k)+cc(i-1,2,k)
            tr2 = cc(i-1,1,k)-cc(i-1,2,k)
            ch(i,k,1) = cc(i,1,k)+cc(i,2,k)
            ti2 = cc(i,1,k)-cc(i,2,k)
            ch(i,k,2) = wa1(i-1)*ti2-wa1(i)*tr2
            ch(i-1,k,2) = wa1(i-1)*tr2+wa1(i)*ti2
  103    continue
  104 continue
      return
      end

      subroutine passf3 (ido,l1,cc,ch,wa1,wa2)
      dimension       cc(ido,3,l1)           ,ch(ido,l1,3)           ,
     1                wa1(*)     ,wa2(*)
      data taur,taui /-.5,-.866025403784439/
      if (ido .ne. 2) go to 102
      do 101 k=1,l1
         tr2 = cc(1,2,k)+cc(1,3,k)
         cr2 = cc(1,1,k)+taur*tr2
         ch(1,k,1) = cc(1,1,k)+tr2
         ti2 = cc(2,2,k)+cc(2,3,k)
         ci2 = cc(2,1,k)+taur*ti2
         ch(2,k,1) = cc(2,1,k)+ti2
         cr3 = taui*(cc(1,2,k)-cc(1,3,k))
         ci3 = taui*(cc(2,2,k)-cc(2,3,k))
         ch(1,k,2) = cr2-ci3
         ch(1,k,3) = cr2+ci3
         ch(2,k,2) = ci2+cr3
         ch(2,k,3) = ci2-cr3
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            tr2 = cc(i-1,2,k)+cc(i-1,3,k)
            cr2 = cc(i-1,1,k)+taur*tr2
            ch(i-1,k,1) = cc(i-1,1,k)+tr2
            ti2 = cc(i,2,k)+cc(i,3,k)
            ci2 = cc(i,1,k)+taur*ti2
            ch(i,k,1) = cc(i,1,k)+ti2
            cr3 = taui*(cc(i-1,2,k)-cc(i-1,3,k))
            ci3 = taui*(cc(i,2,k)-cc(i,3,k))
            dr2 = cr2-ci3
            dr3 = cr2+ci3
            di2 = ci2+cr3
            di3 = ci2-cr3
            ch(i,k,2) = wa1(i-1)*di2-wa1(i)*dr2
            ch(i-1,k,2) = wa1(i-1)*dr2+wa1(i)*di2
            ch(i,k,3) = wa2(i-1)*di3-wa2(i)*dr3
            ch(i-1,k,3) = wa2(i-1)*dr3+wa2(i)*di3
  103    continue
  104 continue
      return
      end

      subroutine passf4 (ido,l1,cc,ch,wa1,wa2,wa3)
      dimension       cc(ido,4,l1)           ,ch(ido,l1,4)           ,
     1                wa1(*)     ,wa2(*)     ,wa3(*)
      if (ido .ne. 2) go to 102
      do 101 k=1,l1
         ti1 = cc(2,1,k)-cc(2,3,k)
         ti2 = cc(2,1,k)+cc(2,3,k)
         tr4 = cc(2,2,k)-cc(2,4,k)
         ti3 = cc(2,2,k)+cc(2,4,k)
         tr1 = cc(1,1,k)-cc(1,3,k)
         tr2 = cc(1,1,k)+cc(1,3,k)
         ti4 = cc(1,4,k)-cc(1,2,k)
         tr3 = cc(1,2,k)+cc(1,4,k)
         ch(1,k,1) = tr2+tr3
         ch(1,k,3) = tr2-tr3
         ch(2,k,1) = ti2+ti3
         ch(2,k,3) = ti2-ti3
         ch(1,k,2) = tr1+tr4
         ch(1,k,4) = tr1-tr4
         ch(2,k,2) = ti1+ti4
         ch(2,k,4) = ti1-ti4
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            ti1 = cc(i,1,k)-cc(i,3,k)
            ti2 = cc(i,1,k)+cc(i,3,k)
            ti3 = cc(i,2,k)+cc(i,4,k)
            tr4 = cc(i,2,k)-cc(i,4,k)
            tr1 = cc(i-1,1,k)-cc(i-1,3,k)
            tr2 = cc(i-1,1,k)+cc(i-1,3,k)
            ti4 = cc(i-1,4,k)-cc(i-1,2,k)
            tr3 = cc(i-1,2,k)+cc(i-1,4,k)
            ch(i-1,k,1) = tr2+tr3
            cr3 = tr2-tr3
            ch(i,k,1) = ti2+ti3
            ci3 = ti2-ti3
            cr2 = tr1+tr4
            cr4 = tr1-tr4
            ci2 = ti1+ti4
            ci4 = ti1-ti4
            ch(i-1,k,2) = wa1(i-1)*cr2+wa1(i)*ci2
            ch(i,k,2) = wa1(i-1)*ci2-wa1(i)*cr2
            ch(i-1,k,3) = wa2(i-1)*cr3+wa2(i)*ci3
            ch(i,k,3) = wa2(i-1)*ci3-wa2(i)*cr3
            ch(i-1,k,4) = wa3(i-1)*cr4+wa3(i)*ci4
            ch(i,k,4) = wa3(i-1)*ci4-wa3(i)*cr4
  103    continue
  104 continue
      return
      end

      subroutine passf5 (ido,l1,cc,ch,wa1,wa2,wa3,wa4)
      dimension       cc(ido,5,l1)           ,ch(ido,l1,5)           ,
     1                wa1(*)     ,wa2(*)     ,wa3(*)     ,wa4(*)
      data tr11,ti11,tr12,ti12 /.309016994374947,-.951056516295154,
     1-.809016994374947,-.587785252292473/
      if (ido .ne. 2) go to 102
      do 101 k=1,l1
         ti5 = cc(2,2,k)-cc(2,5,k)
         ti2 = cc(2,2,k)+cc(2,5,k)
         ti4 = cc(2,3,k)-cc(2,4,k)
         ti3 = cc(2,3,k)+cc(2,4,k)
         tr5 = cc(1,2,k)-cc(1,5,k)
         tr2 = cc(1,2,k)+cc(1,5,k)
         tr4 = cc(1,3,k)-cc(1,4,k)
         tr3 = cc(1,3,k)+cc(1,4,k)
         ch(1,k,1) = cc(1,1,k)+tr2+tr3
         ch(2,k,1) = cc(2,1,k)+ti2+ti3
         cr2 = cc(1,1,k)+tr11*tr2+tr12*tr3
         ci2 = cc(2,1,k)+tr11*ti2+tr12*ti3
         cr3 = cc(1,1,k)+tr12*tr2+tr11*tr3
         ci3 = cc(2,1,k)+tr12*ti2+tr11*ti3
         cr5 = ti11*tr5+ti12*tr4
         ci5 = ti11*ti5+ti12*ti4
         cr4 = ti12*tr5-ti11*tr4
         ci4 = ti12*ti5-ti11*ti4
         ch(1,k,2) = cr2-ci5
         ch(1,k,5) = cr2+ci5
         ch(2,k,2) = ci2+cr5
         ch(2,k,3) = ci3+cr4
         ch(1,k,3) = cr3-ci4
         ch(1,k,4) = cr3+ci4
         ch(2,k,4) = ci3-cr4
         ch(2,k,5) = ci2-cr5
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            ti5 = cc(i,2,k)-cc(i,5,k)
            ti2 = cc(i,2,k)+cc(i,5,k)
            ti4 = cc(i,3,k)-cc(i,4,k)
            ti3 = cc(i,3,k)+cc(i,4,k)
            tr5 = cc(i-1,2,k)-cc(i-1,5,k)
            tr2 = cc(i-1,2,k)+cc(i-1,5,k)
            tr4 = cc(i-1,3,k)-cc(i-1,4,k)
            tr3 = cc(i-1,3,k)+cc(i-1,4,k)
            ch(i-1,k,1) = cc(i-1,1,k)+tr2+tr3
            ch(i,k,1) = cc(i,1,k)+ti2+ti3
            cr2 = cc(i-1,1,k)+tr11*tr2+tr12*tr3
            ci2 = cc(i,1,k)+tr11*ti2+tr12*ti3
            cr3 = cc(i-1,1,k)+tr12*tr2+tr11*tr3
            ci3 = cc(i,1,k)+tr12*ti2+tr11*ti3
            cr5 = ti11*tr5+ti12*tr4
            ci5 = ti11*ti5+ti12*ti4
            cr4 = ti12*tr5-ti11*tr4
            ci4 = ti12*ti5-ti11*ti4
            dr3 = cr3-ci4
            dr4 = cr3+ci4
            di3 = ci3+cr4
            di4 = ci3-cr4
            dr5 = cr2+ci5
            dr2 = cr2-ci5
            di5 = ci2-cr5
            di2 = ci2+cr5
            ch(i-1,k,2) = wa1(i-1)*dr2+wa1(i)*di2
            ch(i,k,2) = wa1(i-1)*di2-wa1(i)*dr2
            ch(i-1,k,3) = wa2(i-1)*dr3+wa2(i)*di3
            ch(i,k,3) = wa2(i-1)*di3-wa2(i)*dr3
            ch(i-1,k,4) = wa3(i-1)*dr4+wa3(i)*di4
            ch(i,k,4) = wa3(i-1)*di4-wa3(i)*dr4
            ch(i-1,k,5) = wa4(i-1)*dr5+wa4(i)*di5
            ch(i,k,5) = wa4(i-1)*di5-wa4(i)*dr5
  103    continue
  104 continue
      return
      end

      subroutine passb (nac,ido,ip,l1,idl1,cc,c1,c2,ch,ch2,wa)
      dimension       ch(ido,l1,ip)          ,cc(ido,ip,l1)          ,
     1                c1(ido,l1,ip)          ,wa(*)      ,c2(idl1,ip),
     2                ch2(idl1,ip)
      idot = ido/2
      nt = ip*idl1
      ipp2 = ip+2
      ipph = (ip+1)/2
      idp = ip*ido
c
      if (ido .lt. l1) go to 106
      do 103 j=2,ipph
         jc = ipp2-j
         do 102 k=1,l1
            do 101 i=1,ido
               ch(i,k,j) = cc(i,j,k)+cc(i,jc,k)
               ch(i,k,jc) = cc(i,j,k)-cc(i,jc,k)
  101       continue
  102    continue
  103 continue
      do 105 k=1,l1
         do 104 i=1,ido
            ch(i,k,1) = cc(i,1,k)
  104    continue
  105 continue
      go to 112
  106 do 109 j=2,ipph
         jc = ipp2-j
         do 108 i=1,ido
            do 107 k=1,l1
               ch(i,k,j) = cc(i,j,k)+cc(i,jc,k)
               ch(i,k,jc) = cc(i,j,k)-cc(i,jc,k)
  107       continue
  108    continue
  109 continue
      do 111 i=1,ido
         do 110 k=1,l1
            ch(i,k,1) = cc(i,1,k)
  110    continue
  111 continue
  112 idl = 2-ido
      inc = 0
      do 116 l=2,ipph
         lc = ipp2-l
         idl = idl+ido
         do 113 ik=1,idl1
            c2(ik,l) = ch2(ik,1)+wa(idl-1)*ch2(ik,2)
            c2(ik,lc) = wa(idl)*ch2(ik,ip)
  113    continue
         idlj = idl
         inc = inc+ido
         do 115 j=3,ipph
            jc = ipp2-j
            idlj = idlj+inc
            if (idlj .gt. idp) idlj = idlj-idp
            war = wa(idlj-1)
            wai = wa(idlj)
            do 114 ik=1,idl1
               c2(ik,l) = c2(ik,l)+war*ch2(ik,j)
               c2(ik,lc) = c2(ik,lc)+wai*ch2(ik,jc)
  114       continue
  115    continue
  116 continue
      do 118 j=2,ipph
         do 117 ik=1,idl1
            ch2(ik,1) = ch2(ik,1)+ch2(ik,j)
  117    continue
  118 continue
      do 120 j=2,ipph
         jc = ipp2-j
         do 119 ik=2,idl1,2
            ch2(ik-1,j) = c2(ik-1,j)-c2(ik,jc)
            ch2(ik-1,jc) = c2(ik-1,j)+c2(ik,jc)
            ch2(ik,j) = c2(ik,j)+c2(ik-1,jc)
            ch2(ik,jc) = c2(ik,j)-c2(ik-1,jc)
  119    continue
  120 continue
      nac = 1
      if (ido .eq. 2) return
      nac = 0
      do 121 ik=1,idl1
         c2(ik,1) = ch2(ik,1)
  121 continue
      do 123 j=2,ip
         do 122 k=1,l1
            c1(1,k,j) = ch(1,k,j)
            c1(2,k,j) = ch(2,k,j)
  122    continue
  123 continue
      if (idot .gt. l1) go to 127
      idij = 0
      do 126 j=2,ip
         idij = idij+2
         do 125 i=4,ido,2
            idij = idij+2
            do 124 k=1,l1
               c1(i-1,k,j) = wa(idij-1)*ch(i-1,k,j)-wa(idij)*ch(i,k,j)
               c1(i,k,j) = wa(idij-1)*ch(i,k,j)+wa(idij)*ch(i-1,k,j)
  124       continue
  125    continue
  126 continue
      return
  127 idj = 2-ido
      do 130 j=2,ip
         idj = idj+ido
         do 129 k=1,l1
            idij = idj
            do 128 i=4,ido,2
               idij = idij+2
               c1(i-1,k,j) = wa(idij-1)*ch(i-1,k,j)-wa(idij)*ch(i,k,j)
               c1(i,k,j) = wa(idij-1)*ch(i,k,j)+wa(idij)*ch(i-1,k,j)
  128       continue
  129    continue
  130 continue
      return
      end

      subroutine passb2 (ido,l1,cc,ch,wa1)
      dimension       cc(ido,2,l1)           ,ch(ido,l1,2)           ,
     1                wa1(*)
      if (ido .gt. 2) go to 102
      do 101 k=1,l1
         ch(1,k,1) = cc(1,1,k)+cc(1,2,k)
         ch(1,k,2) = cc(1,1,k)-cc(1,2,k)
         ch(2,k,1) = cc(2,1,k)+cc(2,2,k)
         ch(2,k,2) = cc(2,1,k)-cc(2,2,k)
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            ch(i-1,k,1) = cc(i-1,1,k)+cc(i-1,2,k)
            tr2 = cc(i-1,1,k)-cc(i-1,2,k)
            ch(i,k,1) = cc(i,1,k)+cc(i,2,k)
            ti2 = cc(i,1,k)-cc(i,2,k)
            ch(i,k,2) = wa1(i-1)*ti2+wa1(i)*tr2
            ch(i-1,k,2) = wa1(i-1)*tr2-wa1(i)*ti2
  103    continue
  104 continue
      return
      end

      subroutine passb3 (ido,l1,cc,ch,wa1,wa2)
      dimension       cc(ido,3,l1)           ,ch(ido,l1,3)           ,
     1                wa1(*)     ,wa2(*)
      data taur,taui /-.5,.866025403784439/
      if (ido .ne. 2) go to 102
      do 101 k=1,l1
         tr2 = cc(1,2,k)+cc(1,3,k)
         cr2 = cc(1,1,k)+taur*tr2
         ch(1,k,1) = cc(1,1,k)+tr2
         ti2 = cc(2,2,k)+cc(2,3,k)
         ci2 = cc(2,1,k)+taur*ti2
         ch(2,k,1) = cc(2,1,k)+ti2
         cr3 = taui*(cc(1,2,k)-cc(1,3,k))
         ci3 = taui*(cc(2,2,k)-cc(2,3,k))
         ch(1,k,2) = cr2-ci3
         ch(1,k,3) = cr2+ci3
         ch(2,k,2) = ci2+cr3
         ch(2,k,3) = ci2-cr3
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            tr2 = cc(i-1,2,k)+cc(i-1,3,k)
            cr2 = cc(i-1,1,k)+taur*tr2
            ch(i-1,k,1) = cc(i-1,1,k)+tr2
            ti2 = cc(i,2,k)+cc(i,3,k)
            ci2 = cc(i,1,k)+taur*ti2
            ch(i,k,1) = cc(i,1,k)+ti2
            cr3 = taui*(cc(i-1,2,k)-cc(i-1,3,k))
            ci3 = taui*(cc(i,2,k)-cc(i,3,k))
            dr2 = cr2-ci3
            dr3 = cr2+ci3
            di2 = ci2+cr3
            di3 = ci2-cr3
            ch(i,k,2) = wa1(i-1)*di2+wa1(i)*dr2
            ch(i-1,k,2) = wa1(i-1)*dr2-wa1(i)*di2
            ch(i,k,3) = wa2(i-1)*di3+wa2(i)*dr3
            ch(i-1,k,3) = wa2(i-1)*dr3-wa2(i)*di3
  103    continue
  104 continue
      return
      end

      subroutine passb4 (ido,l1,cc,ch,wa1,wa2,wa3)
      dimension       cc(ido,4,l1)           ,ch(ido,l1,4)           ,
     1                wa1(*)     ,wa2(*)     ,wa3(*)
      if (ido .ne. 2) go to 102
      do 101 k=1,l1
         ti1 = cc(2,1,k)-cc(2,3,k)
         ti2 = cc(2,1,k)+cc(2,3,k)
         tr4 = cc(2,4,k)-cc(2,2,k)
         ti3 = cc(2,2,k)+cc(2,4,k)
         tr1 = cc(1,1,k)-cc(1,3,k)
         tr2 = cc(1,1,k)+cc(1,3,k)
         ti4 = cc(1,2,k)-cc(1,4,k)
         tr3 = cc(1,2,k)+cc(1,4,k)
         ch(1,k,1) = tr2+tr3
         ch(1,k,3) = tr2-tr3
         ch(2,k,1) = ti2+ti3
         ch(2,k,3) = ti2-ti3
         ch(1,k,2) = tr1+tr4
         ch(1,k,4) = tr1-tr4
         ch(2,k,2) = ti1+ti4
         ch(2,k,4) = ti1-ti4
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            ti1 = cc(i,1,k)-cc(i,3,k)
            ti2 = cc(i,1,k)+cc(i,3,k)
            ti3 = cc(i,2,k)+cc(i,4,k)
            tr4 = cc(i,4,k)-cc(i,2,k)
            tr1 = cc(i-1,1,k)-cc(i-1,3,k)
            tr2 = cc(i-1,1,k)+cc(i-1,3,k)
            ti4 = cc(i-1,2,k)-cc(i-1,4,k)
            tr3 = cc(i-1,2,k)+cc(i-1,4,k)
            ch(i-1,k,1) = tr2+tr3
            cr3 = tr2-tr3
            ch(i,k,1) = ti2+ti3
            ci3 = ti2-ti3
            cr2 = tr1+tr4
            cr4 = tr1-tr4
            ci2 = ti1+ti4
            ci4 = ti1-ti4
            ch(i-1,k,2) = wa1(i-1)*cr2-wa1(i)*ci2
            ch(i,k,2) = wa1(i-1)*ci2+wa1(i)*cr2
            ch(i-1,k,3) = wa2(i-1)*cr3-wa2(i)*ci3
            ch(i,k,3) = wa2(i-1)*ci3+wa2(i)*cr3
            ch(i-1,k,4) = wa3(i-1)*cr4-wa3(i)*ci4
            ch(i,k,4) = wa3(i-1)*ci4+wa3(i)*cr4
  103    continue
  104 continue
      return
      end

      subroutine passb5 (ido,l1,cc,ch,wa1,wa2,wa3,wa4)
      dimension       cc(ido,5,l1)           ,ch(ido,l1,5)           ,
     1                wa1(*)     ,wa2(*)     ,wa3(*)     ,wa4(*)
      data tr11,ti11,tr12,ti12 /.309016994374947,.951056516295154,
     1-.809016994374947,.587785252292473/
      if (ido .ne. 2) go to 102
      do 101 k=1,l1
         ti5 = cc(2,2,k)-cc(2,5,k)
         ti2 = cc(2,2,k)+cc(2,5,k)
         ti4 = cc(2,3,k)-cc(2,4,k)
         ti3 = cc(2,3,k)+cc(2,4,k)
         tr5 = cc(1,2,k)-cc(1,5,k)
         tr2 = cc(1,2,k)+cc(1,5,k)
         tr4 = cc(1,3,k)-cc(1,4,k)
         tr3 = cc(1,3,k)+cc(1,4,k)
         ch(1,k,1) = cc(1,1,k)+tr2+tr3
         ch(2,k,1) = cc(2,1,k)+ti2+ti3
         cr2 = cc(1,1,k)+tr11*tr2+tr12*tr3
         ci2 = cc(2,1,k)+tr11*ti2+tr12*ti3
         cr3 = cc(1,1,k)+tr12*tr2+tr11*tr3
         ci3 = cc(2,1,k)+tr12*ti2+tr11*ti3
         cr5 = ti11*tr5+ti12*tr4
         ci5 = ti11*ti5+ti12*ti4
         cr4 = ti12*tr5-ti11*tr4
         ci4 = ti12*ti5-ti11*ti4
         ch(1,k,2) = cr2-ci5
         ch(1,k,5) = cr2+ci5
         ch(2,k,2) = ci2+cr5
         ch(2,k,3) = ci3+cr4
         ch(1,k,3) = cr3-ci4
         ch(1,k,4) = cr3+ci4
         ch(2,k,4) = ci3-cr4
         ch(2,k,5) = ci2-cr5
  101 continue
      return
  102 do 104 k=1,l1
         do 103 i=2,ido,2
            ti5 = cc(i,2,k)-cc(i,5,k)
            ti2 = cc(i,2,k)+cc(i,5,k)
            ti4 = cc(i,3,k)-cc(i,4,k)
            ti3 = cc(i,3,k)+cc(i,4,k)
            tr5 = cc(i-1,2,k)-cc(i-1,5,k)
            tr2 = cc(i-1,2,k)+cc(i-1,5,k)
            tr4 = cc(i-1,3,k)-cc(i-1,4,k)
            tr3 = cc(i-1,3,k)+cc(i-1,4,k)
            ch(i-1,k,1) = cc(i-1,1,k)+tr2+tr3
            ch(i,k,1) = cc(i,1,k)+ti2+ti3
            cr2 = cc(i-1,1,k)+tr11*tr2+tr12*tr3
            ci2 = cc(i,1,k)+tr11*ti2+tr12*ti3
            cr3 = cc(i-1,1,k)+tr12*tr2+tr11*tr3
            ci3 = cc(i,1,k)+tr12*ti2+tr11*ti3
            cr5 = ti11*tr5+ti12*tr4
            ci5 = ti11*ti5+ti12*ti4
            cr4 = ti12*tr5-ti11*tr4
            ci4 = ti12*ti5-ti11*ti4
            dr3 = cr3-ci4
            dr4 = cr3+ci4
            di3 = ci3+cr4
            di4 = ci3-cr4
            dr5 = cr2+ci5
            dr2 = cr2-ci5
            di5 = ci2-cr5
            di2 = ci2+cr5
            ch(i-1,k,2) = wa1(i-1)*dr2-wa1(i)*di2
            ch(i,k,2) = wa1(i-1)*di2+wa1(i)*dr2
            ch(i-1,k,3) = wa2(i-1)*dr3-wa2(i)*di3
            ch(i,k,3) = wa2(i-1)*di3+wa2(i)*dr3
            ch(i-1,k,4) = wa3(i-1)*dr4-wa3(i)*di4
            ch(i,k,4) = wa3(i-1)*di4+wa3(i)*dr4
            ch(i-1,k,5) = wa4(i-1)*dr5-wa4(i)*di5
            ch(i,k,5) = wa4(i-1)*di5+wa4(i)*dr5
  103    continue
  104 continue
      return
      end

C--------------------------------------------------------------------------
        subroutine ftp2dd(ounit,group,dim1,nx,ny,array,status)

C       Write a 2-d image of r*8 values into the primary array.
C       Data conversion and scaling will be performed if necessary
C       (e.g, if the datatype of the FITS array is not the same
C       as the array being written).

C       ounit   i  Fortran output unit number
C       group   i  number of the data group, if any
C       dim1    i  actual first dimension of ARRAY
C       nx      i  size of the image in the x direction
C       ny      i  size of the image in the y direction
C       array   d  the array of values to be written
C       status  i  returned error stataus

C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,group,dim1,nx,ny,status
        double precision array(dim1,*)
        integer fpixel,row

        fpixel=1
        do 10 row = 1,ny
                call ftpprd(ounit,group,fpixel,nx,array(1,row),status)
                fpixel=fpixel+nx
10      continue

        end

C----------------------------------------------------------------------
        subroutine ftgclj(iunit,colnum,frow,felem,nelem,eincr,
     &   nultyp,nulval,array,flgval,anynul,status)

C       read an array of integer*4 data values from the specified column of
C       the table.  
C       This general purpose routine will handle null values in one
C       of two ways: if nultyp=1, then undefined array elements will be
C       set equal to the input value of NULVAL.  Else if nultyp=2, then
C       undefined array elements will have the corresponding FLGVAL element
C       set equal to .TRUE.  If NULTYP=1 and NULVAL=0, then no checks for
C       undefined values will be made, for maximum efficiency.

C       iunit   i  fortran unit number
C       colnum  i  number of the column to read from
C       frow    i  first row to read
C       felem   i  first element within the row to read
C       nelem   i  number of elements to read
C       eincr   i  element increment
C       nultyp  i  input code indicating how to handle undefined values
C       nulval  i  value that undefined pixels will be set to (if nultyp=1)
C       array   i  array of data values that are read from the FITS file
C       flgval  l  set .true. if corresponding element undefined (if nultyp=2)
C       anynul  l  set to .true. if any of the returned values are undefined
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,colnum,frow,felem,nelem,eincr,nultyp,status
        integer array(*),nulval
        logical flgval(*),anynul

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
        character cnull*16, cform*8
        common/ft0003/cnull(nf),cform(nf)
        character*1 chbuff(400),xdummy(5360)
        common/ftheap/chbuff,xdummy
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer bufdim
        parameter (bufdim = 100)
        integer buffer(bufdim),bytpix,bstart,tcode,i4null,nulchk,incre
        integer ibuff,i1,ntodo,itodo,repeat,rstart,estart,maxpix,ival
        integer offset,rskip,dstart,begcol,lenrow
        integer*2 i2null
        character*1 i1null
        real rval
        double precision scale,zero,dval,align
        character sval*40,sform*13,snull*16
        character crow*9,cp1*9,cp2*9,ccol*4
        logical tofits,descrp,trans
C       the following equivalence is required for the HP/UX PA-RISC complier
C       to force the buffer to be double word aligned.
        equivalence (align,buffer(1))
        
        if (status .gt. 0)return

C       check for zero length array or bad first row number
        if (nelem .le. 0)return
        if (frow .lt. 1)then
C               error: illegal first row number
                status=307
                write(crow,2000)frow
2000            format(i9)
                call ftpmsg('Starting row number for table read '//
     &          'request is out of range:'//crow//' (FTGCLJ).')
                return
        end if

        descrp=.false.
        i1=1
        ntodo=nelem
        rstart=frow-1
        anynul=.false.
        ibuff=bufnum(iunit)
        dstart=dtstrt(ibuff)
        lenrow=rowlen(ibuff)
        begcol=tbcol(colnum+tstart(ibuff))
        tcode=tdtype(colnum+tstart(ibuff))
        scale=tscale(colnum+tstart(ibuff))
        zero=tzero(colnum+tstart(ibuff))
C       the data are being scaled from FITS to internal format 
        tofits=.false.

C       calculate the maximum number of column pixels which fit in buffer
        bytpix=max(abs(tcode)/10,1)
C       check for important special case: no datatype conversion required
        if (abs(tcode) .eq. 41)then
                maxpix=nelem
        else
                maxpix=bufdim/bytpix*4
        end if

C       determine the repeat count and the first element position
C       incre is the byte offset between consecutive pixels
        incre=bytpix*eincr               
        if (tcode .eq. 16)then
C           this is an ASCII table; each element will be read one at a time
                repeat=1
                estart=0
C               construct the read format, and get the null value string
C               Microsoft Fortran 5.0 bug can't handle:
C               sform='(BN,'//cform(colnum+tstart(ibuff))//')'
                sform='(BN,        )'
                sform(5:12)=cform(colnum+tstart(ibuff))
                snull=cnull(colnum+tstart(ibuff))                
                sval=' '
        else
C           this is a binary table
                if (felem .lt. 1)then
C                       illegal element number
                        status=308
                        write(crow,2000)felem
                call ftpmsg('Starting element number for read '//
     &          'request is out of range:'//crow//' (FTGCLJ).')
                        return
                 end if
                 estart=felem-1

                if (tcode .gt. 0)then
                        repeat=trept(colnum+tstart(ibuff))
                        if (felem .gt. repeat)then
C                               illegal element number
                                status=308
                                write(crow,2000)felem
                call ftpmsg('Starting element number for read '//
     &          'request is out of range:'//crow//' (FTGCLJ).')
                                return
                        end if
                        if (repeat .eq. 1 .and. nelem .gt. 1)then
C                           read multiple rows of data at one time by
C                           fooling it into thinking that this is a vector
C                           column with a large value of bytes per pixel
                                dstart=dstart+rstart*lenrow
                                rstart=0
                                estart=0
                                repeat=maxpix*eincr
                                incre=lenrow*eincr 
                                lenrow=lenrow*repeat
                        end if
                else
C                       this is a variable length descriptor column
                        descrp=.true.
                        tcode=-tcode
C                       read the number of elements and the starting offset:
                        call ftgdes(iunit,colnum,frow,repeat,
     &                              offset,status)
                        if (repeat .eq. 0)then
C                               error: null length vector
                                 status=318
                                return
                        else if (estart+(nelem-1)*eincr+1 .gt. repeat)
     %                      then
C                               error: trying to read beyond end of record
                                status=319
                                return
                        end if
C                       define the starting point of the row
                        dstart=dstart+offset+theap(ibuff)
                        rstart=0
                        begcol=0
                end if
        end if

C       determine if we have to check for null values
        if (nultyp .eq. 1 .and. nulval .eq. 0)then
C               user doesn't want to check for nulls
                nulchk=0
        else
C           user does want to check for null values
C           see if the null value has been defined for this column
            nulchk=0
            if (tcode .eq. 11)then
C               check if byte datatype null value is defined, 
                if (tnull(colnum+tstart(ibuff)).ne.123454321)then
                        i1null=char(tnull(colnum+tstart(ibuff)))
                        nulchk=nultyp
                end if
            else if (tcode .eq. 21)then
C               check if I*2 datatype null value is defined, 
                if (tnull(colnum+tstart(ibuff)).ne.123454321)then
                        i2null=tnull(colnum+tstart(ibuff))
                        nulchk=nultyp
                end if
            else if (tcode .eq. 41)then
C               check if I*4 datatype null value is defined, 
                if (tnull(colnum+tstart(ibuff)).ne.123454321)then
                        i4null=tnull(colnum+tstart(ibuff))
                        nulchk=nultyp
                end if
            else if (tcode .eq. 42 .or. tcode .eq. 82)then
C               have to check floating point data for NaN values
                nulchk=nultyp
            end if
        end if

        if (nulchk .eq. 0 .and. scale .eq. 1. .and. zero .eq. 0.)then
                trans=.false.
        else
                trans=.true.
        end if

C       process as many contiguous pixels as possible, up to buffer size
20      itodo=min(ntodo,(repeat-estart-1)/eincr+1,maxpix)

C       move the i/o pointer to the start of the sequence of pixels
        bstart=dstart+rstart*lenrow+begcol+estart*bytpix
        call ftmbyt(iunit,bstart,.false.,status)

C       read the data from FITS file, doing datatype conversion and scaling
        if (tcode .eq. 21)then
C               column data type is I (I*2)
C               read the data and do any machine dependent data conversion
                call ftgi2b(iunit,itodo,incre,buffer,status)
C               check for null values, and do scaling and datatype conversion
                call fti2i4(buffer,itodo,scale,zero,tofits,
     &          nulchk,i2null,nulval,flgval(i1),anynul,array(i1),status)
        else if (tcode .eq. 41)then
C               column data type is J (I*4)
C               read the data and do any machine dependent data conversion
C               note that we can use the input array directly
                call ftgi4b(iunit,itodo,incre,array(i1),status)
C               check for null values, and do scaling and datatype conversion
                if (trans)then
                  call fti4i4(array(i1),itodo,scale,zero,tofits,nulchk,
     &            i4null,nulval,flgval(i1),anynul,array(i1),status)
                end if
        else if (tcode .eq. 42)then
C               column data type is E (R*4)
C               read the data and do any machine dependent data conversion
                call ftgr4b(iunit,itodo,incre,buffer,status)
C               check for null values, and do scaling and datatype conversion
                call ftr4i4(buffer,itodo,scale,zero,tofits,
     &          nulchk,nulval,flgval(i1),anynul,array(i1),status)
        else if (tcode .eq. 82)then
C               column data type is D (R*8)
C               read the data and do any machine dependent data conversion
                call ftgr8b(iunit,itodo,incre,buffer,status)
C               check for null values, and do scaling and datatype conversion
                call ftr8i4(buffer,itodo,scale,zero,tofits,
     &          nulchk,nulval,flgval(i1),anynul,array(i1),status)
        else if (tcode .eq. 11)then
C               column data type is B (byte)
C               read the data and do any machine dependent data conversion
                call ftgi1b(iunit,itodo,incre,chbuff,status)
C               check for null values, and do scaling and datatype conversion
                call fti1i4(chbuff,itodo,scale,zero,tofits,
     &          nulchk,i1null,nulval,flgval(i1),anynul,array(i1),status)
        else if (tcode .eq. 16 .and. hdutyp(ibuff) .eq. 1)then
C               this is an ASCII table column; get the character string
                call ftgcbf(iunit,1,tnull(colnum+tstart(ibuff)),sval,
     &                      status)
                if (status .gt. 0)return

C               check for null
                if (sval(1:16) .eq. snull)then
                        anynul=.true.
                        if (nultyp .eq. 1)then
                                array(i1)=nulval
                        else
                                flgval(i1)=.true.
                        end if
                        go to 30
                end if
C               now read the value, then do scaling and datatype conversion
                if (sform(5:5) .eq. 'I')then
                        read(sval,sform,err=900)ival
                        call fti4i4(ival,itodo,scale,zero,tofits,
     &              0,i4null,nulval,flgval(i1),anynul,array(i1),status)
                else if (sform(5:5).eq.'F'.or. sform(5:5).eq.'E')then
                        read(sval,sform,err=900)rval
                        call ftr4i4(rval,itodo,scale,zero,tofits,
     &                  0,nulval,flgval(i1),anynul,array(i1),status)
                else if (sform(5:5) .eq. 'D')then
                        read(sval,sform,err=900)dval
                        call ftr8i4(dval,itodo,scale,zero,tofits,
     &                  0,nulval,flgval(i1),anynul,array(i1),status)
                else
C                       error: illegal ASCII table format code
                        status=311
                        write(ccol,2001)colnum
        call ftpmsg('Cannot read integer*4 values from column'//ccol
     &   //' with TFORM = '//cform(colnum+tstart(ibuff))//' (FTGCLJ).')
                        return
                end if
        else
C               error illegal binary table data type code
                status=312
                write(ccol,2001)colnum
        call ftpmsg('Cannot read integer*4 values from column'//ccol
     &   //' with TFORM = '//cform(colnum+tstart(ibuff))//' (FTGCLJ).')
                return
        end if

C       find number of pixels left to do, and quit if none left
30      ntodo=ntodo-itodo

        if (status .gt. 0)then
          if (hdutyp(ibuff) .eq. 0)then
C            this is a primary array or image extension
             write(cp1,2000)felem+i1-1
             write(cp2,2000)felem+i1+itodo-2
             call ftpmsg('Error reading pixels'//cp1//' to'//cp2
     &                 // ' of the FITS image array (FTGCLJ).')
             if (frow .ne. 1)then
                write(cp1,2000)frow
                call ftpmsg('Error while reading group'//cp1//
     &          ' of the multigroup primary array.')
             end if
          else
             write(ccol,2001)colnum
2001         format(i4)
             if (descrp)then
C              this is a variable length descriptor column
               write(crow,2000)frow
               write(cp1,2000)felem+i1-1
               write(cp2,2000)felem+i1+itodo-2
               call ftpmsg('Error reading elements'//cp1//' to'//cp2
     &         //' in row'//crow)
               call ftpmsg(' of variable length vector column'//ccol
     &                    //' (FTGCLJ.')
             else if (trept(colnum+tstart(ibuff)) .eq. 1)then
C              this is not a vector column (simple case)
               write(cp1,2000)frow+i1-1
               write(cp2,2000)frow+i1+itodo-2
               call ftpmsg('Error reading rows'//cp1//' to'//cp2
     &           //' of column'//ccol//' (FTGCLJ).')
             else
C              this is a vector column (more complicated case)
               write(crow,2000)rstart+1
               write(cp1,2000)estart+1
               write(cp2,2000)itodo
               call ftpmsg('Error reading'//cp2//' elements from'
     &         //' column'//ccol)
               call ftpmsg(' starting at row'//crow
     &         //', element'//cp1//' (FTGCLJ).')
             end if
          end if
          return
        end if

        if (ntodo .gt. 0)then
C               increment the pointers
                i1=i1+itodo
                estart=estart+itodo*eincr
                rskip=estart/repeat
                rstart=rstart+rskip
                estart=estart-rskip*repeat
                go to 20
        end if

C       check for any overflows
        if (status .eq. -11)then
               status=412
               call ftpmsg('Numeric overflow error occurred reading '//
     &        'Integer*4 data from FITS file.')
        end if
        return

900     continue
C       error reading formatted data value from ASCII table
        write(ccol,2001)colnum
        write(cp1,2000)rstart+1
        call ftpmsg('Error reading colunm'//ccol//', row'//cp1//
     &  ' of the ASCII Table.')
        call ftpmsg('Tried to read "'//sval(1:20)//
     &              '" with format '//sform//' (FTGCLJ).')
        status=315
        end

C--------------------------------------------------------------------------
        subroutine ftpkne(ounit,keywrd,nstart,nkey,rval,decim,comm,
     &                    status)

C       write an array of real*4 values to header records in E format
C
C       ounit   i  fortran output unit number
C       keywrd  c  keyword name    ( 8 characters, cols.  1- 8)
C       nstart  i  starting sequence number (usually 1)
C       nkey    i  number of keywords to write
C       rval    r  array of keyword values
C       decim   i  number of decimal places to display in the value field
C       comm    c  array of keyword comments (47 characters, cols. 34-80)
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        character*(*) keywrd,comm(*)
        integer nstart,nkey,decim,ounit,status,i,j
        real rval(*)
        character keynam*8,comm1*48
        logical repeat

        if (status .gt. 0)return

C       check if the first comment string is to be repeated for all keywords
C       (if the last non-blank character is '&', then it is to be repeated)
        call ftcrep(comm(1),comm1,repeat)

        j=nstart
        do 10 i=1,nkey
C               construct keyword name:
                call ftkeyn(keywrd,j,keynam,status)

C               write the keyword record
                if (repeat)then
                  call ftpkye(ounit,keynam,rval(i),decim,comm1,status)
                else
                  call ftpkye(ounit,keynam,rval(i),decim,comm(i),status)
                end if
                if (status .gt. 0)return
                j=j+1
10      continue
        end

C----------------------------------------------------------------------
        subroutine ftppne(ounit,group,felem,nelem,array,nulval,status)

C       Write an array of real values into the primary array.
C       Data conversion and scaling will be performed if necessary
C       (e.g, if the datatype of the FITS array is not the same as the
C       array being written).  Any input pixels equal to the value of NULVAL
C       will be replaced by the appropriate null value in the output FITS file.

C       ounit   i  Fortran output unit number
C       group   i  number of the data group, if any
C       felem   i  the first pixel to be written (this routine treats
C                  the primary array a large one dimensional array of
C                  values, regardless of the actual dimensionality).
C       nelem   i  number of data elements to be written
C       array   r  the array of values to be written
C       nulval  r  pixel value used to represent an undefine pixel
C       status  i  returned error stataus

C       written by Wm Pence, HEASARC/GSFC, June 1994

        integer ounit,group,felem,nelem,status,row
        real array(*),nulval

C       the primary array is represented as a binary table:
C               each group of the primary array is a row in the table,
C               where the first column contains the group parameters
C               and the second column contains the image itself
        row=max(group,1)
        call ftpcne(ounit,2,row,felem,nelem,array,nulval,status)
        end
